/*!
    war3-model v3.4.1
	https://github.com/4eb0da/war3-model
	Released under the MIT License.
*/
import { vec3, quat, vec4, mat4, mat3 } from 'gl-matrix';

var TextureFlags;
(function (TextureFlags) {
    TextureFlags[TextureFlags["WrapWidth"] = 1] = "WrapWidth";
    TextureFlags[TextureFlags["WrapHeight"] = 2] = "WrapHeight";
})(TextureFlags || (TextureFlags = {}));
var FilterMode;
(function (FilterMode) {
    FilterMode[FilterMode["None"] = 0] = "None";
    FilterMode[FilterMode["Transparent"] = 1] = "Transparent";
    FilterMode[FilterMode["Blend"] = 2] = "Blend";
    FilterMode[FilterMode["Additive"] = 3] = "Additive";
    FilterMode[FilterMode["AddAlpha"] = 4] = "AddAlpha";
    FilterMode[FilterMode["Modulate"] = 5] = "Modulate";
    FilterMode[FilterMode["Modulate2x"] = 6] = "Modulate2x";
})(FilterMode || (FilterMode = {}));
var LineType;
(function (LineType) {
    LineType[LineType["DontInterp"] = 0] = "DontInterp";
    LineType[LineType["Linear"] = 1] = "Linear";
    LineType[LineType["Hermite"] = 2] = "Hermite";
    LineType[LineType["Bezier"] = 3] = "Bezier";
})(LineType || (LineType = {}));
var LayerShading;
(function (LayerShading) {
    LayerShading[LayerShading["Unshaded"] = 1] = "Unshaded";
    LayerShading[LayerShading["SphereEnvMap"] = 2] = "SphereEnvMap";
    LayerShading[LayerShading["TwoSided"] = 16] = "TwoSided";
    LayerShading[LayerShading["Unfogged"] = 32] = "Unfogged";
    LayerShading[LayerShading["NoDepthTest"] = 64] = "NoDepthTest";
    LayerShading[LayerShading["NoDepthSet"] = 128] = "NoDepthSet";
})(LayerShading || (LayerShading = {}));
var MaterialRenderMode;
(function (MaterialRenderMode) {
    MaterialRenderMode[MaterialRenderMode["ConstantColor"] = 1] = "ConstantColor";
    MaterialRenderMode[MaterialRenderMode["SortPrimsFarZ"] = 16] = "SortPrimsFarZ";
    MaterialRenderMode[MaterialRenderMode["FullResolution"] = 32] = "FullResolution";
})(MaterialRenderMode || (MaterialRenderMode = {}));
var GeosetAnimFlags;
(function (GeosetAnimFlags) {
    GeosetAnimFlags[GeosetAnimFlags["DropShadow"] = 1] = "DropShadow";
    GeosetAnimFlags[GeosetAnimFlags["Color"] = 2] = "Color";
})(GeosetAnimFlags || (GeosetAnimFlags = {}));
var NodeFlags;
(function (NodeFlags) {
    NodeFlags[NodeFlags["DontInheritTranslation"] = 1] = "DontInheritTranslation";
    NodeFlags[NodeFlags["DontInheritRotation"] = 2] = "DontInheritRotation";
    NodeFlags[NodeFlags["DontInheritScaling"] = 4] = "DontInheritScaling";
    NodeFlags[NodeFlags["Billboarded"] = 8] = "Billboarded";
    NodeFlags[NodeFlags["BillboardedLockX"] = 16] = "BillboardedLockX";
    NodeFlags[NodeFlags["BillboardedLockY"] = 32] = "BillboardedLockY";
    NodeFlags[NodeFlags["BillboardedLockZ"] = 64] = "BillboardedLockZ";
    NodeFlags[NodeFlags["CameraAnchored"] = 128] = "CameraAnchored";
})(NodeFlags || (NodeFlags = {}));
var NodeType;
(function (NodeType) {
    NodeType[NodeType["Helper"] = 0] = "Helper";
    NodeType[NodeType["Bone"] = 256] = "Bone";
    NodeType[NodeType["Light"] = 512] = "Light";
    NodeType[NodeType["EventObject"] = 1024] = "EventObject";
    NodeType[NodeType["Attachment"] = 2048] = "Attachment";
    NodeType[NodeType["ParticleEmitter"] = 4096] = "ParticleEmitter";
    NodeType[NodeType["CollisionShape"] = 8192] = "CollisionShape";
    NodeType[NodeType["RibbonEmitter"] = 16384] = "RibbonEmitter";
})(NodeType || (NodeType = {}));
var CollisionShapeType;
(function (CollisionShapeType) {
    CollisionShapeType[CollisionShapeType["Box"] = 0] = "Box";
    CollisionShapeType[CollisionShapeType["Sphere"] = 2] = "Sphere";
})(CollisionShapeType || (CollisionShapeType = {}));
var ParticleEmitterFlags;
(function (ParticleEmitterFlags) {
    ParticleEmitterFlags[ParticleEmitterFlags["EmitterUsesMDL"] = 32768] = "EmitterUsesMDL";
    ParticleEmitterFlags[ParticleEmitterFlags["EmitterUsesTGA"] = 65536] = "EmitterUsesTGA";
})(ParticleEmitterFlags || (ParticleEmitterFlags = {}));
var ParticleEmitter2Flags;
(function (ParticleEmitter2Flags) {
    ParticleEmitter2Flags[ParticleEmitter2Flags["Unshaded"] = 32768] = "Unshaded";
    ParticleEmitter2Flags[ParticleEmitter2Flags["SortPrimsFarZ"] = 65536] = "SortPrimsFarZ";
    ParticleEmitter2Flags[ParticleEmitter2Flags["LineEmitter"] = 131072] = "LineEmitter";
    ParticleEmitter2Flags[ParticleEmitter2Flags["Unfogged"] = 262144] = "Unfogged";
    ParticleEmitter2Flags[ParticleEmitter2Flags["ModelSpace"] = 524288] = "ModelSpace";
    ParticleEmitter2Flags[ParticleEmitter2Flags["XYQuad"] = 1048576] = "XYQuad";
})(ParticleEmitter2Flags || (ParticleEmitter2Flags = {}));
var ParticleEmitter2FilterMode;
(function (ParticleEmitter2FilterMode) {
    ParticleEmitter2FilterMode[ParticleEmitter2FilterMode["Blend"] = 0] = "Blend";
    ParticleEmitter2FilterMode[ParticleEmitter2FilterMode["Additive"] = 1] = "Additive";
    ParticleEmitter2FilterMode[ParticleEmitter2FilterMode["Modulate"] = 2] = "Modulate";
    ParticleEmitter2FilterMode[ParticleEmitter2FilterMode["Modulate2x"] = 3] = "Modulate2x";
    ParticleEmitter2FilterMode[ParticleEmitter2FilterMode["AlphaKey"] = 4] = "AlphaKey";
})(ParticleEmitter2FilterMode || (ParticleEmitter2FilterMode = {}));
// Not actually mapped to mdx flags (0: Head, 1: Tail, 2: Both)
var ParticleEmitter2FramesFlags;
(function (ParticleEmitter2FramesFlags) {
    ParticleEmitter2FramesFlags[ParticleEmitter2FramesFlags["Head"] = 1] = "Head";
    ParticleEmitter2FramesFlags[ParticleEmitter2FramesFlags["Tail"] = 2] = "Tail";
})(ParticleEmitter2FramesFlags || (ParticleEmitter2FramesFlags = {}));
var LightType;
(function (LightType) {
    LightType[LightType["Omnidirectional"] = 0] = "Omnidirectional";
    LightType[LightType["Directional"] = 1] = "Directional";
    LightType[LightType["Ambient"] = 2] = "Ambient";
})(LightType || (LightType = {}));
/* Since Version: 900 */
var ParticleEmitterPopcornFlags;
(function (ParticleEmitterPopcornFlags) {
    ParticleEmitterPopcornFlags[ParticleEmitterPopcornFlags["Unshaded"] = 32768] = "Unshaded";
    ParticleEmitterPopcornFlags[ParticleEmitterPopcornFlags["SortPrimsFarZ"] = 65536] = "SortPrimsFarZ";
    ParticleEmitterPopcornFlags[ParticleEmitterPopcornFlags["Unfogged"] = 262144] = "Unfogged";
})(ParticleEmitterPopcornFlags || (ParticleEmitterPopcornFlags = {}));

var model = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get TextureFlags () { return TextureFlags; },
    get FilterMode () { return FilterMode; },
    get LineType () { return LineType; },
    get LayerShading () { return LayerShading; },
    get MaterialRenderMode () { return MaterialRenderMode; },
    get GeosetAnimFlags () { return GeosetAnimFlags; },
    get NodeFlags () { return NodeFlags; },
    get NodeType () { return NodeType; },
    get CollisionShapeType () { return CollisionShapeType; },
    get ParticleEmitterFlags () { return ParticleEmitterFlags; },
    get ParticleEmitter2Flags () { return ParticleEmitter2Flags; },
    get ParticleEmitter2FilterMode () { return ParticleEmitter2FilterMode; },
    get ParticleEmitter2FramesFlags () { return ParticleEmitter2FramesFlags; },
    get LightType () { return LightType; },
    get ParticleEmitterPopcornFlags () { return ParticleEmitterPopcornFlags; }
});

function mat4fromRotationOrigin(out, rotation, origin) {
    var x = rotation[0], y = rotation[1], z = rotation[2], w = rotation[3], x2 = x + x, y2 = y + y, z2 = z + z, xx = x * x2, xy = x * y2, xz = x * z2, yy = y * y2, yz = y * z2, zz = z * z2, wx = w * x2, wy = w * y2, wz = w * z2, ox = origin[0], oy = origin[1], oz = origin[2];
    out[0] = (1 - (yy + zz));
    out[1] = (xy + wz);
    out[2] = (xz - wy);
    out[3] = 0;
    out[4] = (xy - wz);
    out[5] = (1 - (xx + zz));
    out[6] = (yz + wx);
    out[7] = 0;
    out[8] = (xz + wy);
    out[9] = (yz - wx);
    out[10] = (1 - (xx + yy));
    out[11] = 0;
    out[12] = ox - (out[0] * ox + out[4] * oy + out[8] * oz);
    out[13] = oy - (out[1] * ox + out[5] * oy + out[9] * oz);
    out[14] = oz - (out[2] * ox + out[6] * oy + out[10] * oz);
    out[15] = 1;
    return out;
}
function rand(from, to) {
    return from + Math.random() * (to - from);
}
function degToRad(angle) {
    return angle * Math.PI / 180;
}
function getShader(gl, source, type) {
    var shader = gl.createShader(type);
    gl.shaderSource(shader, source);
    gl.compileShader(shader);
    if (!gl.getShaderParameter(shader, gl.COMPILE_STATUS)) {
        alert(gl.getShaderInfoLog(shader));
        return null;
    }
    return shader;
}
function isWebGL2(gl) {
    return gl instanceof WebGL2RenderingContext;
}
var LAYER_TEXTURE_NAME_MAP = {
    'TextureID': 0,
    'NormalTextureID': 1,
    'ORMTextureID': 2,
    'EmissiveTextureID': 3,
    'TeamColorTextureID': 4,
    'ReflectionsTextureID': 5
};
var LAYER_TEXTURE_ID_MAP = [
    'TextureID',
    'NormalTextureID',
    'ORMTextureID',
    'EmissiveTextureID',
    'TeamColorTextureID',
    'ReflectionsTextureID'
];

var _a$2;
var State$1 = /** @class */ (function () {
    function State(str) {
        this.str = str;
        this.pos = 0;
    }
    State.prototype.char = function () {
        if (this.pos >= this.str.length) {
            throwError(this, 'incorrect model data');
        }
        return this.str[this.pos];
    };
    return State;
}());
function throwError(state, str) {
    if (str === void 0) { str = ''; }
    throw new Error("SyntaxError, near ".concat(state.pos) + (str ? ', ' + str : ''));
}
function parseComment(state) {
    if (state.char() === '/' && state.str[state.pos + 1] === '/') {
        state.pos += 2;
        while (state.pos < state.str.length && state.str[++state.pos] !== '\n')
            ;
        ++state.pos;
        return true;
    }
    return false;
}
var spaceRE = /\s/i;
function parseSpace(state) {
    while (state.pos < state.str.length && spaceRE.test(state.char())) {
        ++state.pos;
    }
}
var keywordFirstCharRE = /[a-z]/i;
var keywordOtherCharRE = /[a-z0-9]/i;
function parseKeyword(state) {
    if (!keywordFirstCharRE.test(state.char())) {
        return null;
    }
    var keyword = state.char();
    ++state.pos;
    while (keywordOtherCharRE.test(state.char())) {
        keyword += state.str[state.pos++];
    }
    parseSpace(state);
    return keyword;
}
function parseSymbol(state, symbol) {
    if (state.char() === symbol) {
        ++state.pos;
        parseSpace(state);
    }
}
function strictParseSymbol(state, symbol) {
    if (state.char() !== symbol) {
        throwError(state, "extected ".concat(symbol));
    }
    ++state.pos;
    parseSpace(state);
}
function parseString(state) {
    if (state.char() === '"') {
        var start = ++state.pos; // "
        while (state.char() !== '"') {
            ++state.pos;
        }
        ++state.pos; // "
        var res = state.str.substring(start, state.pos - 1);
        parseSpace(state);
        return res;
    }
    return null;
}
var numberFirstCharRE = /[-0-9]/;
var numberOtherCharRE = /[-+.0-9e]/i;
function parseNumber(state) {
    if (numberFirstCharRE.test(state.char())) {
        var start = state.pos;
        ++state.pos;
        while (numberOtherCharRE.test(state.char())) {
            ++state.pos;
        }
        var res = parseFloat(state.str.substring(start, state.pos));
        parseSpace(state);
        return res;
    }
    return null;
}
function parseArray(state, arr, pos) {
    if (state.char() !== '{') {
        return null;
    }
    if (!arr) {
        arr = [];
        pos = 0;
    }
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var num = parseNumber(state);
        if (num === null) {
            throwError(state, 'expected number');
        }
        arr[pos++] = num;
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    return arr;
}
function parseArrayCounted(state, arr, pos) {
    if (state.char() !== '{') {
        return 0;
    }
    var start = pos;
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var num = parseNumber(state);
        if (num === null) {
            throwError(state, 'expected number');
        }
        arr[pos++] = num;
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    return pos - start;
}
function parseArrayOrSingleItem(state, arr) {
    if (state.char() !== '{') {
        arr[0] = parseNumber(state);
        return arr;
    }
    var pos = 0;
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var num = parseNumber(state);
        if (num === null) {
            throwError(state, 'expected number');
        }
        arr[pos++] = num;
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    return arr;
}
function parseObject(state) {
    var prefix = null;
    var obj = {};
    if (state.char() !== '{') {
        prefix = parseString(state);
        if (prefix === null) {
            prefix = parseNumber(state);
        }
        if (prefix === null) {
            throwError(state, 'expected string or number');
        }
    }
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'Interval') {
            var array = new Uint32Array(2);
            obj[keyword] = parseArray(state, array, 0);
        }
        else if (keyword === 'MinimumExtent' || keyword === 'MaximumExtent') {
            var array = new Float32Array(3);
            obj[keyword] = parseArray(state, array, 0);
        }
        else {
            obj[keyword] = parseArray(state) || parseString(state);
            if (obj[keyword] === null) {
                obj[keyword] = parseNumber(state);
            }
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    return [prefix, obj];
}
function parseVersion$1(state, model) {
    var _a = parseObject(state); _a[0]; var obj = _a[1];
    if (obj.FormatVersion) {
        model.Version = obj.FormatVersion;
    }
}
function parseModelInfo$1(state, model) {
    var _a = parseObject(state), name = _a[0], obj = _a[1];
    model.Info = obj;
    model.Info.Name = name;
}
function parseSequences$1(state, model) {
    parseNumber(state); // count, not used
    strictParseSymbol(state, '{');
    var res = [];
    while (state.char() !== '}') {
        parseKeyword(state); // Anim
        var _a = parseObject(state), name_1 = _a[0], obj = _a[1];
        obj.Name = name_1;
        obj.NonLooping = 'NonLooping' in obj;
        obj.MoveSpeed = obj.MoveSpeed || 0;
        obj.Rarity = obj.Rarity || 0;
        res.push(obj);
    }
    strictParseSymbol(state, '}');
    model.Sequences = res;
}
function parseTextures$1(state, model) {
    var res = [];
    parseNumber(state); // count, not used
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        parseKeyword(state); // Bitmap
        var _a = parseObject(state); _a[0]; var obj = _a[1];
        obj.Flags = 0;
        if ('WrapWidth' in obj) {
            obj.Flags += TextureFlags.WrapWidth;
            delete obj.WrapWidth;
        }
        if ('WrapHeight' in obj) {
            obj.Flags += TextureFlags.WrapHeight;
            delete obj.WrapHeight;
        }
        res.push(obj);
    }
    strictParseSymbol(state, '}');
    model.Textures = res;
}
var AnimVectorType$2;
(function (AnimVectorType) {
    AnimVectorType[AnimVectorType["INT1"] = 0] = "INT1";
    AnimVectorType[AnimVectorType["FLOAT1"] = 1] = "FLOAT1";
    AnimVectorType[AnimVectorType["FLOAT3"] = 2] = "FLOAT3";
    AnimVectorType[AnimVectorType["FLOAT4"] = 3] = "FLOAT4";
})(AnimVectorType$2 || (AnimVectorType$2 = {}));
var animVectorSize$2 = (_a$2 = {},
    _a$2[AnimVectorType$2.INT1] = 1,
    _a$2[AnimVectorType$2.FLOAT1] = 1,
    _a$2[AnimVectorType$2.FLOAT3] = 3,
    _a$2[AnimVectorType$2.FLOAT4] = 4,
    _a$2);
function parseAnimKeyframe(state, frame, type, lineType) {
    var res = {
        Frame: frame,
        Vector: null
    };
    var Vector = type === AnimVectorType$2.INT1 ? Int32Array : Float32Array;
    var itemCount = animVectorSize$2[type];
    res.Vector = parseArrayOrSingleItem(state, new Vector(itemCount));
    strictParseSymbol(state, ',');
    if (lineType === LineType.Hermite || lineType === LineType.Bezier) {
        parseKeyword(state); // InTan
        res.InTan = parseArrayOrSingleItem(state, new Vector(itemCount));
        strictParseSymbol(state, ',');
        parseKeyword(state); // OutTan
        res.OutTan = parseArrayOrSingleItem(state, new Vector(itemCount));
        strictParseSymbol(state, ',');
    }
    return res;
}
function parseAnimVector(state, type) {
    var animVector = {
        LineType: LineType.DontInterp,
        GlobalSeqId: null,
        Keys: []
    };
    parseNumber(state); // count, not used
    strictParseSymbol(state, '{');
    var lineType = parseKeyword(state);
    if (lineType === 'DontInterp' || lineType === 'Linear' || lineType === 'Hermite' || lineType === 'Bezier') {
        animVector.LineType = LineType[lineType];
    }
    strictParseSymbol(state, ',');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (keyword === 'GlobalSeqId') {
            animVector[keyword] = parseNumber(state);
            strictParseSymbol(state, ',');
        }
        else {
            var frame = parseNumber(state);
            if (frame === null) {
                throwError(state, 'expected frame number or GlobalSeqId');
            }
            strictParseSymbol(state, ':');
            animVector.Keys.push(parseAnimKeyframe(state, frame, type, animVector.LineType));
        }
    }
    strictParseSymbol(state, '}');
    return animVector;
}
function parseLayer(state, model) {
    var res = {
        Alpha: null,
        TVertexAnimId: null,
        Shading: 0,
        CoordId: 0
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (!isStatic && (keyword === 'TextureID' || model.Version >= 1100 && keyword in LAYER_TEXTURE_NAME_MAP)) {
            res[keyword] = parseAnimVector(state, AnimVectorType$2.INT1);
        }
        else if (!isStatic && (keyword === 'Alpha')) {
            res[keyword] = parseAnimVector(state, AnimVectorType$2.FLOAT1);
        }
        else if (keyword === 'Unshaded' || keyword === 'SphereEnvMap' || keyword === 'TwoSided' ||
            keyword === 'Unfogged' || keyword === 'NoDepthTest' || keyword === 'NoDepthSet') {
            res.Shading |= LayerShading[keyword];
        }
        else if (keyword === 'FilterMode') {
            var val = parseKeyword(state);
            if (val === 'None' || val === 'Transparent' || val === 'Blend' || val === 'Additive' ||
                val === 'AddAlpha' || val === 'Modulate' || val === 'Modulate2x') {
                res.FilterMode = FilterMode[val];
            }
        }
        else if (keyword === 'TVertexAnimId') {
            res.TVertexAnimId = parseNumber(state);
        }
        else if (model.Version >= 900 && keyword === 'EmissiveGain') {
            if (isStatic) {
                res[keyword] = parseNumber(state);
            }
            else {
                res[keyword] = parseAnimVector(state, AnimVectorType$2.FLOAT1);
            }
        }
        else if (model.Version >= 1000 && keyword === 'FresnelColor') {
            if (isStatic) {
                var array = new Float32Array(3);
                res[keyword] = parseArray(state, array, 0);
            }
            else {
                res[keyword] = parseAnimVector(state, AnimVectorType$2.FLOAT3);
            }
        }
        else if (model.Version >= 1000 && (keyword === 'FresnelOpacity' || keyword === 'FresnelTeamColor')) {
            if (isStatic) {
                res[keyword] = parseNumber(state);
            }
            else {
                res[keyword] = parseAnimVector(state, AnimVectorType$2.FLOAT1);
            }
        }
        else {
            var val = parseNumber(state);
            if (val === null) {
                val = parseKeyword(state);
            }
            res[keyword] = val;
        }
        parseSymbol(state, ',');
        parseComment(state);
        parseSpace(state);
    }
    strictParseSymbol(state, '}');
    return res;
}
function parseMaterials$1(state, model) {
    var res = [];
    parseNumber(state); // count, not used
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var obj = {
            RenderMode: 0,
            Layers: []
        };
        parseKeyword(state); // Material
        strictParseSymbol(state, '{');
        while (state.char() !== '}') {
            var keyword = parseKeyword(state);
            if (!keyword) {
                throwError(state);
            }
            if (keyword === 'Layer') {
                obj.Layers.push(parseLayer(state, model));
            }
            else if (keyword === 'PriorityPlane' || keyword === 'RenderMode') {
                obj[keyword] = parseNumber(state);
            }
            else if (keyword === 'ConstantColor' || keyword === 'SortPrimsFarZ' || keyword === 'FullResolution') {
                obj.RenderMode |= MaterialRenderMode[keyword];
            }
            else if (model.Version >= 900 && model.Version <= 1100 && keyword === 'Shader') {
                obj[keyword] = parseString(state);
            }
            else {
                throw new Error('Unknown material property ' + keyword);
            }
            parseSymbol(state, ',');
        }
        strictParseSymbol(state, '}');
        res.push(obj);
    }
    strictParseSymbol(state, '}');
    model.Materials = res;
}
var GeosetPartType;
(function (GeosetPartType) {
    GeosetPartType[GeosetPartType["INT"] = 0] = "INT";
    GeosetPartType[GeosetPartType["FLOAT"] = 1] = "FLOAT";
})(GeosetPartType || (GeosetPartType = {}));
function parseGeosetPart(state, countPerObj, type) {
    var count = parseNumber(state);
    var arr = new (type === GeosetPartType.FLOAT ? Float32Array : Uint8Array)(count * countPerObj);
    strictParseSymbol(state, '{');
    for (var index = 0; index < count; ++index) {
        parseArray(state, arr, index * countPerObj);
        strictParseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    return arr;
}
function parseGeoset(state, model) {
    var res = {
        Vertices: null,
        Normals: null,
        TVertices: [],
        VertexGroup: new Uint8Array(0),
        Faces: null,
        Groups: null,
        TotalGroupsCount: null,
        MinimumExtent: null,
        MaximumExtent: null,
        BoundsRadius: 0,
        Anims: [],
        MaterialID: null,
        SelectionGroup: null,
        Unselectable: false
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'Vertices' || keyword === 'Normals' || keyword === 'TVertices') {
            var countPerObj = 3;
            if (keyword === 'TVertices') {
                countPerObj = 2;
            }
            var arr = parseGeosetPart(state, countPerObj, GeosetPartType.FLOAT);
            if (keyword === 'TVertices') {
                res.TVertices.push(arr);
            }
            else {
                res[keyword] = arr;
            }
        }
        else if (keyword === 'VertexGroup') {
            res[keyword] = new Uint8Array(res.Vertices.length / 3);
            parseArray(state, res[keyword], 0);
        }
        else if (keyword === 'Faces') {
            var groupCount = parseNumber(state); // group count, always 1 in the official models
            var indexCount = parseNumber(state);
            var pos = 0;
            res.Faces = new Uint16Array(indexCount);
            strictParseSymbol(state, '{');
            var keyword_1 = parseKeyword(state);
            if (keyword_1 !== 'Triangles') {
                throwError(state, 'unexpected faces type');
            }
            strictParseSymbol(state, '{');
            for (var g = 0; g < groupCount; ++g) {
                var count = parseArrayCounted(state, res.Faces, pos);
                if (!count) {
                    throwError(state, 'expected array');
                }
                pos += count;
                parseSymbol(state, ',');
            }
            if (pos !== indexCount || indexCount % 3 !== 0) {
                throwError(state, 'mismatched faces array');
            }
            strictParseSymbol(state, '}');
            strictParseSymbol(state, '}');
        }
        else if (keyword === 'Groups') {
            var groups = [];
            parseNumber(state); // groups count, unused
            res.TotalGroupsCount = parseNumber(state); // summed in subarrays
            strictParseSymbol(state, '{');
            while (state.char() !== '}') {
                parseKeyword(state); // Matrices
                groups.push(parseArray(state));
                parseSymbol(state, ',');
            }
            strictParseSymbol(state, '}');
            res.Groups = groups;
        }
        else if (keyword === 'MinimumExtent' || keyword === 'MaximumExtent') {
            var arr = new Float32Array(3);
            res[keyword] = parseArray(state, arr, 0);
            strictParseSymbol(state, ',');
        }
        else if (keyword === 'BoundsRadius' || keyword === 'MaterialID' || keyword === 'SelectionGroup') {
            res[keyword] = parseNumber(state);
            strictParseSymbol(state, ',');
        }
        else if (keyword === 'Anim') {
            var _a = parseObject(state); _a[0]; var obj = _a[1];
            if (obj.Alpha === undefined) {
                obj.Alpha = 1;
            }
            res.Anims.push(obj);
        }
        else if (keyword === 'Unselectable') {
            res.Unselectable = true;
            strictParseSymbol(state, ',');
        }
        else if (model.Version >= 900) {
            if (keyword === 'LevelOfDetail') {
                res.LevelOfDetail = parseNumber(state);
                strictParseSymbol(state, ',');
            }
            else if (keyword === 'Name') {
                res.Name = parseString(state);
                strictParseSymbol(state, ',');
            }
            else if (keyword === 'Tangents') {
                res.Tangents = parseGeosetPart(state, 4, GeosetPartType.FLOAT);
            }
            else if (keyword === 'SkinWeights') {
                res.SkinWeights = parseGeosetPart(state, 8, GeosetPartType.INT);
            }
        }
    }
    strictParseSymbol(state, '}');
    model.Geosets.push(res);
}
function parseGeosetAnim(state, model) {
    var res = {
        GeosetId: -1,
        Alpha: 1,
        Color: null,
        Flags: 0
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (keyword === 'Alpha') {
            if (isStatic) {
                res.Alpha = parseNumber(state);
            }
            else {
                res.Alpha = parseAnimVector(state, AnimVectorType$2.FLOAT1);
            }
        }
        else if (keyword === 'Color') {
            if (isStatic) {
                var array = new Float32Array(3);
                res.Color = parseArray(state, array, 0);
                res.Color.reverse();
            }
            else {
                res.Color = parseAnimVector(state, AnimVectorType$2.FLOAT3);
                for (var _i = 0, _a = res.Color.Keys; _i < _a.length; _i++) {
                    var key = _a[_i];
                    key.Vector.reverse();
                    if (key.InTan) {
                        key.InTan.reverse();
                        key.OutTan.reverse();
                    }
                }
            }
        }
        else if (keyword === 'DropShadow') {
            res.Flags |= GeosetAnimFlags[keyword];
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.GeosetAnims.push(res);
}
function parseNode$1(state, type, model) {
    var name = parseString(state);
    var node = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        Flags: NodeType[type]
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'Translation' || keyword === 'Rotation' || keyword === 'Scaling' || keyword === 'Visibility') {
            var vectorType = AnimVectorType$2.FLOAT3;
            if (keyword === 'Rotation') {
                vectorType = AnimVectorType$2.FLOAT4;
            }
            else if (keyword === 'Visibility') {
                vectorType = AnimVectorType$2.FLOAT1;
            }
            node[keyword] = parseAnimVector(state, vectorType);
        }
        else if (keyword === 'BillboardedLockZ' || keyword === 'BillboardedLockY' || keyword === 'BillboardedLockX' ||
            keyword === 'Billboarded' || keyword === 'CameraAnchored') {
            node.Flags |= NodeFlags[keyword];
        }
        else if (keyword === 'DontInherit') {
            strictParseSymbol(state, '{');
            var val = parseKeyword(state);
            if (val === 'Translation') {
                node.Flags |= NodeFlags.DontInheritTranslation;
            }
            else if (val === 'Rotation') {
                node.Flags |= NodeFlags.DontInheritRotation;
            }
            else if (val === 'Scaling') {
                node.Flags |= NodeFlags.DontInheritScaling;
            }
            strictParseSymbol(state, '}');
        }
        else if (keyword === 'Path') {
            node[keyword] = parseString(state);
        }
        else {
            var val = parseKeyword(state) || parseNumber(state);
            if (keyword === 'GeosetId' && val === 'Multiple' ||
                keyword === 'GeosetAnimId' && val === 'None') {
                val = null;
            }
            node[keyword] = val;
        }
        parseSymbol(state, ',');
        parseComment(state);
        parseSpace(state);
    }
    strictParseSymbol(state, '}');
    model.Nodes[node.ObjectId] = node;
    return node;
}
function parseBone(state, model) {
    var node = parseNode$1(state, 'Bone', model);
    model.Bones.push(node);
}
function parseHelper(state, model) {
    var node = parseNode$1(state, 'Helper', model);
    model.Helpers.push(node);
}
function parseAttachment(state, model) {
    var node = parseNode$1(state, 'Attachment', model);
    model.Attachments.push(node);
}
function parsePivotPoints$1(state, model) {
    var count = parseNumber(state);
    var res = [];
    strictParseSymbol(state, '{');
    for (var i = 0; i < count; ++i) {
        res.push(parseArray(state, new Float32Array(3), 0));
        strictParseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.PivotPoints = res;
}
function parseEventObject(state, model) {
    var name = parseString(state);
    var res = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        EventTrack: null,
        Flags: NodeType.EventObject
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'EventTrack') {
            var count = parseNumber(state); // EventTrack count
            res.EventTrack = parseArray(state, new Uint32Array(count), 0);
        }
        else if (keyword === 'Translation' || keyword === 'Rotation' || keyword === 'Scaling') {
            var type = keyword === 'Rotation' ? AnimVectorType$2.FLOAT4 : AnimVectorType$2.FLOAT3;
            res[keyword] = parseAnimVector(state, type);
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.EventObjects.push(res);
    model.Nodes[res.ObjectId] = res;
}
function parseCollisionShape(state, model) {
    var name = parseString(state);
    var res = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        Shape: CollisionShapeType.Box,
        Vertices: null,
        Flags: NodeType.CollisionShape
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'Sphere') {
            res.Shape = CollisionShapeType.Sphere;
        }
        else if (keyword === 'Box') {
            res.Shape = CollisionShapeType.Box;
        }
        else if (keyword === 'Vertices') {
            var count = parseNumber(state);
            var vertices = new Float32Array(count * 3);
            strictParseSymbol(state, '{');
            for (var i = 0; i < count; ++i) {
                parseArray(state, vertices, i * 3);
                strictParseSymbol(state, ',');
            }
            strictParseSymbol(state, '}');
            res.Vertices = vertices;
        }
        else if (keyword === 'Translation' || keyword === 'Rotation' || keyword === 'Scaling') {
            var type = keyword === 'Rotation' ? AnimVectorType$2.FLOAT4 : AnimVectorType$2.FLOAT3;
            res[keyword] = parseAnimVector(state, type);
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.CollisionShapes.push(res);
    model.Nodes[res.ObjectId] = res;
}
function parseGlobalSequences$1(state, model) {
    var res = [];
    var count = parseNumber(state);
    strictParseSymbol(state, '{');
    for (var i = 0; i < count; ++i) {
        var keyword = parseKeyword(state);
        if (keyword === 'Duration') {
            res.push(parseNumber(state));
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.GlobalSequences = res;
}
function parseUnknownBlock(state) {
    var opened;
    while (state.char() !== undefined && state.char() !== '{') {
        ++state.pos;
    }
    opened = 1;
    ++state.pos;
    while (state.char() !== undefined && opened > 0) {
        if (state.char() === '{') {
            ++opened;
        }
        else if (state.char() === '}') {
            --opened;
        }
        ++state.pos;
    }
    parseSpace(state);
}
function parseParticleEmitter(state, model) {
    var res = {
        ObjectId: null,
        Parent: null,
        Name: null,
        Flags: 0
    };
    res.Name = parseString(state);
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (keyword === 'ObjectId' || keyword === 'Parent') {
            res[keyword] = parseNumber(state);
        }
        else if (keyword === 'EmitterUsesMDL' || keyword === 'EmitterUsesTGA') {
            res.Flags |= ParticleEmitterFlags[keyword];
        }
        else if (!isStatic && (keyword === 'Visibility' || keyword === 'Translation' || keyword === 'Rotation' ||
            keyword === 'Scaling' || keyword === 'EmissionRate' || keyword === 'Gravity' || keyword === 'Longitude' ||
            keyword === 'Latitude')) {
            var type = AnimVectorType$2.FLOAT3;
            if (keyword === 'Visibility' || keyword === 'EmissionRate' || keyword === 'Gravity' ||
                keyword === 'Longitude' || keyword === 'Latitude') {
                type = AnimVectorType$2.FLOAT1;
            }
            else if (keyword === 'Rotation') {
                type = AnimVectorType$2.FLOAT4;
            }
            res[keyword] = parseAnimVector(state, type);
        }
        else if (keyword === 'Particle') {
            strictParseSymbol(state, '{');
            while (state.char() !== '}') {
                var keyword2 = parseKeyword(state);
                var isStatic2 = false;
                if (keyword2 === 'static') {
                    isStatic2 = true;
                    keyword2 = parseKeyword(state);
                }
                if (!isStatic2 && (keyword2 === 'LifeSpan' || keyword2 === 'InitVelocity')) {
                    res[keyword2] = parseAnimVector(state, AnimVectorType$2.FLOAT1);
                }
                else if (keyword2 === 'LifeSpan' || keyword2 === 'InitVelocity') {
                    res[keyword2] = parseNumber(state);
                }
                else if (keyword2 === 'Path') {
                    res.Path = parseString(state);
                }
                parseSymbol(state, ',');
            }
            strictParseSymbol(state, '}');
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.ParticleEmitters.push(res);
}
function parseParticleEmitter2(state, model) {
    var name = parseString(state);
    var res = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        Flags: NodeType.ParticleEmitter,
        FrameFlags: 0
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (!isStatic && (keyword === 'Speed' || keyword === 'Latitude' || keyword === 'Visibility' ||
            keyword === 'EmissionRate' || keyword === 'Width' || keyword === 'Length' || keyword === 'Translation' ||
            keyword === 'Rotation' || keyword === 'Scaling' || keyword === 'Gravity' || keyword === 'Variation')) {
            var type = AnimVectorType$2.FLOAT3;
            switch (keyword) {
                case 'Rotation':
                    type = AnimVectorType$2.FLOAT4;
                    break;
                case 'Speed':
                case 'Latitude':
                case 'Visibility':
                case 'EmissionRate':
                case 'Width':
                case 'Length':
                case 'Gravity':
                case 'Variation':
                    type = AnimVectorType$2.FLOAT1;
                    break;
            }
            res[keyword] = parseAnimVector(state, type);
        }
        else if (keyword === 'Variation' || keyword === 'Gravity' || keyword === 'ReplaceableId' || keyword === 'PriorityPlane') {
            res[keyword] = parseNumber(state);
        }
        else if (keyword === 'SortPrimsFarZ' || keyword === 'Unshaded' || keyword === 'LineEmitter' ||
            keyword === 'Unfogged' || keyword === 'ModelSpace' || keyword === 'XYQuad') {
            res.Flags |= ParticleEmitter2Flags[keyword];
        }
        else if (keyword === 'Both') {
            res.FrameFlags |= ParticleEmitter2FramesFlags.Head | ParticleEmitter2FramesFlags.Tail;
        }
        else if (keyword === 'Head' || keyword === 'Tail') {
            res.FrameFlags |= ParticleEmitter2FramesFlags[keyword];
        }
        else if (keyword === 'Squirt') {
            res[keyword] = true;
        }
        else if (keyword === 'DontInherit') {
            strictParseSymbol(state, '{');
            var val = parseKeyword(state);
            if (val === 'Translation') {
                res.Flags |= NodeFlags.DontInheritTranslation;
            }
            else if (val === 'Rotation') {
                res.Flags |= NodeFlags.DontInheritRotation;
            }
            else if (val === 'Scaling') {
                res.Flags |= NodeFlags.DontInheritScaling;
            }
            strictParseSymbol(state, '}');
        }
        else if (keyword === 'SegmentColor') {
            var colors = [];
            strictParseSymbol(state, '{');
            while (state.char() !== '}') {
                parseKeyword(state); // Color
                var colorArr = new Float32Array(3);
                parseArray(state, colorArr, 0);
                // bgr order, inverse from mdx
                var temp = colorArr[0];
                colorArr[0] = colorArr[2];
                colorArr[2] = temp;
                colors.push(colorArr);
                parseSymbol(state, ',');
            }
            strictParseSymbol(state, '}');
            res.SegmentColor = colors;
        }
        else if (keyword === 'Alpha') {
            res.Alpha = new Uint8Array(3);
            parseArray(state, res.Alpha, 0);
        }
        else if (keyword === 'ParticleScaling') {
            res[keyword] = new Float32Array(3);
            parseArray(state, res[keyword], 0);
        }
        else if (keyword === 'LifeSpanUVAnim' || keyword === 'DecayUVAnim' || keyword === 'TailUVAnim' ||
            keyword === 'TailDecayUVAnim') {
            res[keyword] = new Uint32Array(3);
            parseArray(state, res[keyword], 0);
        }
        else if (keyword === 'Transparent' || keyword === 'Blend' || keyword === 'Additive' ||
            keyword === 'AlphaKey' || keyword === 'Modulate' || keyword === 'Modulate2x') {
            res.FilterMode = ParticleEmitter2FilterMode[keyword];
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.ParticleEmitters2.push(res);
    model.Nodes[res.ObjectId] = res;
}
function parseCamera(state, model) {
    var res = {
        Name: null,
        Position: null,
        FieldOfView: 0,
        NearClip: 0,
        FarClip: 0,
        TargetPosition: null
    };
    res.Name = parseString(state);
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'Position') {
            res.Position = new Float32Array(3);
            parseArray(state, res.Position, 0);
        }
        else if (keyword === 'FieldOfView' || keyword === 'NearClip' || keyword === 'FarClip') {
            res[keyword] = parseNumber(state);
        }
        else if (keyword === 'Target') {
            strictParseSymbol(state, '{');
            while (state.char() !== '}') {
                var keyword2 = parseKeyword(state);
                if (keyword2 === 'Position') {
                    res.TargetPosition = new Float32Array(3);
                    parseArray(state, res.TargetPosition, 0);
                }
                else if (keyword2 === 'Translation') {
                    res.TargetTranslation = parseAnimVector(state, AnimVectorType$2.FLOAT3);
                }
                parseSymbol(state, ',');
            }
            strictParseSymbol(state, '}');
        }
        else if (keyword === 'Translation' || keyword === 'Rotation') {
            res[keyword] = parseAnimVector(state, keyword === 'Rotation' ?
                AnimVectorType$2.FLOAT1 :
                AnimVectorType$2.FLOAT3);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.Cameras.push(res);
}
function parseLight(state, model) {
    var name = parseString(state);
    var res = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        Flags: NodeType.Light,
        LightType: 0
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (!isStatic && (keyword === 'Visibility' || keyword === 'Color' || keyword === 'Intensity' ||
            keyword === 'AmbIntensity' || keyword === 'AmbColor' || keyword === 'Translation' ||
            keyword === 'Rotation' || keyword === 'Scaling' || keyword === 'AttenuationStart' ||
            keyword === 'AttenuationEnd')) {
            var type = AnimVectorType$2.FLOAT3;
            switch (keyword) {
                case 'Rotation':
                    type = AnimVectorType$2.FLOAT4;
                    break;
                case 'Visibility':
                case 'Intensity':
                case 'AmbIntensity':
                case 'AttenuationStart':
                case 'AttenuationEnd':
                    type = AnimVectorType$2.FLOAT1;
                    break;
            }
            res[keyword] = parseAnimVector(state, type);
            if (keyword === 'Color' || keyword === 'AmbColor') {
                for (var _i = 0, _a = res[keyword].Keys; _i < _a.length; _i++) {
                    var key = _a[_i];
                    key.Vector.reverse();
                    if (key.InTan) {
                        key.InTan.reverse();
                        key.OutTan.reverse();
                    }
                }
            }
        }
        else if (keyword === 'Omnidirectional' || keyword === 'Directional' || keyword === 'Ambient') {
            res.LightType = LightType[keyword];
        }
        else if (keyword === 'Color' || keyword === 'AmbColor') {
            var color = new Float32Array(3);
            parseArray(state, color, 0);
            // bgr order, inverse from mdx
            var temp = color[0];
            color[0] = color[2];
            color[2] = temp;
            res[keyword] = color;
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.Lights.push(res);
    model.Nodes[res.ObjectId] = res;
}
function parseTextureAnims$1(state, model) {
    var res = [];
    parseNumber(state); // count, not used
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var obj = {};
        parseKeyword(state); // TVertexAnim
        strictParseSymbol(state, '{');
        while (state.char() !== '}') {
            var keyword = parseKeyword(state);
            if (!keyword) {
                throwError(state);
            }
            if (keyword === 'Translation' || keyword === 'Rotation' || keyword === 'Scaling') {
                var type = keyword === 'Rotation' ? AnimVectorType$2.FLOAT4 : AnimVectorType$2.FLOAT3;
                obj[keyword] = parseAnimVector(state, type);
            }
            else {
                throw new Error('Unknown texture anim property ' + keyword);
            }
            parseSymbol(state, ',');
        }
        strictParseSymbol(state, '}');
        res.push(obj);
    }
    strictParseSymbol(state, '}');
    model.TextureAnims = res;
}
function parseRibbonEmitter(state, model) {
    var name = parseString(state);
    var res = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        Flags: NodeType.RibbonEmitter,
        HeightAbove: null,
        HeightBelow: null,
        Alpha: null,
        Color: null,
        LifeSpan: null,
        TextureSlot: null,
        EmissionRate: null,
        Rows: null,
        Columns: null,
        MaterialID: 0,
        Gravity: null,
        Visibility: null
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (!isStatic && (keyword === 'Visibility' || keyword === 'HeightAbove' || keyword === 'HeightBelow' ||
            keyword === 'Translation' || keyword === 'Rotation' || keyword === 'Scaling' || keyword === 'Alpha' ||
            keyword === 'TextureSlot')) {
            var type = AnimVectorType$2.FLOAT3;
            switch (keyword) {
                case 'Rotation':
                    type = AnimVectorType$2.FLOAT4;
                    break;
                case 'Visibility':
                case 'HeightAbove':
                case 'HeightBelow':
                case 'Alpha':
                    type = AnimVectorType$2.FLOAT1;
                    break;
                case 'TextureSlot':
                    type = AnimVectorType$2.INT1;
                    break;
            }
            res[keyword] = parseAnimVector(state, type);
        }
        else if (keyword === 'Color') {
            var color = new Float32Array(3);
            parseArray(state, color, 0);
            // bgr order, inverse from mdx
            var temp = color[0];
            color[0] = color[2];
            color[2] = temp;
            res[keyword] = color;
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.RibbonEmitters.push(res);
    model.Nodes[res.ObjectId] = res;
}
function parseFaceFX$1(state, model) {
    if (model.Version < 900) {
        throwError(state, 'Unexpected model chunk FaceFX');
    }
    var name = parseString(state);
    var res = {
        Name: name,
        Path: ''
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'Path') {
            res.Path = parseString(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.FaceFX = model.FaceFX || [];
    model.FaceFX.push(res);
}
function parseBindPose$1(state, model) {
    if (model.Version < 900) {
        throwError(state, 'Unexpected model chunk BindPose');
    }
    var res = {
        Matrices: []
    };
    strictParseSymbol(state, '{');
    parseKeyword(state); // Matrices
    var count = parseNumber(state);
    strictParseSymbol(state, '{');
    for (var i = 0; i < count; ++i) {
        var matrix = new Float32Array(12);
        parseArray(state, matrix, 0);
        parseSymbol(state, ',');
        res.Matrices.push(matrix);
    }
    strictParseSymbol(state, '}');
    strictParseSymbol(state, '}');
    model.BindPoses = model.BindPoses || [];
    model.BindPoses.push(res);
}
function parseParticleEmitterPopcorn$1(state, model) {
    if (model.Version < 900) {
        throwError(state, 'Unexpected model chunk ParticleEmitterPopcorn');
    }
    var name = parseString(state);
    var res = {
        Name: name,
        ObjectId: null,
        Parent: null,
        PivotPoint: null,
        Flags: NodeType.ParticleEmitter
    };
    strictParseSymbol(state, '{');
    while (state.char() !== '}') {
        var keyword = parseKeyword(state);
        var isStatic = false;
        if (!keyword) {
            throwError(state);
        }
        if (keyword === 'static') {
            isStatic = true;
            keyword = parseKeyword(state);
        }
        if (!isStatic && (keyword === 'LifeSpan' || keyword === 'EmissionRate' || keyword === 'Speed' ||
            keyword === 'Color' || keyword === 'Alpha' || keyword === 'Visibility' ||
            keyword === 'Rotation' || keyword === 'Scaling' || keyword === 'Translation')) {
            var type = AnimVectorType$2.FLOAT3;
            switch (keyword) {
                case 'LifeSpan':
                case 'EmissionRate':
                case 'Speed':
                case 'Alpha':
                case 'Visibility':
                    type = AnimVectorType$2.FLOAT1;
                    break;
            }
            res[keyword] = parseAnimVector(state, type);
        }
        else if (keyword === 'LifeSpan' || keyword === 'EmissionRate' || keyword === 'Speed' || keyword === 'Alpha') {
            res[keyword] = parseNumber(state);
        }
        else if (keyword === 'Color') {
            var array = new Float32Array(3);
            res[keyword] = parseArray(state, array, 0);
        }
        else if (keyword === 'ReplaceableId') {
            res[keyword] = parseNumber(state);
        }
        else if (keyword === 'Path' || keyword === 'AnimVisibilityGuide') {
            res[keyword] = parseString(state);
        }
        else if (keyword === 'Unshaded' || keyword === 'SortPrimsFarZ' || keyword === 'Unfogged') {
            if (keyword === 'Unshaded') {
                res.Flags |= ParticleEmitterPopcornFlags.Unshaded;
            }
            else if (keyword === 'Unfogged') {
                res.Flags |= ParticleEmitterPopcornFlags.Unfogged;
            }
            else if (keyword === 'SortPrimsFarZ') {
                res.Flags |= ParticleEmitterPopcornFlags.SortPrimsFarZ;
            }
        }
        else {
            res[keyword] = parseNumber(state);
        }
        parseSymbol(state, ',');
    }
    strictParseSymbol(state, '}');
    model.ParticleEmitterPopcorns = model.ParticleEmitterPopcorns || [];
    model.ParticleEmitterPopcorns.push(res);
    model.Nodes[res.ObjectId] = res;
}
var parsers$1 = {
    Version: parseVersion$1,
    Model: parseModelInfo$1,
    Sequences: parseSequences$1,
    Textures: parseTextures$1,
    Materials: parseMaterials$1,
    Geoset: parseGeoset,
    GeosetAnim: parseGeosetAnim,
    Bone: parseBone,
    Helper: parseHelper,
    Attachment: parseAttachment,
    PivotPoints: parsePivotPoints$1,
    EventObject: parseEventObject,
    CollisionShape: parseCollisionShape,
    GlobalSequences: parseGlobalSequences$1,
    ParticleEmitter: parseParticleEmitter,
    ParticleEmitter2: parseParticleEmitter2,
    Camera: parseCamera,
    Light: parseLight,
    TextureAnims: parseTextureAnims$1,
    RibbonEmitter: parseRibbonEmitter,
    FaceFX: parseFaceFX$1,
    BindPose: parseBindPose$1,
    ParticleEmitterPopcorn: parseParticleEmitterPopcorn$1
};
function parse$1(str) {
    var state = new State$1(str);
    var model = {
        // default
        Version: 800,
        Info: {
            Name: '',
            MinimumExtent: null,
            MaximumExtent: null,
            BoundsRadius: 0,
            BlendTime: 150
        },
        Sequences: [],
        GlobalSequences: [],
        Textures: [],
        Materials: [],
        TextureAnims: [],
        Geosets: [],
        GeosetAnims: [],
        Bones: [],
        Helpers: [],
        Attachments: [],
        EventObjects: [],
        ParticleEmitters: [],
        ParticleEmitters2: [],
        Cameras: [],
        Lights: [],
        RibbonEmitters: [],
        CollisionShapes: [],
        PivotPoints: [],
        Nodes: []
    };
    while (state.pos < state.str.length) {
        while (parseComment(state))
            ;
        var keyword = parseKeyword(state);
        if (keyword) {
            if (keyword in parsers$1) {
                parsers$1[keyword](state, model);
            }
            else {
                parseUnknownBlock(state);
            }
        }
        else {
            break;
        }
    }
    for (var i = 0; i < model.Nodes.length; ++i) {
        if (model.PivotPoints[i]) {
            model.Nodes[i].PivotPoint = model.PivotPoints[i];
        }
    }
    return model;
}

var _a$1;
var BIG_ENDIAN$1 = true;
var NONE$1 = -1;
var AnimVectorType$1;
(function (AnimVectorType) {
    AnimVectorType[AnimVectorType["INT1"] = 0] = "INT1";
    AnimVectorType[AnimVectorType["FLOAT1"] = 1] = "FLOAT1";
    AnimVectorType[AnimVectorType["FLOAT3"] = 2] = "FLOAT3";
    AnimVectorType[AnimVectorType["FLOAT4"] = 3] = "FLOAT4";
})(AnimVectorType$1 || (AnimVectorType$1 = {}));
var animVectorSize$1 = (_a$1 = {},
    _a$1[AnimVectorType$1.INT1] = 1,
    _a$1[AnimVectorType$1.FLOAT1] = 1,
    _a$1[AnimVectorType$1.FLOAT3] = 3,
    _a$1[AnimVectorType$1.FLOAT4] = 4,
    _a$1);
var State = /** @class */ (function () {
    function State(arrayBuffer) {
        this.ab = arrayBuffer;
        this.pos = 0;
        this.length = arrayBuffer.byteLength;
        this.view = new DataView(this.ab);
        this.uint = new Uint8Array(this.ab);
    }
    State.prototype.keyword = function () {
        var res = String.fromCharCode(this.uint[this.pos], this.uint[this.pos + 1], this.uint[this.pos + 2], this.uint[this.pos + 3]);
        this.pos += 4;
        return res;
    };
    State.prototype.expectKeyword = function (keyword, errorText) {
        var curKeyword = this.keyword();
        if (curKeyword !== keyword) {
            throw new Error(errorText);
        }
    };
    State.prototype.uint8 = function () {
        return this.view.getUint8(this.pos++);
    };
    State.prototype.uint16 = function () {
        var res = this.view.getUint16(this.pos, BIG_ENDIAN$1);
        this.pos += 2;
        return res;
    };
    State.prototype.int32 = function () {
        var res = this.view.getInt32(this.pos, BIG_ENDIAN$1);
        this.pos += 4;
        return res;
    };
    State.prototype.float32 = function () {
        var res = this.view.getFloat32(this.pos, BIG_ENDIAN$1);
        this.pos += 4;
        return res;
    };
    State.prototype.float32Array = function (len) {
        var res = new Float32Array(len);
        for (var i = 0; i < len; ++i) {
            res[i] = this.float32();
        }
        return res;
    };
    State.prototype.uint8Array = function (len) {
        var res = new Uint8Array(len);
        for (var i = 0; i < len; ++i) {
            res[i] = this.uint8();
        }
        return res;
    };
    State.prototype.str = function (length) {
        // actual string length
        // data may consist of ['a', 'b', 'c', 0, 0, 0]
        var stringLength = length;
        while (this.uint[this.pos + stringLength - 1] === 0 && stringLength > 0) {
            --stringLength;
        }
        // ??
        // TS2461:Type 'Uint8Array' is not an array type.
        // let res = String.fromCharCode(...this.uint.slice(this.pos, this.pos + length));
        // eslint-disable-next-line prefer-spread
        var res = String.fromCharCode.apply(String, this.uint.slice(this.pos, this.pos + stringLength));
        this.pos += length;
        return res;
    };
    State.prototype.animVector = function (type) {
        var res = {
            Keys: []
        };
        var isInt = type === AnimVectorType$1.INT1;
        var vectorSize = animVectorSize$1[type];
        var keysCount = this.int32();
        res.LineType = this.int32();
        res.GlobalSeqId = this.int32();
        if (res.GlobalSeqId === NONE$1) {
            res.GlobalSeqId = null;
        }
        for (var i = 0; i < keysCount; ++i) {
            var animKeyFrame = {};
            animKeyFrame.Frame = this.int32();
            if (isInt) {
                animKeyFrame.Vector = new Int32Array(vectorSize);
            }
            else {
                animKeyFrame.Vector = new Float32Array(vectorSize);
            }
            for (var j = 0; j < vectorSize; ++j) {
                if (isInt) {
                    animKeyFrame.Vector[j] = this.int32();
                }
                else {
                    animKeyFrame.Vector[j] = this.float32();
                }
            }
            if (res.LineType === LineType.Hermite || res.LineType === LineType.Bezier) {
                for (var _i = 0, _a = ['InTan', 'OutTan']; _i < _a.length; _i++) {
                    var part = _a[_i];
                    animKeyFrame[part] = new Float32Array(vectorSize);
                    for (var j = 0; j < vectorSize; ++j) {
                        if (isInt) {
                            animKeyFrame[part][j] = this.int32();
                        }
                        else {
                            animKeyFrame[part][j] = this.float32();
                        }
                    }
                }
            }
            res.Keys.push(animKeyFrame);
        }
        return res;
    };
    return State;
}());
function parseExtent(obj, state) {
    obj.BoundsRadius = state.float32();
    for (var _i = 0, _a = ['MinimumExtent', 'MaximumExtent']; _i < _a.length; _i++) {
        var key = _a[_i];
        obj[key] = new Float32Array(3);
        for (var i = 0; i < 3; ++i) {
            obj[key][i] = state.float32();
        }
    }
}
function parseVersion(model, state) {
    model.Version = state.int32();
}
var MODEL_NAME_LENGTH$1 = 0x150;
function parseModelInfo(model, state) {
    model.Info.Name = state.str(MODEL_NAME_LENGTH$1);
    state.int32(); // unknown 4-byte sequence
    parseExtent(model.Info, state);
    model.Info.BlendTime = state.int32();
}
var MODEL_SEQUENCE_NAME_LENGTH$1 = 0x50;
function parseSequences(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var name_1 = state.str(MODEL_SEQUENCE_NAME_LENGTH$1);
        var sequence = {};
        sequence.Name = name_1;
        var interval = new Uint32Array(2);
        interval[0] = state.int32();
        interval[1] = state.int32();
        sequence.Interval = interval;
        sequence.MoveSpeed = state.float32();
        sequence.NonLooping = state.int32() > 0;
        sequence.Rarity = state.float32();
        state.int32(); // unknown 4-byte sequence (syncPoint?)
        parseExtent(sequence, state);
        model.Sequences.push(sequence);
    }
}
function parseMaterials(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        state.int32(); // material size inclusive
        var material = {
            Layers: []
        };
        material.PriorityPlane = state.int32();
        material.RenderMode = state.int32();
        if (model.Version >= 900 && model.Version < 1100) {
            material.Shader = state.str(80);
        }
        state.expectKeyword('LAYS', 'Incorrect materials format');
        var layersCount = state.int32();
        for (var i = 0; i < layersCount; ++i) {
            var startPos2 = state.pos;
            var size2 = state.int32();
            var layer = {};
            layer.FilterMode = state.int32();
            layer.Shading = state.int32();
            layer.TextureID = state.int32();
            layer.TVertexAnimId = state.int32();
            if (layer.TVertexAnimId === NONE$1) {
                layer.TVertexAnimId = null;
            }
            layer.CoordId = state.int32();
            layer.Alpha = state.float32();
            if (model.Version >= 900) {
                layer.EmissiveGain = state.float32();
                if (model.Version >= 1000) {
                    layer.FresnelColor = state.float32Array(3);
                    layer.FresnelOpacity = state.float32();
                    layer.FresnelTeamColor = state.float32();
                }
            }
            if (model.Version >= 1100) {
                layer.ShaderTypeId = state.int32(); // hd flag
                var textureCount = state.int32();
                for (var j = 0; j < textureCount; ++j) {
                    var textureId = state.int32(); //layer_texture.id
                    // const textureType = state.int32();
                    state.int32();
                    var textureType = j;
                    var keyword = state.keyword();
                    if (keyword === 'KMTF') {
                        layer[LAYER_TEXTURE_ID_MAP[textureType]] = state.animVector(AnimVectorType$1.INT1);
                    }
                    else {
                        layer[LAYER_TEXTURE_ID_MAP[textureType]] = textureId;
                        state.pos -= 4;
                    }
                }
            }
            while (state.pos < startPos2 + size2) {
                var keyword = state.keyword();
                if (keyword === 'KMTA') {
                    layer.Alpha = state.animVector(AnimVectorType$1.FLOAT1);
                }
                else if (keyword === 'KMTF') {
                    layer.TextureID = state.animVector(AnimVectorType$1.INT1);
                }
                else if (keyword === 'KMTE' && model.Version >= 900) {
                    layer.EmissiveGain = state.animVector(AnimVectorType$1.FLOAT1);
                }
                else if (keyword === 'KFC3' && model.Version >= 1000) {
                    layer.FresnelColor = state.animVector(AnimVectorType$1.FLOAT3);
                }
                else if (keyword === 'KFCA' && model.Version >= 1000) {
                    layer.FresnelOpacity = state.animVector(AnimVectorType$1.FLOAT1);
                }
                else if (keyword === 'KFTC' && model.Version >= 1000) {
                    layer.FresnelTeamColor = state.animVector(AnimVectorType$1.FLOAT1);
                }
                else {
                    throw new Error('Unknown layer chunk data ' + keyword);
                }
            }
            material.Layers.push(layer);
        }
        model.Materials.push(material);
    }
}
var MODEL_TEXTURE_PATH_LENGTH$1 = 0x100;
function parseTextures(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var texture = {};
        texture.ReplaceableId = state.int32();
        texture.Image = state.str(MODEL_TEXTURE_PATH_LENGTH$1);
        state.int32(); // unknown 4-byte sequence
        texture.Flags = state.int32();
        model.Textures.push(texture);
    }
}
function parseGeosets(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var geoset = {};
        state.int32(); // geoset size, not used
        state.expectKeyword('VRTX', 'Incorrect geosets format');
        var verticesCount = state.int32();
        geoset.Vertices = new Float32Array(verticesCount * 3);
        for (var i = 0; i < verticesCount * 3; ++i) {
            geoset.Vertices[i] = state.float32();
        }
        state.expectKeyword('NRMS', 'Incorrect geosets format');
        var normalsCount = state.int32();
        geoset.Normals = new Float32Array(normalsCount * 3);
        for (var i = 0; i < normalsCount * 3; ++i) {
            geoset.Normals[i] = state.float32();
        }
        state.expectKeyword('PTYP', 'Incorrect geosets format');
        var primitiveCount = state.int32();
        for (var i = 0; i < primitiveCount; ++i) {
            if (state.int32() !== 4) {
                throw new Error('Incorrect geosets format');
            }
        }
        state.expectKeyword('PCNT', 'Incorrect geosets format');
        var faceGroupCount = state.int32();
        for (var i = 0; i < faceGroupCount; ++i) {
            state.int32();
        }
        state.expectKeyword('PVTX', 'Incorrect geosets format');
        var indicesCount = state.int32();
        geoset.Faces = new Uint16Array(indicesCount);
        for (var i = 0; i < indicesCount; ++i) {
            geoset.Faces[i] = state.uint16();
        }
        state.expectKeyword('GNDX', 'Incorrect geosets format');
        var verticesGroupCount = state.int32();
        geoset.VertexGroup = new Uint8Array(verticesGroupCount);
        for (var i = 0; i < verticesGroupCount; ++i) {
            geoset.VertexGroup[i] = state.uint8();
        }
        state.expectKeyword('MTGC', 'Incorrect geosets format');
        var groupsCount = state.int32();
        geoset.Groups = [];
        for (var i = 0; i < groupsCount; ++i) {
            // new Array(array length)
            geoset.Groups[i] = new Array(state.int32());
        }
        state.expectKeyword('MATS', 'Incorrect geosets format');
        geoset.TotalGroupsCount = state.int32();
        var groupIndex = 0;
        var groupCounter = 0;
        for (var i = 0; i < geoset.TotalGroupsCount; ++i) {
            if (groupIndex >= geoset.Groups[groupCounter].length) {
                groupIndex = 0;
                groupCounter++;
            }
            geoset.Groups[groupCounter][groupIndex++] = state.int32();
        }
        geoset.MaterialID = state.int32();
        geoset.SelectionGroup = state.int32();
        geoset.Unselectable = state.int32() > 0;
        if (model.Version >= 900) {
            geoset.LevelOfDetail = state.int32();
            geoset.Name = state.str(80);
        }
        parseExtent(geoset, state);
        var geosetAnimCount = state.int32();
        geoset.Anims = [];
        for (var i = 0; i < geosetAnimCount; ++i) {
            var geosetAnim = {};
            parseExtent(geosetAnim, state);
            geoset.Anims.push(geosetAnim);
        }
        var keyword = state.keyword();
        if (model.Version >= 900) {
            // eslint-disable-next-line no-constant-condition
            while (1) {
                if (state.pos >= state.length) {
                    throw new Error('Unexpected EOF');
                }
                if (keyword === 'TANG') {
                    if (geoset.Tangents) {
                        throw new Error('Incorrect geoset, multiple Tangents');
                    }
                    var len = state.int32();
                    geoset.Tangents = state.float32Array(len * 4);
                }
                else if (keyword === 'SKIN') {
                    if (geoset.SkinWeights) {
                        throw new Error('Incorrect geoset, multiple SkinWeights');
                    }
                    var len = state.int32();
                    geoset.SkinWeights = state.uint8Array(len);
                }
                else if (keyword === 'UVAS') {
                    break;
                }
                keyword = state.keyword();
            }
        }
        else if (keyword !== 'UVAS') {
            throw new Error('Incorrect geosets format');
        }
        var textureChunkCount = state.int32();
        geoset.TVertices = [];
        for (var i = 0; i < textureChunkCount; ++i) {
            state.expectKeyword('UVBS', 'Incorrect geosets format');
            var textureCoordsCount = state.int32();
            var tvertices = new Float32Array(textureCoordsCount * 2);
            for (var j = 0; j < textureCoordsCount * 2; ++j) {
                tvertices[j] = state.float32();
            }
            geoset.TVertices.push(tvertices);
        }
        model.Geosets.push(geoset);
    }
}
function parseGeosetAnims(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var animStartPos = state.pos;
        var animSize = state.int32();
        var geosetAnim = {};
        geosetAnim.Alpha = state.float32();
        geosetAnim.Flags = state.int32();
        geosetAnim.Color = new Float32Array(3);
        for (var i = 0; i < 3; ++i) {
            geosetAnim.Color[i] = state.float32();
        }
        geosetAnim.GeosetId = state.int32();
        if (geosetAnim.GeosetId === NONE$1) {
            geosetAnim.GeosetId = null;
        }
        while (state.pos < animStartPos + animSize) {
            var keyword = state.keyword();
            if (keyword === 'KGAO') {
                geosetAnim.Alpha = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KGAC') {
                geosetAnim.Color = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else {
                throw new Error('Incorrect GeosetAnim chunk data ' + keyword);
            }
        }
        model.GeosetAnims.push(geosetAnim);
    }
}
var MODEL_NODE_NAME_LENGTH$1 = 0x50;
function parseNode(model, node, state) {
    var startPos = state.pos;
    var size = state.int32();
    node.Name = state.str(MODEL_NODE_NAME_LENGTH$1);
    node.ObjectId = state.int32();
    if (node.ObjectId === NONE$1) {
        node.ObjectId = null;
    }
    node.Parent = state.int32();
    if (node.Parent === NONE$1) {
        node.Parent = null;
    }
    node.Flags = state.int32();
    while (state.pos < startPos + size) {
        var keyword = state.keyword();
        if (keyword === 'KGTR') {
            node.Translation = state.animVector(AnimVectorType$1.FLOAT3);
        }
        else if (keyword === 'KGRT') {
            node.Rotation = state.animVector(AnimVectorType$1.FLOAT4);
        }
        else if (keyword === 'KGSC') {
            node.Scaling = state.animVector(AnimVectorType$1.FLOAT3);
        }
        else {
            throw new Error('Incorrect node chunk data ' + keyword);
        }
    }
    model.Nodes[node.ObjectId] = node;
}
function parseBones(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var bone = {};
        parseNode(model, bone, state);
        bone.GeosetId = state.int32();
        if (bone.GeosetId === NONE$1) {
            bone.GeosetId = null;
        }
        bone.GeosetAnimId = state.int32();
        if (bone.GeosetAnimId === NONE$1) {
            bone.GeosetAnimId = null;
        }
        model.Bones.push(bone);
    }
}
function parseHelpers(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var helper = {};
        parseNode(model, helper, state);
        model.Helpers.push(helper);
    }
}
var MODEL_ATTACHMENT_PATH_LENGTH$1 = 0x100;
function parseAttachments(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var attachmentStart = state.pos;
        var attachmentSize = state.int32();
        var attachment = {};
        parseNode(model, attachment, state);
        attachment.Path = state.str(MODEL_ATTACHMENT_PATH_LENGTH$1);
        state.int32(); // unknown 4-byte
        attachment.AttachmentID = state.int32();
        if (state.pos < attachmentStart + attachmentSize) {
            state.expectKeyword('KATV', 'Incorrect attachment chunk data');
            attachment.Visibility = state.animVector(AnimVectorType$1.FLOAT1);
        }
        model.Attachments.push(attachment);
    }
}
function parsePivotPoints(model, state, size) {
    var pointsCount = size / (4 * 3);
    for (var i = 0; i < pointsCount; ++i) {
        model.PivotPoints[i] = new Float32Array(3);
        model.PivotPoints[i][0] = state.float32();
        model.PivotPoints[i][1] = state.float32();
        model.PivotPoints[i][2] = state.float32();
    }
}
function parseEventObjects(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var eventObject = {};
        parseNode(model, eventObject, state);
        state.expectKeyword('KEVT', 'Incorrect EventObject chunk data');
        var eventTrackCount = state.int32();
        eventObject.EventTrack = new Uint32Array(eventTrackCount);
        state.int32(); // unused 4-byte?
        for (var i = 0; i < eventTrackCount; ++i) {
            eventObject.EventTrack[i] = state.int32();
        }
        model.EventObjects.push(eventObject);
    }
}
function parseCollisionShapes(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var collisionShape = {};
        parseNode(model, collisionShape, state);
        collisionShape.Shape = state.int32();
        if (collisionShape.Shape === CollisionShapeType.Box) {
            collisionShape.Vertices = new Float32Array(6);
        }
        else {
            collisionShape.Vertices = new Float32Array(3);
        }
        for (var i = 0; i < collisionShape.Vertices.length; ++i) {
            collisionShape.Vertices[i] = state.float32();
        }
        if (collisionShape.Shape === CollisionShapeType.Sphere) {
            collisionShape.BoundsRadius = state.float32();
        }
        model.CollisionShapes.push(collisionShape);
    }
}
function parseGlobalSequences(model, state, size) {
    var startPos = state.pos;
    model.GlobalSequences = [];
    while (state.pos < startPos + size) {
        model.GlobalSequences.push(state.int32());
    }
}
var MODEL_PARTICLE_EMITTER_PATH_LENGTH$1 = 0x100;
function parseParticleEmitters(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var emitterStart = state.pos;
        var emitterSize = state.int32();
        var emitter = {};
        parseNode(model, emitter, state);
        emitter.EmissionRate = state.float32();
        emitter.Gravity = state.float32();
        emitter.Longitude = state.float32();
        emitter.Latitude = state.float32();
        emitter.Path = state.str(MODEL_PARTICLE_EMITTER_PATH_LENGTH$1);
        state.int32();
        emitter.LifeSpan = state.float32();
        emitter.InitVelocity = state.float32();
        while (state.pos < emitterStart + emitterSize) {
            var keyword = state.keyword();
            if (keyword === 'KPEV') {
                emitter.Visibility = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPEE') {
                emitter.EmissionRate = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPEG') {
                emitter.Gravity = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPLN') {
                emitter.Longitude = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPLT') {
                emitter.Latitude = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPEL') {
                emitter.LifeSpan = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPES') {
                emitter.InitVelocity = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else {
                throw new Error('Incorrect particle emitter chunk data ' + keyword);
            }
        }
        model.ParticleEmitters.push(emitter);
    }
}
function parseParticleEmitters2(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var emitterStart = state.pos;
        var emitterSize = state.int32();
        var emitter = {};
        parseNode(model, emitter, state);
        emitter.Speed = state.float32();
        emitter.Variation = state.float32();
        emitter.Latitude = state.float32();
        emitter.Gravity = state.float32();
        emitter.LifeSpan = state.float32();
        emitter.EmissionRate = state.float32();
        emitter.Width = state.float32();
        emitter.Length = state.float32();
        emitter.FilterMode = state.int32();
        emitter.Rows = state.int32();
        emitter.Columns = state.int32();
        var frameFlags = state.int32();
        emitter.FrameFlags = 0;
        if (frameFlags === 0 || frameFlags === 2) {
            emitter.FrameFlags |= ParticleEmitter2FramesFlags.Head;
        }
        if (frameFlags === 1 || frameFlags === 2) {
            emitter.FrameFlags |= ParticleEmitter2FramesFlags.Tail;
        }
        emitter.TailLength = state.float32();
        emitter.Time = state.float32();
        emitter.SegmentColor = [];
        // always 3 segments
        for (var i = 0; i < 3; ++i) {
            emitter.SegmentColor[i] = new Float32Array(3);
            //  rgb order, inverse from mdl
            for (var j = 0; j < 3; ++j) {
                emitter.SegmentColor[i][j] = state.float32();
            }
        }
        emitter.Alpha = new Uint8Array(3);
        for (var i = 0; i < 3; ++i) {
            emitter.Alpha[i] = state.uint8();
        }
        emitter.ParticleScaling = new Float32Array(3);
        for (var i = 0; i < 3; ++i) {
            emitter.ParticleScaling[i] = state.float32();
        }
        for (var _i = 0, _a = ['LifeSpanUVAnim', 'DecayUVAnim', 'TailUVAnim', 'TailDecayUVAnim']; _i < _a.length; _i++) {
            var part = _a[_i];
            emitter[part] = new Uint32Array(3);
            for (var i = 0; i < 3; ++i) {
                emitter[part][i] = state.int32();
            }
        }
        emitter.TextureID = state.int32();
        if (emitter.TextureID === NONE$1) {
            emitter.TextureID = null;
        }
        emitter.Squirt = state.int32() > 0;
        emitter.PriorityPlane = state.int32();
        emitter.ReplaceableId = state.int32();
        while (state.pos < emitterStart + emitterSize) {
            var keyword = state.keyword();
            if (keyword === 'KP2V') {
                emitter.Visibility = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2E') {
                emitter.EmissionRate = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2W') {
                emitter.Width = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2N') {
                emitter.Length = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2S') {
                emitter.Speed = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2L') {
                emitter.Latitude = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2G') {
                emitter.Gravity = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KP2R') {
                emitter.Variation = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else {
                throw new Error('Incorrect particle emitter2 chunk data ' + keyword);
            }
        }
        model.ParticleEmitters2.push(emitter);
    }
}
var MODEL_CAMERA_NAME_LENGTH$1 = 0x50;
function parseCameras(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var cameraStart = state.pos;
        var cameraSize = state.int32();
        var camera = {};
        camera.Name = state.str(MODEL_CAMERA_NAME_LENGTH$1);
        camera.Position = new Float32Array(3);
        camera.Position[0] = state.float32();
        camera.Position[1] = state.float32();
        camera.Position[2] = state.float32();
        camera.FieldOfView = state.float32();
        camera.FarClip = state.float32();
        camera.NearClip = state.float32();
        camera.TargetPosition = new Float32Array(3);
        camera.TargetPosition[0] = state.float32();
        camera.TargetPosition[1] = state.float32();
        camera.TargetPosition[2] = state.float32();
        while (state.pos < cameraStart + cameraSize) {
            var keyword = state.keyword();
            if (keyword === 'KCTR') {
                camera.Translation = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else if (keyword === 'KTTR') {
                camera.TargetTranslation = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else if (keyword === 'KCRL') {
                camera.Rotation = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else {
                throw new Error('Incorrect camera chunk data ' + keyword);
            }
        }
        model.Cameras.push(camera);
    }
}
function parseLights(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var lightStart = state.pos;
        var lightSize = state.int32();
        var light = {};
        parseNode(model, light, state);
        light.LightType = state.int32();
        light.AttenuationStart = state.float32();
        light.AttenuationEnd = state.float32();
        light.Color = new Float32Array(3);
        //  rgb order, inverse from mdl
        for (var j = 0; j < 3; ++j) {
            light.Color[j] = state.float32();
        }
        light.Intensity = state.float32();
        light.AmbColor = new Float32Array(3);
        //  rgb order, inverse from mdl
        for (var j = 0; j < 3; ++j) {
            light.AmbColor[j] = state.float32();
        }
        light.AmbIntensity = state.float32();
        while (state.pos < lightStart + lightSize) {
            var keyword = state.keyword();
            if (keyword === 'KLAV') {
                light.Visibility = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KLAC') {
                light.Color = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else if (keyword === 'KLAI') {
                light.Intensity = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KLBC') {
                light.AmbColor = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else if (keyword === 'KLBI') {
                light.AmbIntensity = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KLAS') {
                light.AttenuationStart = state.animVector(AnimVectorType$1.INT1);
            }
            else if (keyword === 'KLAE') {
                light.AttenuationEnd = state.animVector(AnimVectorType$1.INT1);
            }
            else {
                throw new Error('Incorrect light chunk data ' + keyword);
            }
        }
        model.Lights.push(light);
    }
}
function parseTextureAnims(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var animStart = state.pos;
        var animSize = state.int32();
        var anim = {};
        while (state.pos < animStart + animSize) {
            var keyword = state.keyword();
            if (keyword === 'KTAT') {
                anim.Translation = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else if (keyword === 'KTAR') {
                anim.Rotation = state.animVector(AnimVectorType$1.FLOAT4);
            }
            else if (keyword === 'KTAS') {
                anim.Scaling = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else {
                throw new Error('Incorrect light chunk data ' + keyword);
            }
        }
        model.TextureAnims.push(anim);
    }
}
function parseRibbonEmitters(model, state, size) {
    var startPos = state.pos;
    while (state.pos < startPos + size) {
        var emitterStart = state.pos;
        var emitterSize = state.int32();
        var emitter = {};
        parseNode(model, emitter, state);
        emitter.HeightAbove = state.float32();
        emitter.HeightBelow = state.float32();
        emitter.Alpha = state.float32();
        emitter.Color = new Float32Array(3);
        //  rgb order, inverse from mdl
        for (var j = 0; j < 3; ++j) {
            emitter.Color[j] = state.float32();
        }
        emitter.LifeSpan = state.float32();
        emitter.TextureSlot = state.int32();
        emitter.EmissionRate = state.int32();
        emitter.Rows = state.int32();
        emitter.Columns = state.int32();
        emitter.MaterialID = state.int32();
        emitter.Gravity = state.float32();
        while (state.pos < emitterStart + emitterSize) {
            var keyword = state.keyword();
            if (keyword === 'KRVS') {
                emitter.Visibility = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KRHA') {
                emitter.HeightAbove = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KRHB') {
                emitter.HeightBelow = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KRAL') {
                emitter.Alpha = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KRTX') {
                emitter.TextureSlot = state.animVector(AnimVectorType$1.INT1);
            }
            else {
                throw new Error('Incorrect ribbon emitter chunk data ' + keyword);
            }
        }
        model.RibbonEmitters.push(emitter);
    }
}
function parseFaceFX(model, state, size) {
    if (model.Version < 900) {
        throw new Error('Mismatched version chunk');
    }
    var startPos = state.pos;
    model.FaceFX = model.FaceFX || [];
    while (state.pos < startPos + size) {
        var faceFX = {
            Name: '',
            Path: ''
        };
        faceFX.Name = state.str(80);
        faceFX.Path = state.str(260);
        model.FaceFX.push(faceFX);
    }
}
function parseBindPose(model, state, size) {
    if (model.Version < 900) {
        throw new Error('Mismatched version chunk');
    }
    var startPos = state.pos;
    model.BindPoses = model.BindPoses || [];
    var len = state.int32();
    var bindPose = {
        Matrices: []
    };
    for (var i = 0; i < len; ++i) {
        var matrix = state.float32Array(12);
        bindPose.Matrices.push(matrix);
    }
    model.BindPoses.push(bindPose);
    if (state.pos !== startPos + size) {
        throw new Error('Mismatched BindPose data');
    }
}
function parseParticleEmitterPopcorn(model, state, size) {
    if (model.Version < 900) {
        throw new Error('Mismatched version chunk');
    }
    var startPos = state.pos;
    model.ParticleEmitterPopcorns = model.ParticleEmitterPopcorns || [];
    while (state.pos < startPos + size) {
        var emitterStart = state.pos;
        var emitterSize = state.int32();
        var emitter = {};
        parseNode(model, emitter, state);
        emitter.LifeSpan = state.float32();
        emitter.EmissionRate = state.float32();
        emitter.Speed = state.float32();
        emitter.Color = state.float32Array(3);
        emitter.Alpha = state.float32();
        emitter.ReplaceableId = state.int32();
        emitter.Path = state.str(260);
        emitter.AnimVisibilityGuide = state.str(260);
        while (state.pos < emitterStart + emitterSize) {
            var keyword = state.keyword();
            if (keyword === 'KPPA') {
                emitter.Alpha = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPPC') {
                emitter.Color = state.animVector(AnimVectorType$1.FLOAT3);
            }
            else if (keyword === 'KPPE') {
                emitter.EmissionRate = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPPL') {
                emitter.LifeSpan = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPPS') {
                emitter.Speed = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else if (keyword === 'KPPV') {
                emitter.Visibility = state.animVector(AnimVectorType$1.FLOAT1);
            }
            else {
                throw new Error('Incorrect particle emitter popcorn chunk data ' + keyword);
            }
        }
        model.ParticleEmitterPopcorns.push(emitter);
    }
}
var parsers = {
    VERS: parseVersion,
    MODL: parseModelInfo,
    SEQS: parseSequences,
    MTLS: parseMaterials,
    TEXS: parseTextures,
    GEOS: parseGeosets,
    GEOA: parseGeosetAnims,
    BONE: parseBones,
    HELP: parseHelpers,
    ATCH: parseAttachments,
    PIVT: parsePivotPoints,
    EVTS: parseEventObjects,
    CLID: parseCollisionShapes,
    GLBS: parseGlobalSequences,
    PREM: parseParticleEmitters,
    PRE2: parseParticleEmitters2,
    CAMS: parseCameras,
    LITE: parseLights,
    TXAN: parseTextureAnims,
    RIBB: parseRibbonEmitters,
    FAFX: parseFaceFX,
    BPOS: parseBindPose,
    CORN: parseParticleEmitterPopcorn
};
function parse(arrayBuffer) {
    var state = new State(arrayBuffer);
    if (state.keyword() !== 'MDLX') {
        throw new Error('Not a mdx model');
    }
    var model = {
        // default
        Version: 800,
        Info: {
            Name: '',
            MinimumExtent: null,
            MaximumExtent: null,
            BoundsRadius: 0,
            BlendTime: 150
        },
        Sequences: [],
        GlobalSequences: [],
        Textures: [],
        Materials: [],
        TextureAnims: [],
        Geosets: [],
        GeosetAnims: [],
        Bones: [],
        Helpers: [],
        Attachments: [],
        EventObjects: [],
        ParticleEmitters: [],
        ParticleEmitters2: [],
        Cameras: [],
        Lights: [],
        RibbonEmitters: [],
        CollisionShapes: [],
        PivotPoints: [],
        Nodes: []
    };
    while (state.pos < state.length) {
        var keyword = state.keyword();
        var size = state.int32();
        if (keyword in parsers) {
            parsers[keyword](model, state, size);
        }
        else {
            // throw new Error('Unknown group ' + keyword);
            state.pos += size;
        }
    }
    for (var i = 0; i < model.Nodes.length; ++i) {
        if (model.Nodes[i] && model.PivotPoints[i]) {
            model.Nodes[i].PivotPoint = model.PivotPoints[i];
        }
    }
    model.Info.NumGeosets = model.Geosets.length;
    model.Info.NumGeosetAnims = model.GeosetAnims.length;
    model.Info.NumBones = model.Bones.length;
    model.Info.NumLights = model.Lights.length;
    model.Info.NumAttachments = model.Attachments.length;
    model.Info.NumEvents = model.EventObjects.length;
    model.Info.NumParticleEmitters = model.ParticleEmitters.length;
    model.Info.NumParticleEmitters2 = model.ParticleEmitters2.length;
    model.Info.NumRibbonEmitters = model.RibbonEmitters.length;
    return model;
}

var FLOAT_PRESICION = 6;
var EPSILON = 1e-6;
function isNotEmptyVec3(vec, val) {
    if (val === void 0) { val = 0; }
    return Math.abs(vec[0] - val) > EPSILON ||
        Math.abs(vec[1] - val) > EPSILON ||
        Math.abs(vec[2] - val) > EPSILON;
}
function generateTab(tabSize) {
    if (tabSize === void 0) { tabSize = 1; }
    if (tabSize === 0) {
        return '';
    }
    var res = '\t';
    for (var i = 1; i < tabSize; ++i) {
        res += '\t';
    }
    return res;
}
function generateWrappedString(val) {
    return "\"".concat(val, "\"");
}
function generateWrappedStringOrNumber(val) {
    if (typeof val === 'number') {
        return String(val);
    }
    return generateWrappedString(val);
}
function generateBlockStart(blockName, subInfo, tabSize) {
    if (subInfo === void 0) { subInfo = null; }
    if (tabSize === void 0) { tabSize = 0; }
    return generateTab(tabSize) +
        blockName + ' ' +
        (subInfo !== null ? generateWrappedStringOrNumber(subInfo) + ' ' : '') +
        '{\n';
}
function generateBlockEnd(tabSize) {
    if (tabSize === void 0) { tabSize = 0; }
    return generateTab(tabSize) + '}\n';
}
var trailingZeroRegExp = /(\..+?)0+$/;
var trailingZeroRegExp2 = /\.0+$/;
var negativeZeroRegExp = /^-0$/;
function generateNumber(val) {
    return val.toFixed(FLOAT_PRESICION)
        .replace(trailingZeroRegExp, '$1')
        .replace(trailingZeroRegExp2, '')
        .replace(negativeZeroRegExp, '0');
}
function generateArray(arr, reverse) {
    if (reverse === void 0) { reverse = false; }
    var middle = '';
    if (reverse) {
        for (var i = arr.length - 1; i >= 0; --i) {
            if (i < arr.length - 1) {
                middle += ', ';
            }
            middle += generateNumber(arr[i]);
        }
    }
    else {
        for (var i = 0; i < arr.length; ++i) {
            if (i > 0) {
                middle += ', ';
            }
            middle += generateNumber(arr[i]);
        }
    }
    return '{ ' + middle + ' }';
}
function generateUIntArray(arr) {
    var middle = '';
    for (var i = 0; i < arr.length; ++i) {
        if (i > 0) {
            middle += ', ';
        }
        middle += String(arr[i]);
    }
    return '{ ' + middle + ' }';
}
function generateStatic(isStatic) {
    return isStatic ? 'static ' : '';
}
function generateProp(name, val, isStatic, tabSize) {
    if (tabSize === void 0) { tabSize = 1; }
    return "".concat(generateTab(tabSize) + generateStatic(isStatic) + name, " ").concat(val, ",\n");
}
function generateIntProp(name, val, isStatic, tabSize) {
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    return generateProp(name, String(val), isStatic, tabSize);
}
function generateFloatProp(name, val, isStatic, tabSize) {
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    return generateProp(name, generateNumber(val), isStatic, tabSize);
}
function generateStringProp(name, val, isStatic, tabSize) {
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    return generateProp(name, val, isStatic, tabSize);
}
function generateWrappedStringProp(name, val, isStatic, tabSize) {
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    return generateProp(name, generateWrappedString(val), isStatic, tabSize);
}
function generateFloatArrayProp(name, val, isStatic, tabSize) {
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    return generateProp(name, generateArray(val), isStatic, tabSize);
}
function generateUIntArrayProp(name, val, isStatic, tabSize) {
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    return generateProp(name, generateUIntArray(val), isStatic, tabSize);
}
function generateBooleanProp(name, tabSize) {
    if (tabSize === void 0) { tabSize = 1; }
    return generateTab(tabSize) + name + ',\n';
}
function generateIntPropIfNotEmpty(name, val, defaultVal, isStatic, tabSize) {
    if (defaultVal === void 0) { defaultVal = 0; }
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    if (val !== defaultVal && val !== null && val !== undefined) {
        return generateIntProp(name, val, isStatic, tabSize);
    }
    return '';
}
function generateFloatPropIfNotEmpty(name, val, defaultVal, isStatic, tabSize) {
    if (defaultVal === void 0) { defaultVal = 0; }
    if (isStatic === void 0) { isStatic = null; }
    if (tabSize === void 0) { tabSize = 1; }
    if (Math.abs(val - defaultVal) > EPSILON) {
        return generateFloatProp(name, val, isStatic, tabSize);
    }
    return '';
}
function generateLineType(lineType) {
    switch (lineType) {
        case LineType.DontInterp:
            return 'DontInterp';
        case LineType.Linear:
            return 'Linear';
        case LineType.Bezier:
            return 'Bezier';
        case LineType.Hermite:
            return 'Hermite';
    }
    return '';
}
function generateAnimKeyFrame(key, tabSize, reverse) {
    if (tabSize === void 0) { tabSize = 2; }
    if (reverse === void 0) { reverse = false; }
    var res = generateTab(tabSize) + key.Frame + ': ' +
        (key.Vector.length === 1 ? generateNumber(key.Vector[0]) : generateArray(key.Vector, reverse)) + ',\n';
    if (key.InTan /* or OutTan */) {
        res += generateTab(tabSize + 1) + 'InTan ' +
            (key.InTan.length === 1 ? generateNumber(key.InTan[0]) : generateArray(key.InTan, reverse)) + ',\n';
        res += generateTab(tabSize + 1) + 'OutTan ' +
            (key.OutTan.length === 1 ? generateNumber(key.OutTan[0]) : generateArray(key.OutTan, reverse)) + ',\n';
    }
    return res;
}
function generateAnimVectorProp(name, val, defaultVal, tabSize, reverse) {
    if (defaultVal === void 0) { defaultVal = 0; }
    if (tabSize === void 0) { tabSize = 1; }
    if (reverse === void 0) { reverse = false; }
    if (val === null || val === undefined) {
        return '';
    }
    if (typeof val === 'number') {
        if (typeof defaultVal === 'number' && Math.abs(val - defaultVal) < EPSILON) {
            return '';
        }
        else {
            return generateFloatProp(name, val, true, tabSize);
        }
    }
    else {
        return generateBlockStart(name, val.Keys.length, tabSize) +
            generateBooleanProp(generateLineType(val.LineType), tabSize + 1) +
            (val.GlobalSeqId !== null ? generateIntProp('GlobalSeqId', val.GlobalSeqId, null, tabSize + 1) : '') +
            val.Keys.map(function (key) { return generateAnimKeyFrame(key, tabSize + 1, reverse); }).join('') +
            generateBlockEnd(tabSize);
    }
}
function generateVersion$1(model) {
    return generateBlockStart('Version') +
        generateIntProp('FormatVersion', model.Version) +
        generateBlockEnd();
}
function generateModel(model) {
    return generateBlockStart('Model', model.Info.Name) +
        generateIntPropIfNotEmpty('NumGeosets', model.Geosets.length) +
        generateIntPropIfNotEmpty('NumGeosetAnims', model.GeosetAnims.length) +
        generateIntPropIfNotEmpty('NumHelpers', model.Helpers.length) +
        generateIntPropIfNotEmpty('NumBones', model.Bones.length) +
        (model.Lights.length ? generateIntPropIfNotEmpty('NumLights', model.Lights.length) : '') +
        generateIntPropIfNotEmpty('NumAttachments', model.Attachments.length) +
        generateIntPropIfNotEmpty('NumEvents', model.EventObjects.length) +
        generateIntPropIfNotEmpty('NumParticleEmitters', model.ParticleEmitters.length) +
        (model.ParticleEmitters2.length ?
            generateIntPropIfNotEmpty('NumParticleEmitters2', model.ParticleEmitters2.length) :
            '') +
        (model.RibbonEmitters.length ?
            generateIntPropIfNotEmpty('NumRibbonEmitters', model.RibbonEmitters.length) :
            '') +
        generateIntProp('BlendTime', model.Info.BlendTime) +
        generateFloatArrayProp('MinimumExtent', model.Info.MinimumExtent) +
        generateFloatArrayProp('MaximumExtent', model.Info.MaximumExtent) +
        generateFloatPropIfNotEmpty('BoundsRadius', model.Info.BoundsRadius) +
        generateBlockEnd();
}
function generateSequences$1(model) {
    return generateBlockStart('Sequences', model.Sequences.length) +
        model.Sequences.map(generateSequenceChunk).join('') +
        generateBlockEnd();
}
function generateSequenceChunk(sequence) {
    return generateBlockStart('Anim', sequence.Name, 1) +
        generateUIntArrayProp('Interval', sequence.Interval, null, 2) +
        generateFloatPropIfNotEmpty('Rarity', sequence.Rarity, 0, null, 2) +
        generateFloatPropIfNotEmpty('MoveSpeed', sequence.MoveSpeed, 0, null, 2) +
        (sequence.NonLooping ? generateBooleanProp('NonLooping', 2) : '') +
        generateFloatArrayProp('MinimumExtent', sequence.MinimumExtent, null, 2) +
        generateFloatArrayProp('MaximumExtent', sequence.MaximumExtent, null, 2) +
        generateFloatPropIfNotEmpty('BoundsRadius', sequence.BoundsRadius, 0, null, 2) +
        generateBlockEnd(1);
}
function generateGlobalSequences$1(model) {
    if (!model.GlobalSequences || !model.GlobalSequences.length) {
        return '';
    }
    return generateBlockStart('GlobalSequences', model.GlobalSequences.length) +
        model.GlobalSequences.map(function (duration) { return generateIntProp('Duration', duration); }).join('') +
        generateBlockEnd();
}
function generateTextures$1(model) {
    if (!model.Textures.length) {
        return '';
    }
    return generateBlockStart('Textures', model.Textures.length) +
        model.Textures.map(generateTextureChunk).join('') +
        generateBlockEnd();
}
function generateTextureChunk(texture) {
    return generateBlockStart('Bitmap', null, 1) +
        generateWrappedStringProp('Image', texture.Image, null, 2) +
        generateIntPropIfNotEmpty('ReplaceableId', texture.ReplaceableId, 0, null, 2) +
        (texture.Flags & TextureFlags.WrapWidth ? generateBooleanProp('WrapWidth', 2) : '') +
        (texture.Flags & TextureFlags.WrapHeight ? generateBooleanProp('WrapHeight', 2) : '') +
        generateBlockEnd(1);
}
function generateMaterials$1(model) {
    if (!model.Materials.length) {
        return '';
    }
    return generateBlockStart('Materials', model.Materials.length) +
        model.Materials.map(function (it) { return generateMaterialChunk(model, it); }).join('') +
        generateBlockEnd();
}
function generateMaterialChunk(model, material) {
    var shader = '';
    if (model.Version >= 900 && model.Version < 1100 && material.Shader) {
        shader = generateWrappedStringProp('Shader', material.Shader, false, 2);
    }
    return generateBlockStart('Material', null, 1) +
        (material.RenderMode & MaterialRenderMode.ConstantColor ? generateBooleanProp('ConstantColor', 2) : '') +
        (material.RenderMode & MaterialRenderMode.SortPrimsFarZ ? generateBooleanProp('SortPrimsFarZ', 2) : '') +
        (material.RenderMode & MaterialRenderMode.FullResolution ? generateBooleanProp('FullResolution', 2) : '') +
        generateIntPropIfNotEmpty('PriorityPlane', material.PriorityPlane, 0, null, 2) +
        generateIntPropIfNotEmpty('RenderMode', material.RenderMode, 0, null, 2) +
        shader +
        material.Layers.map(function (it) { return generateLayerChunk(model, it); }).join('') +
        generateBlockEnd(1);
}
function generateFilterMode(filterMode) {
    switch (filterMode) {
        case FilterMode.None:
            return 'None';
        case FilterMode.Transparent:
            return 'Transparent';
        case FilterMode.Blend:
            return 'Blend';
        case FilterMode.Additive:
            return 'Additive';
        case FilterMode.AddAlpha:
            return 'AddAlpha';
        case FilterMode.Modulate:
            return 'Modulate';
        case FilterMode.Modulate2x:
            return 'Modulate2x';
    }
    return '';
}
function generateLayerChunk(model, layer) {
    var middle = '';
    if (model.Version >= 900) {
        middle += (layer.EmissiveGain !== undefined ? generateAnimVectorProp('EmissiveGain', layer.EmissiveGain, 1, 3) : '');
        if (model.Version >= 1000) {
            middle += (layer.FresnelColor !== undefined ? generateColorProp('FresnelColor', layer.FresnelColor, true, 3) : '');
            middle += (layer.FresnelOpacity !== undefined ? generateAnimVectorProp('FresnelOpacity', layer.FresnelOpacity, 0, 3) : '');
            middle += (layer.FresnelTeamColor !== undefined ? generateAnimVectorProp('FresnelTeamColor', layer.FresnelTeamColor, 0, 3) : '');
        }
    }
    if (model.Version >= 1100) {
        middle += generateIntProp('ShaderTypeId', layer.ShaderTypeId || 0, null, 3);
        LAYER_TEXTURE_ID_MAP.slice(1).forEach(function (name) {
            var val = layer[name];
            if (val !== undefined) {
                middle += generateAnimVectorProp(name, val, null, 3);
            }
        });
    }
    return generateBlockStart('Layer', null, 2) +
        generateStringProp('FilterMode', generateFilterMode(layer.FilterMode), null, 3) +
        (layer.Alpha !== undefined ? generateAnimVectorProp('Alpha', layer.Alpha, 1, 3) : '') +
        (layer.TextureID !== undefined ? generateAnimVectorProp('TextureID', layer.TextureID, null, 3) : '') +
        (layer.Shading & LayerShading.TwoSided ? generateBooleanProp('TwoSided', 3) : '') +
        (layer.Shading & LayerShading.Unshaded ? generateBooleanProp('Unshaded', 3) : '') +
        (layer.Shading & LayerShading.Unfogged ? generateBooleanProp('Unfogged', 3) : '') +
        (layer.Shading & LayerShading.SphereEnvMap ? generateBooleanProp('SphereEnvMap', 3) : '') +
        (layer.Shading & LayerShading.NoDepthTest ? generateBooleanProp('NoDepthTest', 3) : '') +
        (layer.Shading & LayerShading.NoDepthSet ? generateBooleanProp('NoDepthSet', 3) : '') +
        generateIntPropIfNotEmpty('CoordId', layer.CoordId, 0, null, 3) +
        generateIntPropIfNotEmpty('TVertexAnimId', layer.TVertexAnimId, null, null, 3) +
        middle +
        generateBlockEnd(2);
}
function generateTextureAnims$1(model) {
    if (!model.TextureAnims.length) {
        return '';
    }
    return generateBlockStart('TextureAnims', model.TextureAnims.length) +
        model.TextureAnims.map(generateTextureAnimChunk).join('') +
        generateBlockEnd();
}
function generateTextureAnimChunk(textureAnim) {
    return generateBlockStart('TVertexAnim', null, 1) +
        (textureAnim.Translation ? generateAnimVectorProp('Translation', textureAnim.Translation, null, 2) : '') +
        (textureAnim.Rotation ? generateAnimVectorProp('Rotation', textureAnim.Rotation, null, 2) : '') +
        (textureAnim.Scaling ? generateAnimVectorProp('Scaling', textureAnim.Scaling, null, 2) : '') +
        generateBlockEnd(1);
}
function generateGeosets$1(model) {
    if (!model.Geosets.length) {
        return '';
    }
    return model.Geosets.map(function (it) { return generateGeosetChunk(model, it); }).join('');
}
function generateGeosetChunk(model, geoset) {
    var middle = '';
    if (model.Version >= 900) {
        middle += (geoset.LevelOfDetail !== undefined ? generateIntProp('LevelOfDetail', geoset.LevelOfDetail) : '') +
            (geoset.Name ? generateWrappedStringProp('Name', geoset.Name) : '') +
            (geoset.Tangents ? generateGeosetArray('Tangents', geoset.Tangents, 4) : '') +
            (geoset.SkinWeights ? generateGeosetArray('SkinWeights', geoset.SkinWeights, 8) : '');
    }
    return generateBlockStart('Geoset') +
        generateGeosetArray('Vertices', geoset.Vertices, 3) +
        generateGeosetArray('Normals', geoset.Normals, 3) +
        generateGeosetArray('TVertices', geoset.TVertices[0], 2) +
        generateGeosetVertexGroup(geoset.VertexGroup) +
        generateGeosetFaces(geoset.Faces) +
        generateGeosetGroups(geoset.Groups) +
        generateFloatArrayProp('MinimumExtent', geoset.MinimumExtent) +
        generateFloatArrayProp('MaximumExtent', geoset.MaximumExtent) +
        generateFloatPropIfNotEmpty('BoundsRadius', geoset.BoundsRadius) +
        generateGeosetAnimInfos(geoset.Anims) +
        generateIntProp('MaterialID', geoset.MaterialID) +
        generateIntProp('SelectionGroup', geoset.SelectionGroup) +
        (geoset.Unselectable ? generateBooleanProp('Unselectable') : '') +
        middle +
        generateBlockEnd();
}
function generateGeosetArray(name, arr, elemLength) {
    var middle = '';
    var elemCount = arr.length / elemLength;
    for (var i = 0; i < elemCount; ++i) {
        middle += generateTab(2) + generateArray(arr.slice(i * elemLength, (i + 1) * elemLength)) + ',\n';
    }
    return generateBlockStart(name, elemCount, 1) +
        middle +
        generateBlockEnd(1);
}
function generateGeosetVertexGroup(arr) {
    if (!arr.length) {
        return '';
    }
    var middle = '';
    for (var i = 0; i < arr.length; ++i) {
        middle += generateTab(2) + arr[i] + ',\n';
    }
    return generateBlockStart('VertexGroup', null, 1) +
        middle +
        generateBlockEnd(1);
}
function generateGeosetFaces(arr) {
    return generateBlockStart("Faces 1 ".concat(arr.length), null, 1) +
        generateBlockStart('Triangles', null, 2) +
        generateTab(3) + generateUIntArray(arr) + ',\n' +
        generateBlockEnd(2) +
        generateBlockEnd(1);
}
function generateGeosetGroups(groups) {
    var totalMatrices = 0;
    var middle = '';
    for (var _i = 0, groups_1 = groups; _i < groups_1.length; _i++) {
        var group = groups_1[_i];
        totalMatrices += group.length;
        middle += generateTab(2) + 'Matrices ' + generateUIntArray(group) + ',\n';
    }
    return generateBlockStart("Groups ".concat(groups.length, " ").concat(totalMatrices), null, 1) +
        middle +
        generateBlockEnd(1);
}
function generateGeosetAnimInfos(anims) {
    if (!anims) {
        return '';
    }
    return anims.map(generateGeosetAnimInfoChunk).join('');
}
function generateGeosetAnimInfoChunk(anim) {
    return generateBlockStart('Anim', null, 1) +
        generateFloatArrayProp('MinimumExtent', anim.MinimumExtent, null, 2) +
        generateFloatArrayProp('MaximumExtent', anim.MaximumExtent, null, 2) +
        generateFloatPropIfNotEmpty('BoundsRadius', anim.BoundsRadius, 0, null, 2) +
        generateBlockEnd(1);
}
function generateGeosetAnims$1(model) {
    if (!model.GeosetAnims.length) {
        return '';
    }
    return model.GeosetAnims.map(generateGeosetAnimChunk).join('');
}
function generateColorProp(name, color, isStatic, tabSize) {
    if (tabSize === void 0) { tabSize = 1; }
    if (color) {
        if (color instanceof Float32Array) {
            if (!isStatic || isNotEmptyVec3(color, 1)) {
                var middle = '';
                for (var i = 2; i >= 0; --i) {
                    if (i < 2) {
                        middle += ', ';
                    }
                    middle += generateNumber(color[i]);
                }
                return "".concat(generateTab(tabSize)).concat(isStatic ? 'static ' : '').concat(name, " { ").concat(middle, " },\n");
            }
        }
        else {
            return generateAnimVectorProp(name, color, null, tabSize, true);
        }
    }
    return '';
}
function generateGeosetAnimChunk(geosetAnim) {
    return generateBlockStart('GeosetAnim') +
        generateIntProp('GeosetId', geosetAnim.GeosetId) +
        generateAnimVectorProp('Alpha', geosetAnim.Alpha, 1) +
        generateColorProp('Color', geosetAnim.Color, true) +
        (geosetAnim.Flags & GeosetAnimFlags.DropShadow ? generateBooleanProp('DropShadow') : '') +
        generateBlockEnd();
}
function generateNodeProps(node) {
    return generateIntProp('ObjectId', node.ObjectId) +
        generateIntPropIfNotEmpty('Parent', node.Parent, null) +
        generateNodeDontInherit(node.Flags) +
        (node.Flags & NodeFlags.Billboarded ? generateBooleanProp('Billboarded') : '') +
        (node.Flags & NodeFlags.BillboardedLockX ? generateBooleanProp('BillboardedLockX') : '') +
        (node.Flags & NodeFlags.BillboardedLockY ? generateBooleanProp('BillboardedLockY') : '') +
        (node.Flags & NodeFlags.BillboardedLockZ ? generateBooleanProp('BillboardedLockZ') : '') +
        (node.Flags & NodeFlags.CameraAnchored ? generateBooleanProp('CameraAnchored') : '') +
        (node.Translation !== undefined ? generateAnimVectorProp('Translation', node.Translation) : '') +
        (node.Rotation !== undefined ? generateAnimVectorProp('Rotation', node.Rotation) : '') +
        (node.Scaling !== undefined ? generateAnimVectorProp('Scaling', node.Scaling) : '');
}
function generateNodeDontInherit(flags) {
    var flagsStrs = [];
    if (flags & NodeFlags.DontInheritTranslation) {
        flagsStrs.push('Translation');
    }
    if (flags & NodeFlags.DontInheritRotation) {
        flagsStrs.push('Rotation');
    }
    if (flags & NodeFlags.DontInheritScaling) {
        flagsStrs.push('Scaling');
    }
    if (!flagsStrs.length) {
        return '';
    }
    return generateTab(1) + 'DontInherit { ' + flagsStrs.join(', ') + ' },\n';
}
function generateBones$1(model) {
    if (!model.Bones.length) {
        return '';
    }
    return model.Bones.map(generateBoneChunk).join('');
}
function generateBoneChunk(bone) {
    return generateBlockStart('Bone', bone.Name) +
        generateNodeProps(bone) +
        (bone.GeosetId !== null ?
            generateIntProp('GeosetId', bone.GeosetId) :
            generateStringProp('GeosetId', 'Multiple')) +
        (bone.GeosetAnimId !== null ?
            generateIntProp('GeosetAnimId', bone.GeosetAnimId) :
            generateStringProp('GeosetAnimId', 'None')) +
        generateBlockEnd();
}
function generateLights$1(model) {
    if (!model.Lights.length) {
        return '';
    }
    return model.Lights.map(generateLightChunk).join('');
}
function generateLightChunk(light) {
    return generateBlockStart('Light', light.Name) +
        generateNodeProps(light) +
        generateBooleanProp(generateLightType(light.LightType)) +
        generateAnimVectorProp('AttenuationStart', light.AttenuationStart) +
        generateAnimVectorProp('AttenuationEnd', light.AttenuationEnd) +
        generateColorProp('Color', light.Color, true) +
        generateAnimVectorProp('Intensity', light.Intensity, null) +
        generateColorProp('AmbColor', light.AmbColor, true) +
        generateAnimVectorProp('AmbIntensity', light.AmbIntensity, null) +
        generateAnimVectorProp('Visibility', light.Visibility, 1) +
        generateBlockEnd();
}
function generateLightType(lightType) {
    switch (lightType) {
        case LightType.Omnidirectional:
            return 'Omnidirectional';
        case LightType.Directional:
            return 'Directional';
        case LightType.Ambient:
            return 'Ambient';
    }
    return '';
}
function generateHelpers$1(model) {
    return model.Helpers.map(generateHelperChunk).join('');
}
function generateHelperChunk(helper) {
    return generateBlockStart('Helper', helper.Name) +
        generateNodeProps(helper) +
        generateBlockEnd();
}
function generateAttachments$1(model) {
    return model.Attachments.map(generateAttachmentChunk).join('');
}
function generateAttachmentChunk(attachment) {
    return generateBlockStart('Attachment', attachment.Name) +
        generateNodeProps(attachment) +
        generateIntProp('AttachmentID', attachment.AttachmentID) +
        (attachment.Path ? generateWrappedStringProp('Path', attachment.Path) : '') +
        generateAnimVectorProp('Visibility', attachment.Visibility, 1) +
        generateBlockEnd();
}
function generatePivotPoints$1(model) {
    return generateBlockStart('PivotPoints', model.PivotPoints.length) +
        model.PivotPoints.map(function (point) { return "".concat(generateTab()).concat(generateArray(point), ",\n"); }).join('') +
        generateBlockEnd();
}
function generateParticleEmitters$1(model) {
    return model.ParticleEmitters.map(generateParticleEmitterChunk).join('');
}
function generateParticleEmitterChunk(emitter) {
    return generateBlockStart('ParticleEmitter', emitter.Name) +
        generateNodeProps(emitter) +
        (emitter.Flags & ParticleEmitterFlags.EmitterUsesMDL ? generateBooleanProp('EmitterUsesMDL') : '') +
        (emitter.Flags & ParticleEmitterFlags.EmitterUsesTGA ? generateBooleanProp('EmitterUsesTGA') : '') +
        generateAnimVectorProp('EmissionRate', emitter.EmissionRate) +
        generateAnimVectorProp('Gravity', emitter.Gravity) +
        generateAnimVectorProp('Longitude', emitter.Longitude) +
        generateAnimVectorProp('Latitude', emitter.Latitude) +
        generateAnimVectorProp('Visibility', emitter.Visibility) +
        generateBlockStart('Particle', null, 1) +
        generateAnimVectorProp('LifeSpan', emitter.LifeSpan, null, 2) +
        generateAnimVectorProp('InitVelocity', emitter.InitVelocity, null, 2) +
        generateWrappedStringProp('Path', emitter.Path, false, 2) +
        generateBlockEnd(1) +
        generateBlockEnd();
}
function generateParticleEmitters2$1(model) {
    return model.ParticleEmitters2.map(generateParticleEmitter2Chunk).join('');
}
function generateParticleEmitters2FilterMode(filterMode) {
    switch (filterMode) {
        case ParticleEmitter2FilterMode.Blend:
            return 'Blend';
        case ParticleEmitter2FilterMode.Additive:
            return 'Additive';
        case ParticleEmitter2FilterMode.Modulate:
            return 'Modulate';
        case ParticleEmitter2FilterMode.Modulate2x:
            return 'Modulate2x';
        case ParticleEmitter2FilterMode.AlphaKey:
            return 'AlphaKey';
    }
    return '';
}
function generateSegmentColor(colors) {
    return generateBlockStart('SegmentColor', null, 1) +
        colors.map(function (color) { return generateColorProp('Color', color, false, 2); }).join('') +
        generateTab() + '},\n';
}
function generateParticleEmitter2FrameFlags(frameFlags) {
    if (frameFlags & ParticleEmitter2FramesFlags.Head && frameFlags & ParticleEmitter2FramesFlags.Tail) {
        return 'Both';
    }
    else if (frameFlags & ParticleEmitter2FramesFlags.Head) {
        return 'Head';
    }
    else if (frameFlags & ParticleEmitter2FramesFlags.Tail) {
        return 'Tail';
    }
    return '';
}
function generateParticleEmitter2Chunk(particleEmitter2) {
    return generateBlockStart('ParticleEmitter2', particleEmitter2.Name) +
        generateNodeProps(particleEmitter2) +
        generateBooleanProp(generateParticleEmitters2FilterMode(particleEmitter2.FilterMode)) +
        generateAnimVectorProp('Speed', particleEmitter2.Speed, null) +
        generateAnimVectorProp('Variation', particleEmitter2.Variation, null) +
        generateAnimVectorProp('Latitude', particleEmitter2.Latitude, null) +
        generateAnimVectorProp('Gravity', particleEmitter2.Gravity, null) +
        generateAnimVectorProp('EmissionRate', particleEmitter2.EmissionRate, null) +
        generateAnimVectorProp('Width', particleEmitter2.Width, null) +
        generateAnimVectorProp('Length', particleEmitter2.Length, null) +
        generateAnimVectorProp('Visibility', particleEmitter2.Visibility, 1) +
        generateSegmentColor(particleEmitter2.SegmentColor) +
        generateUIntArrayProp('Alpha', particleEmitter2.Alpha) +
        generateFloatArrayProp('ParticleScaling', particleEmitter2.ParticleScaling) +
        generateFloatArrayProp('LifeSpanUVAnim', particleEmitter2.LifeSpanUVAnim) +
        generateFloatArrayProp('DecayUVAnim', particleEmitter2.DecayUVAnim) +
        generateFloatArrayProp('TailUVAnim', particleEmitter2.TailUVAnim) +
        generateFloatArrayProp('TailDecayUVAnim', particleEmitter2.TailDecayUVAnim) +
        generateIntPropIfNotEmpty('Rows', particleEmitter2.Rows, 0) +
        generateIntPropIfNotEmpty('Columns', particleEmitter2.Columns, 0) +
        generateIntProp('TextureID', particleEmitter2.TextureID) +
        generateIntPropIfNotEmpty('Time', particleEmitter2.Time, 0) +
        generateIntPropIfNotEmpty('LifeSpan', particleEmitter2.LifeSpan, 0) +
        generateIntPropIfNotEmpty('TailLength', particleEmitter2.TailLength, 0) +
        generateIntPropIfNotEmpty('PriorityPlane', particleEmitter2.PriorityPlane, 0) +
        generateIntPropIfNotEmpty('ReplaceableId', particleEmitter2.ReplaceableId, null) +
        (particleEmitter2.Flags & ParticleEmitter2Flags.SortPrimsFarZ ? generateBooleanProp('SortPrimsFarZ') : '') +
        (particleEmitter2.Flags & ParticleEmitter2Flags.LineEmitter ? generateBooleanProp('LineEmitter') : '') +
        (particleEmitter2.Flags & ParticleEmitter2Flags.ModelSpace ? generateBooleanProp('ModelSpace') : '') +
        (particleEmitter2.Flags & ParticleEmitter2Flags.Unshaded ? generateBooleanProp('Unshaded') : '') +
        (particleEmitter2.Flags & ParticleEmitter2Flags.Unfogged ? generateBooleanProp('Unfogged') : '') +
        (particleEmitter2.Flags & ParticleEmitter2Flags.XYQuad ? generateBooleanProp('XYQuad') : '') +
        (particleEmitter2.Squirt ? generateBooleanProp('Squirt') : '') +
        generateBooleanProp(generateParticleEmitter2FrameFlags(particleEmitter2.FrameFlags)) +
        generateBlockEnd();
}
function generateRibbonEmitters$1(model) {
    return model.RibbonEmitters.map(generateRibbonEmitterChunk).join('');
}
function generateRibbonEmitterChunk(ribbonEmitter) {
    return generateBlockStart('RibbonEmitter', ribbonEmitter.Name) +
        generateNodeProps(ribbonEmitter) +
        generateAnimVectorProp('HeightAbove', ribbonEmitter.HeightAbove, null) +
        generateAnimVectorProp('HeightBelow', ribbonEmitter.HeightBelow, null) +
        generateAnimVectorProp('Alpha', ribbonEmitter.Alpha, null) +
        generateColorProp('Color', ribbonEmitter.Color, true) +
        generateAnimVectorProp('TextureSlot', ribbonEmitter.TextureSlot, null) +
        generateAnimVectorProp('Visibility', ribbonEmitter.Visibility, 1) +
        generateIntProp('EmissionRate', ribbonEmitter.EmissionRate) +
        generateIntProp('LifeSpan', ribbonEmitter.LifeSpan) +
        generateIntPropIfNotEmpty('Gravity', ribbonEmitter.Gravity, 0) +
        generateIntProp('Rows', ribbonEmitter.Rows) +
        generateIntProp('Columns', ribbonEmitter.Columns) +
        generateIntProp('MaterialID', ribbonEmitter.MaterialID) +
        generateBlockEnd();
}
function generateEventObjects$1(model) {
    return model.EventObjects.map(generateEventObjectChunk).join('');
}
function generateEventTrack(eventTrack) {
    var middle = '';
    for (var i = 0; i < eventTrack.length; ++i) {
        middle += generateTab(2) + eventTrack[i] + ',\n';
    }
    return generateBlockStart('EventTrack', eventTrack.length, 1) +
        middle +
        generateBlockEnd(1);
}
function generateEventObjectChunk(eventObject) {
    return generateBlockStart('EventObject', eventObject.Name) +
        generateNodeProps(eventObject) +
        generateEventTrack(eventObject.EventTrack) +
        generateBlockEnd();
}
function generateCameras$1(model) {
    return model.Cameras.map(generateCameraChunk).join('');
}
function generateCameraChunk(camera) {
    return generateBlockStart('Camera', camera.Name) +
        generateFloatProp('FieldOfView', camera.FieldOfView) +
        generateFloatProp('FarClip', camera.FarClip) +
        generateFloatProp('NearClip', camera.NearClip) +
        generateFloatArrayProp('Position', camera.Position) +
        generateAnimVectorProp('Translation', camera.Translation) +
        generateAnimVectorProp('Rotation', camera.Rotation) +
        generateBlockStart('Target', null, 1) +
        generateFloatArrayProp('Position', camera.TargetPosition, null, 2) +
        generateAnimVectorProp('Translation', camera.TargetTranslation, null, 2) +
        generateBlockEnd(1) +
        generateBlockEnd();
}
function generateCollisionShapes$1(model) {
    return model.CollisionShapes.map(generateCollisionShapeChunk).join('');
}
function generateCollisionShapeChunk(collisionShape) {
    var middle = '';
    if (collisionShape.Shape === CollisionShapeType.Box) {
        middle = generateBooleanProp('Box');
        middle += generateBlockStart('Vertices', 2, 1) +
            generateTab(2) + generateArray(collisionShape.Vertices.slice(0, 3)) + ',\n' +
            generateTab(2) + generateArray(collisionShape.Vertices.slice(3, 6)) + ',\n' +
            generateBlockEnd(1);
    }
    else {
        middle = generateBooleanProp('Sphere');
        middle += generateBlockStart('Vertices', 1, 1) +
            generateTab(2) + generateArray(collisionShape.Vertices) + ',\n' +
            generateBlockEnd(1) +
            generateFloatProp('BoundsRadius', collisionShape.BoundsRadius);
    }
    return generateBlockStart('CollisionShape', collisionShape.Name) +
        generateNodeProps(collisionShape) +
        middle +
        generateBlockEnd();
}
function generateFaceFX$1(model) {
    if (model.Version < 900 || !model.FaceFX) {
        return '';
    }
    return model.FaceFX.map(generateFaceFXChunk).join('');
}
function generateFaceFXChunk(faceFX) {
    return generateBlockStart('FaceFX', faceFX.Name) +
        generateWrappedStringProp('Path', faceFX.Path) +
        generateBlockEnd();
}
function generateBindPose(model) {
    if (model.Version < 900 || !model.BindPoses) {
        return '';
    }
    return model.BindPoses.map(generateBindPoseChunk).join('');
}
function generateBindPoseChunk(bindPose) {
    var middle = generateBlockStart('Matrices', bindPose.Matrices.length, 1) +
        bindPose.Matrices.map(function (item) {
            return generateTab(2) + generateArray(item) + ',';
        }).join('\n') + '\n' +
        generateBlockEnd(1);
    return generateBlockStart('BindPose') +
        middle +
        generateBlockEnd();
}
function generateParticleEmitterPopcorn(model) {
    if (model.Version < 900 || !model.ParticleEmitterPopcorns) {
        return '';
    }
    return model.ParticleEmitterPopcorns.map(generateParticleEmitterPopcornChunk).join('');
}
function generateParticleEmitterPopcornChunk(emitter) {
    return generateBlockStart('ParticleEmitterPopcorn', emitter.Name) +
        generateNodeProps(emitter) +
        (emitter.Flags & ParticleEmitterPopcornFlags.Unshaded ? generateBooleanProp('Unshaded') : '') +
        (emitter.Flags & ParticleEmitterPopcornFlags.SortPrimsFarZ ? generateBooleanProp('SortPrimsFarZ') : '') +
        (emitter.Flags & ParticleEmitterPopcornFlags.Unfogged ? generateBooleanProp('Unfogged') : '') +
        generateAnimVectorProp('LifeSpan', emitter.LifeSpan, null) +
        generateAnimVectorProp('EmissionRate', emitter.EmissionRate, 0) +
        generateAnimVectorProp('Speed', emitter.Speed, 0) +
        generateColorProp('Color', emitter.Color, true) +
        generateAnimVectorProp('Alpha', emitter.Alpha, 1) +
        generateIntPropIfNotEmpty('ReplaceableId', emitter.ReplaceableId, 0, null) +
        generateWrappedStringProp('Path', emitter.Path, false) +
        generateWrappedStringProp('AnimVisibilityGuide', emitter.AnimVisibilityGuide, false) +
        generateAnimVectorProp('Visibility', emitter.Visibility) +
        generateBlockEnd();
}
var generators$1 = [
    generateVersion$1,
    generateModel,
    generateSequences$1,
    generateGlobalSequences$1,
    generateTextures$1,
    generateMaterials$1,
    generateTextureAnims$1,
    generateGeosets$1,
    generateGeosetAnims$1,
    generateBones$1,
    generateLights$1,
    generateHelpers$1,
    generateAttachments$1,
    generatePivotPoints$1,
    generateParticleEmitters$1,
    generateParticleEmitters2$1,
    generateRibbonEmitters$1,
    generateEventObjects$1,
    generateCameras$1,
    generateCollisionShapes$1,
    generateFaceFX$1,
    generateBindPose,
    generateParticleEmitterPopcorn
];
function generate$1(model) {
    var res = '';
    for (var _i = 0, generators_1 = generators$1; _i < generators_1.length; _i++) {
        var generator = generators_1[_i];
        res += generator(model);
    }
    return res;
}

var _a;
var BIG_ENDIAN = true;
var NONE = -1;
var Stream = /** @class */ (function () {
    function Stream(arrayBuffer) {
        this.ab = arrayBuffer;
        this.uint = new Uint8Array(this.ab);
        this.view = new DataView(this.ab);
        this.pos = 0;
    }
    Stream.prototype.keyword = function (keyword) {
        this.uint[this.pos] = keyword.charCodeAt(0);
        this.uint[this.pos + 1] = keyword.charCodeAt(1);
        this.uint[this.pos + 2] = keyword.charCodeAt(2);
        this.uint[this.pos + 3] = keyword.charCodeAt(3);
        this.pos += 4;
    };
    Stream.prototype.uint8 = function (num) {
        this.view.setUint8(this.pos, num);
        this.pos += 1;
    };
    Stream.prototype.uint16 = function (num) {
        this.view.setUint16(this.pos, num, BIG_ENDIAN);
        this.pos += 2;
    };
    Stream.prototype.int32 = function (num) {
        this.view.setInt32(this.pos, num, BIG_ENDIAN);
        this.pos += 4;
    };
    Stream.prototype.uint32 = function (num) {
        this.view.setUint32(this.pos, num, BIG_ENDIAN);
        this.pos += 4;
    };
    Stream.prototype.float32 = function (num) {
        this.view.setFloat32(this.pos, num, BIG_ENDIAN);
        this.pos += 4;
    };
    Stream.prototype.float32Array = function (arr) {
        for (var i = 0; i < arr.length; ++i) {
            this.float32(arr[i]);
        }
    };
    Stream.prototype.uint8Array = function (arr) {
        for (var i = 0; i < arr.length; ++i) {
            this.uint8(arr[i]);
        }
    };
    Stream.prototype.uint16Array = function (arr) {
        for (var i = 0; i < arr.length; ++i) {
            this.uint16(arr[i]);
        }
    };
    Stream.prototype.int32Array = function (arr) {
        for (var i = 0; i < arr.length; ++i) {
            this.int32(arr[i]);
        }
    };
    Stream.prototype.uint32Array = function (arr) {
        for (var i = 0; i < arr.length; ++i) {
            this.uint32(arr[i]);
        }
    };
    Stream.prototype.str = function (str, len) {
        for (var i = 0; i < len; ++i, ++this.pos) {
            this.uint[this.pos] = i < str.length ? str.charCodeAt(i) : 0;
        }
    };
    Stream.prototype.animVector = function (animVector, type) {
        var isInt = type === AnimVectorType.INT1;
        this.int32(animVector.Keys.length);
        this.int32(animVector.LineType);
        this.int32(animVector.GlobalSeqId !== null ? animVector.GlobalSeqId : NONE);
        for (var _i = 0, _a = animVector.Keys; _i < _a.length; _i++) {
            var keyFrame = _a[_i];
            this.int32(keyFrame.Frame);
            if (isInt) {
                this.int32Array(keyFrame.Vector);
            }
            else {
                this.float32Array(keyFrame.Vector);
            }
            if (animVector.LineType === LineType.Hermite || animVector.LineType === LineType.Bezier) {
                if (isInt) {
                    this.int32Array(keyFrame.InTan);
                    this.int32Array(keyFrame.OutTan);
                }
                else {
                    this.float32Array(keyFrame.InTan);
                    this.float32Array(keyFrame.OutTan);
                }
            }
        }
    };
    return Stream;
}());
function generateExtent(obj, stream) {
    stream.float32(obj.BoundsRadius || 0);
    for (var _i = 0, _a = ['MinimumExtent', 'MaximumExtent']; _i < _a.length; _i++) {
        var key = _a[_i];
        stream.float32Array(obj[key]);
    }
}
var AnimVectorType;
(function (AnimVectorType) {
    AnimVectorType[AnimVectorType["INT1"] = 0] = "INT1";
    AnimVectorType[AnimVectorType["FLOAT1"] = 1] = "FLOAT1";
    AnimVectorType[AnimVectorType["FLOAT3"] = 2] = "FLOAT3";
    AnimVectorType[AnimVectorType["FLOAT4"] = 3] = "FLOAT4";
})(AnimVectorType || (AnimVectorType = {}));
var animVectorSize = (_a = {},
    _a[AnimVectorType.INT1] = 1,
    _a[AnimVectorType.FLOAT1] = 1,
    _a[AnimVectorType.FLOAT3] = 3,
    _a[AnimVectorType.FLOAT4] = 4,
    _a);
function byteLengthAnimVector(animVector, type) {
    return 4 /* key count */ +
        4 /* LineType */ +
        4 /* GlobalSeqId */ +
        animVector.Keys.length * (4 /* frame */ +
            4 * animVectorSize[type] *
                (animVector.LineType === LineType.Hermite || animVector.LineType === LineType.Bezier ? 3 : 1));
}
function sum(arr) {
    return arr.reduce(function (a, b) {
        return a + b;
    }, 0);
}
function byteLengthVersion() {
    return 4 /* keyword */ +
        4 /* size */ +
        4 /* version */;
}
function generateVersion(model, stream) {
    stream.keyword('VERS');
    stream.int32(4);
    stream.int32(model.Version);
}
var MODEL_NAME_LENGTH = 0x150;
function byteLengthModelInfo() {
    return 4 /* keyword */ +
        4 /* size */ +
        MODEL_NAME_LENGTH +
        4 /* 4-byte zero ? */ +
        4 * 7 /* extent */ +
        4; /* blend time */
}
function generateModelInfo(model, stream) {
    stream.keyword('MODL');
    stream.int32(byteLengthModelInfo() - 8);
    stream.str(model.Info.Name, MODEL_NAME_LENGTH);
    stream.int32(0);
    generateExtent(model.Info, stream);
    stream.int32(model.Info.BlendTime);
}
var MODEL_SEQUENCE_NAME_LENGTH = 0x50;
function byteLengthSequence() {
    return MODEL_SEQUENCE_NAME_LENGTH +
        4 * 2 /* interval */ +
        4 /* MoveSpeed */ +
        4 /* NonLooping */ +
        4 /* Rarity */ +
        4 +
        4 * 7; /* extent */
}
function byteLengthSequences(model) {
    if (!model.Sequences.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Sequences.map(byteLengthSequence));
}
function generateSequences(model, stream) {
    if (!model.Sequences.length) {
        return;
    }
    stream.keyword('SEQS');
    stream.int32(byteLengthSequences(model) - 8);
    for (var _i = 0, _a = model.Sequences; _i < _a.length; _i++) {
        var sequence = _a[_i];
        stream.str(sequence.Name, MODEL_SEQUENCE_NAME_LENGTH);
        stream.int32(sequence.Interval[0]);
        stream.int32(sequence.Interval[1]);
        stream.float32(sequence.MoveSpeed);
        stream.int32(sequence.NonLooping ? 1 : 0);
        stream.float32(sequence.Rarity);
        stream.int32(0);
        generateExtent(sequence, stream);
    }
}
function byteLengthGlobalSequences(model) {
    if (!model.GlobalSequences || !model.GlobalSequences.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        4 * model.GlobalSequences.length;
}
function generateGlobalSequences(model, stream) {
    if (!model.GlobalSequences || !model.GlobalSequences.length) {
        return;
    }
    stream.keyword('GLBS');
    stream.int32(model.GlobalSequences.length * 4);
    for (var _i = 0, _a = model.GlobalSequences; _i < _a.length; _i++) {
        var duration = _a[_i];
        stream.int32(duration);
    }
}
function byteLengthLayer(model, layer) {
    return 4 /* size */ +
        4 /* FilterMode */ +
        4 /* Shading */ +
        4 /* static TextureID */ +
        4 /* TVertexAnimId */ +
        4 +
        4 /* static Alpha */ +
        (model.Version >= 900 ? 4 : 0) /* EmissiveGain */ +
        (model.Version >= 1000 ?
            4 * 3 /* FresnelColor */ +
                4 /* FresnelOpacity */ +
                4 /* FresnelTeamColor */ :
            0) +
        (model.Version >= 1100 ?
            4 /* ShaderTypeId */ +
                4 /* textureCount */ +
                LAYER_TEXTURE_ID_MAP.reduce(function (acc, name) {
                    return acc + (typeof layer[name] !== 'undefined' ?
                        4 /* textureId */ +
                            4 /* textureType */ +
                            (typeof layer[name] === 'object' ?
                                4 /* keyword */ + byteLengthAnimVector(layer[name], AnimVectorType.INT1) :
                                0) :
                        0);
                }, 0) :
            0) +
        (layer.Alpha !== null && typeof layer.Alpha !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(layer.Alpha, AnimVectorType.FLOAT1) :
            0) +
        (model.Version < 1100 && layer.TextureID !== null && typeof layer.TextureID !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(layer.TextureID, AnimVectorType.INT1) :
            0) +
        (model.Version >= 900 && layer.EmissiveGain !== undefined && layer.EmissiveGain !== null && typeof layer.EmissiveGain !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(layer.EmissiveGain, AnimVectorType.FLOAT1) :
            0) +
        (model.Version >= 1000 && layer.FresnelColor !== undefined && layer.FresnelColor !== null && !(layer.FresnelColor instanceof Float32Array) ?
            4 /* keyword */ + byteLengthAnimVector(layer.FresnelColor, AnimVectorType.FLOAT3) :
            0) +
        (model.Version >= 1000 && layer.FresnelOpacity !== undefined && layer.FresnelOpacity !== null && typeof layer.FresnelOpacity !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(layer.FresnelOpacity, AnimVectorType.FLOAT1) :
            0) +
        (model.Version >= 1000 && layer.FresnelTeamColor !== undefined && layer.FresnelTeamColor !== null && typeof layer.FresnelTeamColor !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(layer.FresnelTeamColor, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthMaterial(model, material) {
    return 4 /* size */ +
        4 /* PriorityPlane */ +
        4 /* RenderMode */ +
        4 /* LAYS keyword */ +
        4 /* layer count */ +
        (model.Version >= 900 && model.Version < 1100 ? 80 : 0) /* Shader */ +
        sum(material.Layers.map(function (layer) { return byteLengthLayer(model, layer); }));
}
function byteLengthMaterials(model) {
    if (!model.Materials.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Materials.map(function (material) { return byteLengthMaterial(model, material); }));
}
function generateMaterials(model, stream) {
    if (!model.Materials.length) {
        return;
    }
    stream.keyword('MTLS');
    stream.int32(byteLengthMaterials(model) - 8);
    for (var _i = 0, _a = model.Materials; _i < _a.length; _i++) {
        var material = _a[_i];
        stream.int32(byteLengthMaterial(model, material));
        stream.int32(material.PriorityPlane);
        stream.int32(material.RenderMode);
        if (model.Version >= 900 && model.Version < 1100) {
            stream.str(material.Shader || '', 80);
        }
        stream.keyword('LAYS');
        stream.int32(material.Layers.length);
        var _loop_1 = function (layer) {
            stream.int32(byteLengthLayer(model, layer));
            stream.int32(layer.FilterMode);
            stream.int32(layer.Shading);
            stream.int32(model.Version < 1100 && typeof layer.TextureID === 'number' ? layer.TextureID : 0);
            stream.int32(layer.TVertexAnimId !== null ? layer.TVertexAnimId : NONE);
            stream.int32(layer.CoordId);
            stream.float32(typeof layer.Alpha === 'number' ? layer.Alpha : 1);
            if (model.Version >= 900) {
                stream.float32(typeof layer.EmissiveGain === 'number' ? layer.EmissiveGain : 1);
                if (model.Version >= 1000) {
                    stream.float32Array(layer.FresnelColor instanceof Float32Array ? layer.FresnelColor : new Float32Array([1, 1, 1]));
                    stream.float32(typeof layer.FresnelOpacity === 'number' ? layer.FresnelOpacity : 0);
                    stream.float32(typeof layer.FresnelTeamColor === 'number' ? layer.FresnelTeamColor : 0);
                }
            }
            if (model.Version >= 1100) {
                stream.int32(layer.ShaderTypeId || 0);
                var textures = LAYER_TEXTURE_ID_MAP.filter(function (name) { return layer[name] !== undefined; }).length;
                stream.int32(textures);
                for (var i = 0; i < LAYER_TEXTURE_ID_MAP.length; ++i) {
                    var id = layer[LAYER_TEXTURE_ID_MAP[i]];
                    if (id === undefined) {
                        continue;
                    }
                    stream.int32(typeof id === 'number' ? id : 0);
                    stream.int32(typeof id === 'number' ? i : 0); // ?
                    if (typeof id === 'object') {
                        stream.keyword('KMTF');
                        stream.animVector(id, AnimVectorType.INT1);
                    }
                }
            }
            if (layer.Alpha && typeof layer.Alpha !== 'number') {
                stream.keyword('KMTA');
                stream.animVector(layer.Alpha, AnimVectorType.FLOAT1);
            }
            if (model.Version < 1100 && layer.TextureID && typeof layer.TextureID !== 'number') {
                stream.keyword('KMTF');
                stream.animVector(layer.TextureID, AnimVectorType.INT1);
            }
            if (model.Version >= 900 && layer.EmissiveGain && typeof layer.EmissiveGain !== 'number') {
                stream.keyword('KMTE');
                stream.animVector(layer.EmissiveGain, AnimVectorType.FLOAT1);
            }
            if (model.Version >= 1000 && layer.FresnelColor && !(layer.FresnelColor instanceof Float32Array)) {
                stream.keyword('KFC3');
                stream.animVector(layer.FresnelColor, AnimVectorType.FLOAT3);
            }
            if (model.Version >= 1000 && layer.FresnelOpacity && typeof layer.FresnelOpacity !== 'number') {
                stream.keyword('KFCA');
                stream.animVector(layer.FresnelOpacity, AnimVectorType.FLOAT1);
            }
            if (model.Version >= 1000 && layer.FresnelTeamColor && typeof layer.FresnelTeamColor !== 'number') {
                stream.keyword('KFTC');
                stream.animVector(layer.FresnelTeamColor, AnimVectorType.FLOAT1);
            }
        };
        for (var _b = 0, _c = material.Layers; _b < _c.length; _b++) {
            var layer = _c[_b];
            _loop_1(layer);
        }
    }
}
var MODEL_TEXTURE_PATH_LENGTH = 0x100;
function byteLengthTexture() {
    return 4 /* ReplaceableId */ +
        MODEL_TEXTURE_PATH_LENGTH +
        4 /* str trailing zero ? */ +
        4 /* Flags */;
}
function byteLengthTextures(model) {
    if (!model.Textures.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Textures.map(function (_texture) { return byteLengthTexture(); }));
}
function generateTextures(model, stream) {
    if (!model.Textures.length) {
        return;
    }
    stream.keyword('TEXS');
    stream.int32(byteLengthTextures(model) - 8);
    for (var _i = 0, _a = model.Textures; _i < _a.length; _i++) {
        var texture = _a[_i];
        stream.int32(texture.ReplaceableId);
        stream.str(texture.Image, MODEL_TEXTURE_PATH_LENGTH);
        stream.int32(0);
        stream.int32(texture.Flags);
    }
}
function byteLengthTextureAnim(anim) {
    return 4 /* size */ +
        (anim.Translation ? 4 /* keyword */ + byteLengthAnimVector(anim.Translation, AnimVectorType.FLOAT3) : 0) +
        (anim.Rotation ? 4 /* keyword */ + byteLengthAnimVector(anim.Rotation, AnimVectorType.FLOAT4) : 0) +
        (anim.Scaling ? 4 /* keyword */ + byteLengthAnimVector(anim.Scaling, AnimVectorType.FLOAT3) : 0);
}
function byteLengthTextureAnims(model) {
    if (!model.TextureAnims || !model.TextureAnims.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.TextureAnims.map(function (anim) { return byteLengthTextureAnim(anim); }));
}
function generateTextureAnims(model, stream) {
    if (!model.TextureAnims || !model.TextureAnims.length) {
        return;
    }
    stream.keyword('TXAN');
    stream.int32(byteLengthTextureAnims(model) - 8);
    for (var _i = 0, _a = model.TextureAnims; _i < _a.length; _i++) {
        var anim = _a[_i];
        stream.int32(byteLengthTextureAnim(anim));
        if (anim.Translation) {
            stream.keyword('KTAT');
            stream.animVector(anim.Translation, AnimVectorType.FLOAT3);
        }
        if (anim.Rotation) {
            stream.keyword('KTAR');
            stream.animVector(anim.Rotation, AnimVectorType.FLOAT4);
        }
        if (anim.Scaling) {
            stream.keyword('KTAS');
            stream.animVector(anim.Scaling, AnimVectorType.FLOAT3);
        }
    }
}
function byteLengthGeoset(model, geoset) {
    var _a, _b;
    return 4 /* size */ +
        4 /* VRTX keyword */ +
        4 /* vertices count */ +
        4 * geoset.Vertices.length /* vertices data */ +
        4 /* NRMS keyword */ +
        4 /* normals count */ +
        4 * geoset.Normals.length /* normals data */ +
        4 /* PTYP keyword */ +
        4 /* primitive count */ +
        4 /* int "4" */ +
        4 /* PCNT keyword */ +
        4 /* face group count */ +
        4 /* faces count */ +
        4 /* PVTX keyword */ +
        4 /* indices count */ +
        2 * geoset.Faces.length /* indices data */ +
        4 /* GNDX keyword */ +
        4 /* vertex group count */ +
        geoset.VertexGroup.length /* vertex group data */ +
        4 /* MTGC keyword */ +
        4 /* group count */ +
        4 * geoset.Groups.length /* group data */ +
        4 /* MATS keyword */ +
        4 /* total group count */ +
        4 * geoset.TotalGroupsCount /* groups data */ +
        4 /* MaterialID */ +
        4 /* SelectionGroup */ +
        4 /* Unselectable */ +
        (model.Version >= 900 ?
            4 /* LevelOfDetail */ +
                80 /* Name */ :
            0) +
        ((model.Version >= 900 && ((_a = geoset.Tangents) === null || _a === void 0 ? void 0 : _a.length)) ?
            4 /* TANG keyword */ +
                4 /* Tangents count */ +
                4 * geoset.Tangents.length /* Tangents data */ :
            0) +
        ((model.Version >= 900 && ((_b = geoset.SkinWeights) === null || _b === void 0 ? void 0 : _b.length)) ?
            4 /* SKIN keyword */ +
                4 /* SkinWeights count */ +
                geoset.SkinWeights.length /* SkinWeights data */ :
            0) +
        4 * 7 /* extent */ +
        4 /* geoset anim count */ +
        4 * 7 * geoset.Anims.length /* geoset anim data */ +
        4 /* UVAS keyword */ +
        4 /* TVertices count */ +
        sum(geoset.TVertices.map(function (tvertices) {
            return 4 /* UVBS keyword */ +
                4 /* texture coord count */ +
                4 * tvertices.length;
        } /* texture coord data */));
}
function byteLengthGeosets(model) {
    if (!model.Geosets.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Geosets.map(function (geoset) { return byteLengthGeoset(model, geoset); }));
}
function generateGeosets(model, stream) {
    if (!model.Geosets.length) {
        return;
    }
    stream.keyword('GEOS');
    stream.int32(byteLengthGeosets(model) - 8);
    for (var _i = 0, _a = model.Geosets; _i < _a.length; _i++) {
        var geoset = _a[_i];
        stream.int32(byteLengthGeoset(model, geoset));
        stream.keyword('VRTX');
        stream.int32(geoset.Vertices.length / 3);
        stream.float32Array(geoset.Vertices);
        stream.keyword('NRMS');
        stream.int32(geoset.Normals.length / 3);
        stream.float32Array(geoset.Normals);
        stream.keyword('PTYP');
        stream.int32(1);
        stream.int32(4);
        stream.keyword('PCNT');
        stream.int32(1);
        stream.int32(geoset.Faces.length);
        stream.keyword('PVTX');
        stream.int32(geoset.Faces.length);
        stream.uint16Array(geoset.Faces);
        stream.keyword('GNDX');
        stream.int32(geoset.VertexGroup.length);
        stream.uint8Array(geoset.VertexGroup);
        stream.keyword('MTGC');
        stream.int32(geoset.Groups.length);
        for (var i = 0; i < geoset.Groups.length; ++i) {
            stream.int32(geoset.Groups[i].length);
        }
        stream.keyword('MATS');
        stream.int32(geoset.TotalGroupsCount);
        for (var _b = 0, _c = geoset.Groups; _b < _c.length; _b++) {
            var group = _c[_b];
            for (var _d = 0, group_1 = group; _d < group_1.length; _d++) {
                var index = group_1[_d];
                stream.int32(index);
            }
        }
        stream.int32(geoset.MaterialID);
        stream.int32(geoset.SelectionGroup);
        stream.int32(geoset.Unselectable ? 4 : 0);
        if (model.Version >= 900) {
            stream.int32(typeof geoset.LevelOfDetail === 'number' ? geoset.LevelOfDetail : -1);
            stream.str(geoset.Name || '', 80);
        }
        generateExtent(geoset, stream);
        stream.int32(geoset.Anims.length);
        for (var _e = 0, _f = geoset.Anims; _e < _f.length; _e++) {
            var anim = _f[_e];
            generateExtent(anim, stream);
        }
        if (model.Version >= 900) {
            if (geoset.Tangents && geoset.Tangents.length) {
                stream.keyword('TANG');
                stream.int32(geoset.Tangents.length / 4);
                stream.float32Array(geoset.Tangents);
            }
            if (geoset.SkinWeights && geoset.SkinWeights.length) {
                stream.keyword('SKIN');
                stream.int32(geoset.SkinWeights.length);
                stream.uint8Array(geoset.SkinWeights);
            }
        }
        stream.keyword('UVAS');
        stream.int32(geoset.TVertices.length);
        for (var _g = 0, _h = geoset.TVertices; _g < _h.length; _g++) {
            var tvertices = _h[_g];
            stream.keyword('UVBS');
            stream.int32(tvertices.length / 2);
            stream.float32Array(tvertices);
        }
    }
}
function byteLengthGeosetAnim(anim) {
    return 4 /* size */ +
        4 /* static Alpha */ +
        4 /* Flags */ +
        4 * 3 /* static Color */ +
        4 /* GeosetId */ +
        (typeof anim.Alpha !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(anim.Alpha, AnimVectorType.FLOAT1) :
            0) +
        (anim.Color && !(anim.Color instanceof Float32Array) ?
            4 /* keyword */ + byteLengthAnimVector(anim.Color, AnimVectorType.FLOAT3) :
            0);
}
function byteLengthGeosetAnims(model) {
    if (!model.GeosetAnims.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.GeosetAnims.map(function (anim) { return byteLengthGeosetAnim(anim); }));
}
function generateGeosetAnims(model, stream) {
    if (!model.GeosetAnims.length) {
        return;
    }
    stream.keyword('GEOA');
    stream.int32(byteLengthGeosetAnims(model) - 8);
    for (var _i = 0, _a = model.GeosetAnims; _i < _a.length; _i++) {
        var anim = _a[_i];
        stream.int32(byteLengthGeosetAnim(anim));
        stream.float32(typeof anim.Alpha === 'number' ? anim.Alpha : 1);
        stream.int32(anim.Flags);
        if (anim.Color && anim.Color instanceof Float32Array) {
            stream.float32(anim.Color[0]);
            stream.float32(anim.Color[1]);
            stream.float32(anim.Color[2]);
        }
        else {
            stream.float32(1);
            stream.float32(1);
            stream.float32(1);
        }
        stream.int32(anim.GeosetId !== null ? anim.GeosetId : NONE);
        if (anim.Alpha !== null && typeof anim.Alpha !== 'number') {
            stream.keyword('KGAO');
            stream.animVector(anim.Alpha, AnimVectorType.FLOAT1);
        }
        if (anim.Color && !(anim.Color instanceof Float32Array)) {
            stream.keyword('KGAC');
            stream.animVector(anim.Color, AnimVectorType.FLOAT3);
        }
    }
}
var MODEL_NODE_NAME_LENGTH = 0x50;
function byteLengthNode(node) {
    return 4 /* size */ +
        MODEL_NODE_NAME_LENGTH +
        4 /* ObjectId */ +
        4 /* Parent */ +
        4 /* Flags */ +
        (node.Translation ? 4 /*keyword */ + byteLengthAnimVector(node.Translation, AnimVectorType.FLOAT3) : 0) +
        (node.Rotation ? 4 /*keyword */ + byteLengthAnimVector(node.Rotation, AnimVectorType.FLOAT4) : 0) +
        (node.Scaling ? 4 /*keyword */ + byteLengthAnimVector(node.Scaling, AnimVectorType.FLOAT3) : 0);
}
function byteLengthBone(bone) {
    return byteLengthNode(bone) +
        4 /* GeosetId */ +
        4; /* GeosetAnimId */
}
function byteLengthBones(model) {
    if (!model.Bones.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Bones.map(byteLengthBone));
}
function generateNode(node, stream) {
    stream.int32(byteLengthNode(node));
    stream.str(node.Name, MODEL_NODE_NAME_LENGTH);
    stream.int32(node.ObjectId !== null ? node.ObjectId : NONE);
    stream.int32(node.Parent !== null ? node.Parent : NONE);
    stream.int32(node.Flags);
    if (node.Translation) {
        stream.keyword('KGTR');
        stream.animVector(node.Translation, AnimVectorType.FLOAT3);
    }
    if (node.Rotation) {
        stream.keyword('KGRT');
        stream.animVector(node.Rotation, AnimVectorType.FLOAT4);
    }
    if (node.Scaling) {
        stream.keyword('KGSC');
        stream.animVector(node.Scaling, AnimVectorType.FLOAT3);
    }
}
function generateBones(model, stream) {
    if (!model.Bones.length) {
        return;
    }
    stream.keyword('BONE');
    stream.int32(byteLengthBones(model) - 8);
    for (var _i = 0, _a = model.Bones; _i < _a.length; _i++) {
        var bone = _a[_i];
        generateNode(bone, stream);
        stream.int32(bone.GeosetId !== null ? bone.GeosetId : NONE);
        stream.int32(bone.GeosetAnimId !== null ? bone.GeosetAnimId : NONE);
    }
}
function byteLengthLight(light) {
    return 4 /* size */ +
        byteLengthNode(light) +
        4 /* LightType */ +
        4 /* AttenuationStart */ +
        4 /* AttenuationEnd */ +
        4 * 3 /* static Color */ +
        4 /* static Intensity */ +
        4 * 3 /* static AmbColor */ +
        4 /* static AmbIntensity */ +
        (light.Visibility ? 4 /* keyword */ + byteLengthAnimVector(light.Visibility, AnimVectorType.FLOAT1) : 0) +
        (light.Color && !(light.Color instanceof Float32Array) ?
            4 /* keyword */ + byteLengthAnimVector(light.Color, AnimVectorType.FLOAT3) :
            0) +
        (light.Intensity && typeof light.Intensity !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(light.Intensity, AnimVectorType.FLOAT1) :
            0) +
        (light.AttenuationStart && typeof light.AttenuationStart !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(light.AttenuationStart, AnimVectorType.FLOAT1) :
            0) +
        (light.AttenuationEnd && typeof light.AttenuationEnd !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(light.AttenuationEnd, AnimVectorType.FLOAT1) :
            0) +
        (light.AmbColor && !(light.AmbColor instanceof Float32Array) ?
            4 /* keyword */ + byteLengthAnimVector(light.AmbColor, AnimVectorType.FLOAT3) :
            0) +
        (light.AmbIntensity && typeof light.AmbIntensity !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(light.AmbIntensity, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthLights(model) {
    if (!model.Lights.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Lights.map(byteLengthLight));
}
function generateLights(model, stream) {
    if (!model.Lights.length) {
        return;
    }
    stream.keyword('LITE');
    stream.int32(byteLengthLights(model) - 8);
    for (var _i = 0, _a = model.Lights; _i < _a.length; _i++) {
        var light = _a[_i];
        stream.int32(byteLengthLight(light));
        generateNode(light, stream);
        stream.int32(light.LightType);
        stream.float32(typeof light.AttenuationStart === 'number' ? light.AttenuationStart : 0);
        stream.float32(typeof light.AttenuationEnd === 'number' ? light.AttenuationEnd : 0);
        if (light.Color instanceof Float32Array) {
            stream.float32(light.Color[0]);
            stream.float32(light.Color[1]);
            stream.float32(light.Color[2]);
        }
        else {
            stream.float32(1);
            stream.float32(1);
            stream.float32(1);
        }
        stream.float32(typeof light.Intensity === 'number' ? light.Intensity : 0);
        if (light.AmbColor instanceof Float32Array) {
            stream.float32(light.AmbColor[0]);
            stream.float32(light.AmbColor[1]);
            stream.float32(light.AmbColor[2]);
        }
        else {
            stream.float32(1);
            stream.float32(1);
            stream.float32(1);
        }
        stream.float32(typeof light.AmbIntensity === 'number' ? light.AmbIntensity : 0);
        if (light.Intensity && typeof light.Intensity !== 'number') {
            stream.keyword('KLAI');
            stream.animVector(light.Intensity, AnimVectorType.FLOAT1);
        }
        if (light.Visibility) {
            stream.keyword('KLAV');
            stream.animVector(light.Visibility, AnimVectorType.FLOAT1);
        }
        if (light.Color && !(light.Color instanceof Float32Array)) {
            stream.keyword('KLAC');
            stream.animVector(light.Color, AnimVectorType.FLOAT3);
        }
        if (light.AmbColor && !(light.AmbColor instanceof Float32Array)) {
            stream.keyword('KLBC');
            stream.animVector(light.AmbColor, AnimVectorType.FLOAT3);
        }
        if (light.AmbIntensity && typeof light.AmbIntensity !== 'number') {
            stream.keyword('KLBI');
            stream.animVector(light.AmbIntensity, AnimVectorType.FLOAT1);
        }
        if (light.AttenuationStart && typeof light.AttenuationStart !== 'number') {
            stream.keyword('KLAS');
            stream.animVector(light.AttenuationStart, AnimVectorType.INT1);
        }
        if (light.AttenuationEnd && typeof light.AttenuationEnd !== 'number') {
            stream.keyword('KLAE');
            stream.animVector(light.AttenuationEnd, AnimVectorType.INT1);
        }
    }
}
function byteLengthHelpers(model) {
    if (model.Helpers.length === 0) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Helpers.map(byteLengthNode));
}
function generateHelpers(model, stream) {
    if (model.Helpers.length === 0) {
        return;
    }
    stream.keyword('HELP');
    stream.int32(byteLengthHelpers(model) - 8);
    for (var _i = 0, _a = model.Helpers; _i < _a.length; _i++) {
        var helper = _a[_i];
        generateNode(helper, stream);
    }
}
var MODEL_ATTACHMENT_PATH_LENGTH = 0x100;
function byteLengthAttachment(attachment) {
    return 4 /* size */ +
        byteLengthNode(attachment) +
        MODEL_ATTACHMENT_PATH_LENGTH +
        4 /* zero ? */ +
        4 /* AttachmentID */ +
        (attachment.Visibility ?
            4 /* keyword */ + byteLengthAnimVector(attachment.Visibility, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthAttachments(model) {
    if (model.Attachments.length === 0) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Attachments.map(byteLengthAttachment));
}
function generateAttachments(model, stream) {
    if (model.Attachments.length === 0) {
        return;
    }
    stream.keyword('ATCH');
    stream.int32(byteLengthAttachments(model) - 8);
    for (var _i = 0, _a = model.Attachments; _i < _a.length; _i++) {
        var attachment = _a[_i];
        stream.int32(byteLengthAttachment(attachment));
        generateNode(attachment, stream);
        stream.str(attachment.Path || '', MODEL_ATTACHMENT_PATH_LENGTH);
        stream.int32(0);
        stream.int32(attachment.AttachmentID);
        if (attachment.Visibility) {
            stream.keyword('KATV');
            stream.animVector(attachment.Visibility, AnimVectorType.FLOAT1);
        }
    }
}
function byteLengthPivotPoints(model) {
    if (!model.PivotPoints.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        4 * 3 * model.PivotPoints.length;
}
function generatePivotPoints(model, stream) {
    if (!model.PivotPoints.length) {
        return;
    }
    stream.keyword('PIVT');
    stream.int32(model.PivotPoints.length * 4 * 3);
    for (var _i = 0, _a = model.PivotPoints; _i < _a.length; _i++) {
        var point = _a[_i];
        stream.float32Array(point);
    }
}
var MODEL_PARTICLE_EMITTER_PATH_LENGTH = 0x100;
function byteLengthParticleEmitter(emitter) {
    return 4 /* size */ +
        byteLengthNode(emitter) +
        4 /* EmissionRate */ +
        4 /* Gravity */ +
        4 /* Longitude */ +
        4 /* Latitude */ +
        MODEL_PARTICLE_EMITTER_PATH_LENGTH +
        4 +
        4 /* LifeSpan */ +
        4 /* InitVelocity */ +
        (emitter.Visibility && typeof emitter.Visibility !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Visibility, AnimVectorType.FLOAT1) :
            0) +
        (emitter.EmissionRate && typeof emitter.EmissionRate !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.EmissionRate, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Gravity && typeof emitter.Gravity !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Gravity, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Longitude && typeof emitter.Longitude !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Longitude, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Latitude && typeof emitter.Latitude !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Latitude, AnimVectorType.FLOAT1) :
            0) +
        (emitter.LifeSpan && typeof emitter.LifeSpan !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.LifeSpan, AnimVectorType.FLOAT1) :
            0) +
        (emitter.InitVelocity && typeof emitter.InitVelocity !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.InitVelocity, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthParticleEmitters(model) {
    if (!model.ParticleEmitters.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.ParticleEmitters.map(byteLengthParticleEmitter));
}
function generateParticleEmitters(model, stream) {
    if (!model.ParticleEmitters.length) {
        return;
    }
    stream.keyword('PREM');
    stream.int32(byteLengthParticleEmitters(model) - 8);
    for (var _i = 0, _a = model.ParticleEmitters; _i < _a.length; _i++) {
        var emitter = _a[_i];
        stream.int32(byteLengthParticleEmitter(emitter));
        generateNode(emitter, stream);
        stream.float32(typeof emitter.EmissionRate === 'number' ? emitter.EmissionRate : 0);
        stream.float32(typeof emitter.Gravity === 'number' ? emitter.Gravity : 0);
        stream.float32(typeof emitter.Longitude === 'number' ? emitter.Longitude : 0);
        stream.float32(typeof emitter.Latitude === 'number' ? emitter.Latitude : 0);
        stream.str(emitter.Path, MODEL_PARTICLE_EMITTER_PATH_LENGTH);
        stream.int32(0);
        stream.float32(typeof emitter.LifeSpan === 'number' ? emitter.LifeSpan : 0);
        stream.float32(typeof emitter.InitVelocity === 'number' ? emitter.InitVelocity : 0);
        if (emitter.Visibility && typeof emitter.Visibility !== 'number') {
            stream.keyword('KPEV');
            stream.animVector(emitter.Visibility, AnimVectorType.FLOAT1);
        }
        if (emitter.EmissionRate && typeof emitter.EmissionRate !== 'number') {
            stream.keyword('KPEE');
            stream.animVector(emitter.EmissionRate, AnimVectorType.FLOAT1);
        }
        if (emitter.Gravity && typeof emitter.Gravity !== 'number') {
            stream.keyword('KPEG');
            stream.animVector(emitter.Gravity, AnimVectorType.FLOAT1);
        }
        if (emitter.Longitude && typeof emitter.Longitude !== 'number') {
            stream.keyword('KPLN');
            stream.animVector(emitter.Longitude, AnimVectorType.FLOAT1);
        }
        if (emitter.Latitude && typeof emitter.Latitude !== 'number') {
            stream.keyword('KPLT');
            stream.animVector(emitter.Latitude, AnimVectorType.FLOAT1);
        }
        if (emitter.LifeSpan && typeof emitter.LifeSpan !== 'number') {
            stream.keyword('KPEL');
            stream.animVector(emitter.LifeSpan, AnimVectorType.FLOAT1);
        }
        if (emitter.InitVelocity && typeof emitter.InitVelocity !== 'number') {
            stream.keyword('KPES');
            stream.animVector(emitter.InitVelocity, AnimVectorType.FLOAT1);
        }
    }
}
function byteLengthParticleEmitter2(emitter) {
    return 4 /* size */ +
        byteLengthNode(emitter) +
        4 /* static Speed */ +
        4 /* Variation */ +
        4 /* static Latitude */ +
        4 /* Gravity */ +
        4 /* LifeSpan */ +
        4 /* static EmissionRate */ +
        4 /* static Length */ +
        4 /* static Width */ +
        4 /* FilterMode */ +
        4 /* Rows */ +
        4 /* Columns */ +
        4 /* FrameFlags */ +
        4 /* TailLength */ +
        4 /* Time */ +
        4 * 3 * 3 /* SegmentColor */ +
        3 /* Alpha uint * 3 */ +
        4 * 3 /* ParticleScaling */ +
        4 * 3 /* LifeSpanUVAnim */ +
        4 * 3 /* DecayUVAnim */ +
        4 * 3 /* TailUVAnim */ +
        4 * 3 /* TailDecayUVAnim */ +
        4 /* TextureID */ +
        4 /* Squirt */ +
        4 /* PriorityPlane */ +
        4 /* ReplaceableId */ +
        (emitter.Visibility && typeof emitter.Visibility !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Visibility, AnimVectorType.FLOAT1) :
            0) +
        (emitter.EmissionRate && typeof emitter.EmissionRate !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.EmissionRate, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Width && typeof emitter.Width !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Width, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Length && typeof emitter.Length !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Length, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Speed && typeof emitter.Speed !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Speed, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Latitude && typeof emitter.Latitude !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Latitude, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Gravity && typeof emitter.Gravity !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Gravity, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Variation && typeof emitter.Variation !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Variation, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthParticleEmitters2(model) {
    if (!model.ParticleEmitters2.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.ParticleEmitters2.map(byteLengthParticleEmitter2));
}
function generateParticleEmitters2(model, stream) {
    if (!model.ParticleEmitters2.length) {
        return;
    }
    stream.keyword('PRE2');
    stream.int32(byteLengthParticleEmitters2(model) - 8);
    for (var _i = 0, _a = model.ParticleEmitters2; _i < _a.length; _i++) {
        var emitter = _a[_i];
        stream.int32(byteLengthParticleEmitter2(emitter));
        generateNode(emitter, stream);
        stream.float32(typeof emitter.Speed === 'number' ? emitter.Speed : 0);
        stream.float32(typeof emitter.Variation === 'number' ? emitter.Variation : 0);
        stream.float32(typeof emitter.Latitude === 'number' ? emitter.Latitude : 0);
        stream.float32(typeof emitter.Gravity === 'number' ? emitter.Gravity : 0);
        stream.float32(emitter.LifeSpan);
        stream.float32(typeof emitter.EmissionRate === 'number' ? emitter.EmissionRate : 0);
        stream.float32(typeof emitter.Width === 'number' ? emitter.Width : 0);
        stream.float32(typeof emitter.Length === 'number' ? emitter.Length : 0);
        stream.int32(emitter.FilterMode);
        stream.int32(emitter.Rows);
        stream.int32(emitter.Columns);
        if (emitter.FrameFlags & ParticleEmitter2FramesFlags.Head &&
            emitter.FrameFlags & ParticleEmitter2FramesFlags.Tail) {
            stream.int32(2);
        }
        else if (emitter.FrameFlags & ParticleEmitter2FramesFlags.Tail) {
            stream.int32(1);
        }
        else if (emitter.FrameFlags & ParticleEmitter2FramesFlags.Head) {
            stream.int32(0);
        }
        stream.float32(emitter.TailLength);
        stream.float32(emitter.Time);
        for (var i = 0; i < 3; ++i) {
            for (var j = 0; j < 3; ++j) {
                stream.float32(emitter.SegmentColor[i][j]);
            }
        }
        for (var i = 0; i < 3; ++i) {
            stream.uint8(emitter.Alpha[i]);
        }
        for (var i = 0; i < 3; ++i) {
            stream.float32(emitter.ParticleScaling[i]);
        }
        for (var _b = 0, _c = ['LifeSpanUVAnim', 'DecayUVAnim', 'TailUVAnim', 'TailDecayUVAnim']; _b < _c.length; _b++) {
            var part = _c[_b];
            for (var i = 0; i < 3; ++i) {
                stream.int32(emitter[part][i]);
            }
        }
        stream.int32(emitter.TextureID !== null ? emitter.TextureID : NONE);
        stream.int32(emitter.Squirt ? 1 : 0);
        stream.int32(emitter.PriorityPlane);
        stream.int32(emitter.ReplaceableId);
        if (emitter.Speed && typeof emitter.Speed !== 'number') {
            stream.keyword('KP2S');
            stream.animVector(emitter.Speed, AnimVectorType.FLOAT1);
        }
        if (emitter.Latitude && typeof emitter.Latitude !== 'number') {
            stream.keyword('KP2L');
            stream.animVector(emitter.Latitude, AnimVectorType.FLOAT1);
        }
        if (emitter.EmissionRate && typeof emitter.EmissionRate !== 'number') {
            stream.keyword('KP2E');
            stream.animVector(emitter.EmissionRate, AnimVectorType.FLOAT1);
        }
        if (emitter.Visibility && typeof emitter.Visibility !== 'number') {
            stream.keyword('KP2V');
            stream.animVector(emitter.Visibility, AnimVectorType.FLOAT1);
        }
        if (emitter.Length && typeof emitter.Length !== 'number') {
            stream.keyword('KP2N');
            stream.animVector(emitter.Length, AnimVectorType.FLOAT1);
        }
        if (emitter.Width && typeof emitter.Width !== 'number') {
            stream.keyword('KP2W');
            stream.animVector(emitter.Width, AnimVectorType.FLOAT1);
        }
        if (emitter.Gravity && typeof emitter.Gravity !== 'number') {
            stream.keyword('KP2G');
            stream.animVector(emitter.Gravity, AnimVectorType.FLOAT1);
        }
        if (emitter.Variation && typeof emitter.Variation !== 'number') {
            stream.keyword('KP2R');
            stream.animVector(emitter.Variation, AnimVectorType.FLOAT1);
        }
    }
}
function byteLengthRibbonEmitter(emitter) {
    return 4 /* size */ +
        byteLengthNode(emitter) +
        4 /* static HeightAbove */ +
        4 /* static HeightBelow */ +
        4 /* Alpha */ +
        4 * 3 /* Color */ +
        4 /* LifeSpan */ +
        4 /* TextureSlot */ +
        4 /* EmissionRate */ +
        4 /* Rows */ +
        4 /* Columns */ +
        4 /* MaterialID */ +
        4 /* Gravity */ +
        (emitter.Visibility ? 4 /* keyword */ + byteLengthAnimVector(emitter.Visibility, AnimVectorType.FLOAT1) : 0) +
        (typeof emitter.HeightAbove !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.HeightAbove, AnimVectorType.FLOAT1) :
            0) +
        (typeof emitter.HeightBelow !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.HeightBelow, AnimVectorType.FLOAT1) :
            0) +
        (typeof emitter.Alpha !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Alpha, AnimVectorType.FLOAT1) :
            0) +
        (typeof emitter.TextureSlot !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.TextureSlot, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthRibbonEmitters(model) {
    if (!model.RibbonEmitters.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.RibbonEmitters.map(byteLengthRibbonEmitter));
}
function generateRibbonEmitters(model, stream) {
    if (!model.RibbonEmitters.length) {
        return;
    }
    stream.keyword('RIBB');
    stream.int32(byteLengthRibbonEmitters(model) - 8);
    for (var _i = 0, _a = model.RibbonEmitters; _i < _a.length; _i++) {
        var emitter = _a[_i];
        stream.int32(byteLengthRibbonEmitter(emitter));
        generateNode(emitter, stream);
        stream.float32(typeof emitter.HeightAbove === 'number' ? emitter.HeightAbove : 0);
        stream.float32(typeof emitter.HeightBelow === 'number' ? emitter.HeightBelow : 0);
        stream.float32(typeof emitter.Alpha === 'number' ? emitter.Alpha : 0);
        if (emitter.Color) {
            stream.float32Array(emitter.Color);
        }
        else {
            stream.float32(1);
            stream.float32(1);
            stream.float32(1);
        }
        stream.float32(emitter.LifeSpan);
        stream.int32(typeof emitter.TextureSlot === 'number' ? emitter.TextureSlot : 0);
        stream.int32(emitter.EmissionRate);
        stream.int32(emitter.Rows);
        stream.int32(emitter.Columns);
        stream.int32(emitter.MaterialID);
        stream.float32(emitter.Gravity);
        if (emitter.Visibility) {
            stream.keyword('KRVS');
            stream.animVector(emitter.Visibility, AnimVectorType.FLOAT1);
        }
        if (typeof emitter.HeightAbove !== 'number') {
            stream.keyword('KRHA');
            stream.animVector(emitter.HeightAbove, AnimVectorType.FLOAT1);
        }
        if (typeof emitter.HeightBelow !== 'number') {
            stream.keyword('KRHB');
            stream.animVector(emitter.HeightBelow, AnimVectorType.FLOAT1);
        }
        if (typeof emitter.Alpha !== 'number') {
            stream.keyword('KRAL');
            stream.animVector(emitter.Alpha, AnimVectorType.FLOAT1);
        }
        if (typeof emitter.TextureSlot !== 'number') {
            stream.keyword('KRTX');
            stream.animVector(emitter.TextureSlot, AnimVectorType.INT1);
        }
    }
}
var MODEL_CAMERA_NAME_LENGTH = 0x50;
function byteLengthCamera(camera) {
    return 4 /* size */ +
        MODEL_CAMERA_NAME_LENGTH +
        4 * 3 /* Position */ +
        4 /* FieldOfView */ +
        4 /* FarClip */ +
        4 /* NearClip */ +
        4 * 3 /* TargetPosition */ +
        (camera.Translation ? 4 /* keyword */ + byteLengthAnimVector(camera.Translation, AnimVectorType.FLOAT3) : 0) +
        (camera.TargetTranslation ?
            4 /* keyword */ + byteLengthAnimVector(camera.TargetTranslation, AnimVectorType.FLOAT3) :
            0) +
        (camera.Rotation ? 4 /* keyword */ + byteLengthAnimVector(camera.Rotation, AnimVectorType.FLOAT1) : 0);
}
function byteLengthCameras(model) {
    if (!model.Cameras.length) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.Cameras.map(byteLengthCamera));
}
function generateCameras(model, stream) {
    if (!model.Cameras.length) {
        return;
    }
    stream.keyword('CAMS');
    stream.int32(byteLengthCameras(model) - 8);
    for (var _i = 0, _a = model.Cameras; _i < _a.length; _i++) {
        var camera = _a[_i];
        stream.int32(byteLengthCamera(camera));
        stream.str(camera.Name, MODEL_CAMERA_NAME_LENGTH);
        stream.float32Array(camera.Position);
        stream.float32(camera.FieldOfView);
        stream.float32(camera.FarClip);
        stream.float32(camera.NearClip);
        stream.float32Array(camera.TargetPosition);
        if (camera.Translation) {
            stream.keyword('KCTR');
            stream.animVector(camera.Translation, AnimVectorType.FLOAT3);
        }
        if (camera.Rotation) {
            stream.keyword('KCRL');
            stream.animVector(camera.Rotation, AnimVectorType.FLOAT1);
        }
        if (camera.TargetTranslation) {
            stream.keyword('KTTR');
            stream.animVector(camera.TargetTranslation, AnimVectorType.FLOAT3);
        }
    }
}
function byteLengthEventObject(eventObject) {
    return byteLengthNode(eventObject) +
        4 /* KEVT keyword */ +
        4 /* count */ +
        4 +
        4 * eventObject.EventTrack.length;
}
function byteLengthEventObjects(model) {
    if (model.EventObjects.length === 0) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.EventObjects.map(byteLengthEventObject));
}
function generateEventObjects(model, stream) {
    if (model.EventObjects.length === 0) {
        return;
    }
    stream.keyword('EVTS');
    stream.int32(byteLengthEventObjects(model) - 8);
    for (var _i = 0, _a = model.EventObjects; _i < _a.length; _i++) {
        var eventObject = _a[_i];
        generateNode(eventObject, stream);
        stream.keyword('KEVT');
        stream.int32(eventObject.EventTrack.length);
        // todo GlobalSequenceId
        stream.int32(NONE); // GlobalSequenceId ?
        stream.uint32Array(eventObject.EventTrack);
    }
}
function byteLengthCollisionShape(collisionShape) {
    return byteLengthNode(collisionShape) +
        4 /* Shape */ +
        (collisionShape.Shape === CollisionShapeType.Box ? 6 : 3) * 4 /* Vertices */ +
        (collisionShape.Shape === CollisionShapeType.Sphere ? 4 : 0); /* BoundsRadius */
}
function byteLengthCollisionShapes(model) {
    if (model.CollisionShapes.length === 0) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.CollisionShapes.map(byteLengthCollisionShape));
}
function generateCollisionShapes(model, stream) {
    if (model.CollisionShapes.length === 0) {
        return;
    }
    stream.keyword('CLID');
    stream.int32(byteLengthCollisionShapes(model) - 8);
    for (var _i = 0, _a = model.CollisionShapes; _i < _a.length; _i++) {
        var collisionShape = _a[_i];
        generateNode(collisionShape, stream);
        stream.int32(collisionShape.Shape);
        stream.float32Array(collisionShape.Vertices);
        if (collisionShape.Shape === CollisionShapeType.Sphere) {
            stream.float32(collisionShape.BoundsRadius);
        }
    }
}
function byteLengthFaceFX(model) {
    if (model.Version < 900 || !model.FaceFX) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        (80 /* Name */ +
            260 /* Path */) * model.FaceFX.length;
}
function generateFaceFX(model, stream) {
    if (model.Version < 900 || !model.FaceFX) {
        return;
    }
    stream.keyword('FAFX');
    stream.int32(byteLengthFaceFX(model) - 8);
    for (var _i = 0, _a = model.FaceFX; _i < _a.length; _i++) {
        var faceFx = _a[_i];
        stream.str(faceFx.Name, 80);
        stream.str(faceFx.Path, 260);
    }
}
function byteLengthBindPoseObject(bindPose) {
    return 4 * 12 /* Matrices */ * bindPose.Matrices.length;
}
function byteLengthBindPoses(model) {
    if (model.Version < 900 || !model.BindPoses) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        4 /* count */ +
        sum(model.BindPoses.map(byteLengthBindPoseObject));
}
function generateBindPoses(model, stream) {
    var _a;
    if (model.Version < 900 || !((_a = model.BindPoses) === null || _a === void 0 ? void 0 : _a.length)) {
        return;
    }
    stream.keyword('BPOS');
    stream.int32(byteLengthBindPoses(model) - 8);
    var totalCount = model.BindPoses.reduce(function (acc, bindPose) {
        return acc + bindPose.Matrices.length;
    }, 0);
    stream.int32(totalCount);
    for (var _i = 0, _b = model.BindPoses; _i < _b.length; _i++) {
        var bindPose = _b[_i];
        for (var _c = 0, _d = bindPose.Matrices; _c < _d.length; _c++) {
            var matrix = _d[_c];
            stream.float32Array(matrix);
        }
    }
}
function byteLengthParticleEmitterPopcorn(emitter) {
    return 4 /* size */ +
        byteLengthNode(emitter) +
        4 /* static LifeSpan */ +
        4 /* static EmissionRate */ +
        4 /* static Speed */ +
        4 * 3 /* static Color */ +
        4 /* static Alpha */ +
        4 /* ReplaceableId */ +
        260 /* Path */ +
        260 /* AnimVisibilityGuide */ +
        (emitter.Alpha && typeof emitter.Alpha !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Alpha, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Visibility && typeof emitter.Visibility !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Visibility, AnimVectorType.FLOAT1) :
            0) +
        (emitter.EmissionRate && typeof emitter.EmissionRate !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.EmissionRate, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Color && !(emitter.Color instanceof Float32Array) ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Color, AnimVectorType.FLOAT3) :
            0) +
        (emitter.LifeSpan && typeof emitter.LifeSpan !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.LifeSpan, AnimVectorType.FLOAT1) :
            0) +
        (emitter.Speed && typeof emitter.Speed !== 'number' ?
            4 /* keyword */ + byteLengthAnimVector(emitter.Speed, AnimVectorType.FLOAT1) :
            0);
}
function byteLengthParticleEmitterPopcorns(model) {
    var _a;
    if (model.Version < 900 || !((_a = model.ParticleEmitterPopcorns) === null || _a === void 0 ? void 0 : _a.length)) {
        return 0;
    }
    return 4 /* keyword */ +
        4 /* size */ +
        sum(model.ParticleEmitterPopcorns.map(byteLengthParticleEmitterPopcorn));
}
function generateParticleEmitterPopcorns(model, stream) {
    var _a;
    if (model.Version < 900 || !((_a = model.ParticleEmitterPopcorns) === null || _a === void 0 ? void 0 : _a.length)) {
        return;
    }
    stream.keyword('CORN');
    stream.int32(byteLengthParticleEmitterPopcorns(model) - 8);
    for (var _i = 0, _b = model.ParticleEmitterPopcorns; _i < _b.length; _i++) {
        var emitter = _b[_i];
        stream.int32(byteLengthParticleEmitterPopcorn(emitter));
        generateNode(emitter, stream);
        stream.float32(typeof emitter.LifeSpan === 'number' ? emitter.LifeSpan : 0);
        stream.float32(typeof emitter.EmissionRate === 'number' ? emitter.EmissionRate : 1);
        stream.float32(typeof emitter.Speed === 'number' ? emitter.Speed : 0);
        if (emitter.Color instanceof Float32Array) {
            stream.float32(emitter.Color[0]);
            stream.float32(emitter.Color[1]);
            stream.float32(emitter.Color[2]);
        }
        else {
            stream.float32(1);
            stream.float32(1);
            stream.float32(1);
        }
        stream.float32(typeof emitter.Alpha === 'number' ? emitter.Alpha : 1);
        stream.int32(typeof emitter.ReplaceableId === 'number' ? emitter.ReplaceableId : 0);
        stream.str(emitter.Path, 260);
        stream.str(emitter.AnimVisibilityGuide, 260);
        if (emitter.Alpha && typeof emitter.Alpha !== 'number') {
            stream.keyword('KPPA');
            stream.animVector(emitter.Alpha, AnimVectorType.FLOAT1);
        }
        if (emitter.Color && !(emitter.Color instanceof Float32Array)) {
            stream.keyword('KPPC');
            stream.animVector(emitter.Color, AnimVectorType.FLOAT3);
        }
        if (emitter.EmissionRate && typeof emitter.EmissionRate !== 'number') {
            stream.keyword('KPPE');
            stream.animVector(emitter.EmissionRate, AnimVectorType.FLOAT1);
        }
        if (emitter.LifeSpan && typeof emitter.LifeSpan !== 'number') {
            stream.keyword('KPPL');
            stream.animVector(emitter.LifeSpan, AnimVectorType.FLOAT1);
        }
        if (emitter.Speed && typeof emitter.Speed !== 'number') {
            stream.keyword('KPPS');
            stream.animVector(emitter.Speed, AnimVectorType.FLOAT1);
        }
        if (emitter.Visibility && typeof emitter.Visibility !== 'number') {
            stream.keyword('KPPV');
            stream.animVector(emitter.Visibility, AnimVectorType.FLOAT1);
        }
    }
}
var byteLength = [
    byteLengthVersion,
    byteLengthModelInfo,
    byteLengthSequences,
    byteLengthGlobalSequences,
    byteLengthMaterials,
    byteLengthTextures,
    byteLengthTextureAnims,
    byteLengthGeosets,
    byteLengthGeosetAnims,
    byteLengthBones,
    byteLengthLights,
    byteLengthHelpers,
    byteLengthAttachments,
    byteLengthPivotPoints,
    byteLengthParticleEmitters,
    byteLengthParticleEmitters2,
    byteLengthParticleEmitterPopcorns,
    byteLengthRibbonEmitters,
    byteLengthCameras,
    byteLengthEventObjects,
    byteLengthCollisionShapes,
    byteLengthFaceFX,
    byteLengthBindPoses
];
var generators = [
    generateVersion,
    generateModelInfo,
    generateSequences,
    generateGlobalSequences,
    generateMaterials,
    generateTextures,
    generateTextureAnims,
    generateGeosets,
    generateGeosetAnims,
    generateBones,
    generateLights,
    generateHelpers,
    generateAttachments,
    generatePivotPoints,
    generateParticleEmitters,
    generateParticleEmitters2,
    generateParticleEmitterPopcorns,
    generateRibbonEmitters,
    generateCameras,
    generateEventObjects,
    generateCollisionShapes,
    generateFaceFX,
    generateBindPoses
];
function generate(model) {
    var totalLength = 4 /* format keyword */;
    for (var _i = 0, byteLength_1 = byteLength; _i < byteLength_1.length; _i++) {
        var lenFunc = byteLength_1[_i];
        totalLength += lenFunc(model);
    }
    var res = new ArrayBuffer(totalLength);
    var stream = new Stream(res);
    stream.keyword('MDLX');
    for (var _a = 0, generators_1 = generators; _a < generators_1.length; _a++) {
        var generator = generators_1[_a];
        generator(model, stream);
    }
    return res;
}

var BLPType;
(function (BLPType) {
    BLPType[BLPType["BLP0"] = 0] = "BLP0";
    BLPType[BLPType["BLP1"] = 1] = "BLP1";
    BLPType[BLPType["BLP2"] = 2] = "BLP2";
})(BLPType || (BLPType = {}));
var BLPContent;
(function (BLPContent) {
    BLPContent[BLPContent["JPEG"] = 0] = "JPEG";
    BLPContent[BLPContent["Direct"] = 1] = "Direct";
})(BLPContent || (BLPContent = {}));

var blpimage = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get BLPType () { return BLPType; },
    get BLPContent () { return BLPContent; }
});

/*
 Copyright 2011 notmasteryet

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

// - The JPEG specification can be found in the ITU CCITT Recommendation T.81
//   (www.w3.org/Graphics/JPEG/itu-t81.pdf)
// - The JFIF specification can be found in the JPEG File Interchange Format
//   (www.w3.org/Graphics/JPEG/jfif3.pdf)
// - The Adobe Application-Specific JPEG markers in the Supporting the DCT Filters
//   in PostScript Level 2, Technical Note #5116
//   (partners.adobe.com/public/developer/en/ps/sdk/5116.DCT_Filter.pdf)

// NOTE: This file was edited to match the crude usage of the JPG format by Blizzard for their BLP1 format.

var JpegImage = (function jpegImage() {
    var dctZigZag = new Int32Array([
        0,
        1,  8,
        16,  9,  2,
        3, 10, 17, 24,
        32, 25, 18, 11, 4,
        5, 12, 19, 26, 33, 40,
        48, 41, 34, 27, 20, 13,  6,
        7, 14, 21, 28, 35, 42, 49, 56,
        57, 50, 43, 36, 29, 22, 15,
        23, 30, 37, 44, 51, 58,
        59, 52, 45, 38, 31,
        39, 46, 53, 60,
        61, 54, 47,
        55, 62,
        63
    ]);

    var dctCos1  =  4017;   // cos(pi/16)
    var dctSin1  =   799;   // sin(pi/16)
    var dctCos3  =  3406;   // cos(3*pi/16)
    var dctSin3  =  2276;   // sin(3*pi/16)
    var dctCos6  =  1567;   // cos(6*pi/16)
    var dctSin6  =  3784;   // sin(6*pi/16)
    var dctSqrt2 =  5793;   // sqrt(2)
    var dctSqrt1d2 = 2896;  // sqrt(2) / 2

    function constructor() {
    }

    function buildHuffmanTable(codeLengths, values) {
        var k = 0, code = [], i, j, length = 16;
        while (length > 0 && !codeLengths[length - 1])
            length--;
        code.push({children: [], index: 0});
        var p = code[0], q;
        for (i = 0; i < length; i++) {
            for (j = 0; j < codeLengths[i]; j++) {
                p = code.pop();
                p.children[p.index] = values[k];
                while (p.index > 0) {
                    p = code.pop();
                }
                p.index++;
                code.push(p);
                while (code.length <= i) {
                    code.push(q = {children: [], index: 0});
                    p.children[p.index] = q.children;
                    p = q;
                }
                k++;
            }
            if (i + 1 < length) {
                // p here points to last code
                code.push(q = {children: [], index: 0});
                p.children[p.index] = q.children;
                p = q;
            }
        }
        return code[0].children;
    }

    function getBlockBufferOffset(component, row, col) {
        return 64 * ((component.blocksPerLine + 1) * row + col);
    }

    function decodeScan(data, offset,
                        frame, components, resetInterval,
                        spectralStart, spectralEnd,
                        successivePrev, successive) {
        frame.precision;
        frame.samplesPerLine;
        frame.scanLines;
        var mcusPerLine = frame.mcusPerLine;
        var progressive = frame.progressive;
        frame.maxH; frame.maxV;

        var startOffset = offset, bitsData = 0, bitsCount = 0;

        function readBit() {
            if (bitsCount > 0) {
                bitsCount--;
                return (bitsData >> bitsCount) & 1;
            }
            bitsData = data[offset++];
            if (bitsData == 0xFF) {
                var nextByte = data[offset++];
                if (nextByte) {
                    throw "unexpected marker: " + ((bitsData << 8) | nextByte).toString(16);
                }
                // unstuff 0
            }
            bitsCount = 7;
            return bitsData >>> 7;
        }

        function decodeHuffman(tree) {
            var node = tree;
            var bit;
            while ((bit = readBit()) !== null) {
                node = node[bit];
                if (typeof node === 'number')
                    return node;
                if (typeof node !== 'object')
                    throw "invalid huffman sequence";
            }
            return null;
        }

        function receive(length) {
            var n = 0;
            while (length > 0) {
                var bit = readBit();
                if (bit === null) return;
                n = (n << 1) | bit;
                length--;
            }
            return n;
        }

        function receiveAndExtend(length) {
            var n = receive(length);
            if (n >= 1 << (length - 1))
                return n;
            return n + (-1 << length) + 1;
        }

        function decodeBaseline(component, offset) {
            var t = decodeHuffman(component.huffmanTableDC);
            var diff = t === 0 ? 0 : receiveAndExtend(t);
            component.blockData[offset] = (component.pred += diff);
            var k = 1;
            while (k < 64) {
                var rs = decodeHuffman(component.huffmanTableAC);
                var s = rs & 15, r = rs >> 4;
                if (s === 0) {
                    if (r < 15)
                        break;
                    k += 16;
                    continue;
                }
                k += r;
                var z = dctZigZag[k];
                component.blockData[offset + z] = receiveAndExtend(s);
                k++;
            }
        }

        function decodeDCFirst(component, offset) {
            var t = decodeHuffman(component.huffmanTableDC);
            var diff = t === 0 ? 0 : (receiveAndExtend(t) << successive);
            component.blockData[offset] = (component.pred += diff);
        }

        function decodeDCSuccessive(component, offset) {
            component.blockData[offset] |= readBit() << successive;
        }

        var eobrun = 0;
        function decodeACFirst(component, offset) {
            if (eobrun > 0) {
                eobrun--;
                return;
            }
            var k = spectralStart, e = spectralEnd;
            while (k <= e) {
                var rs = decodeHuffman(component.huffmanTableAC);
                var s = rs & 15, r = rs >> 4;
                if (s === 0) {
                    if (r < 15) {
                        eobrun = receive(r) + (1 << r) - 1;
                        break;
                    }
                    k += 16;
                    continue;
                }
                k += r;
                var z = dctZigZag[k];
                component.blockData[offset + z] = receiveAndExtend(s) * (1 << successive);
                k++;
            }
        }

        var successiveACState = 0, successiveACNextValue;
        function decodeACSuccessive(component, offset) {
            var k = spectralStart, e = spectralEnd, r = 0;
            while (k <= e) {
                var z = dctZigZag[k];
                switch (successiveACState) {
                    case 0: // initial state
                        var rs = decodeHuffman(component.huffmanTableAC);
                        var s = rs & 15, r = rs >> 4;
                        if (s === 0) {
                            if (r < 15) {
                                eobrun = receive(r) + (1 << r);
                                successiveACState = 4;
                            } else {
                                r = 16;
                                successiveACState = 1;
                            }
                        } else {
                            if (s !== 1)
                                throw "invalid ACn encoding";
                            successiveACNextValue = receiveAndExtend(s);
                            successiveACState = r ? 2 : 3;
                        }
                        continue;
                    case 1: // skipping r zero items
                    case 2:
                        if (component.blockData[offset + z]) {
                            component.blockData[offset + z] += (readBit() << successive);
                        } else {
                            r--;
                            if (r === 0)
                                successiveACState = successiveACState == 2 ? 3 : 0;
                        }
                        break;
                    case 3: // set value for a zero item
                        if (component.blockData[offset + z]) {
                            component.blockData[offset + z] += (readBit() << successive);
                        } else {
                            component.blockData[offset + z] = successiveACNextValue << successive;
                            successiveACState = 0;
                        }
                        break;
                    case 4: // eob
                        if (component.blockData[offset + z]) {
                            component.blockData[offset + z] += (readBit() << successive);
                        }
                        break;
                }
                k++;
            }
            if (successiveACState === 4) {
                eobrun--;
                if (eobrun === 0)
                    successiveACState = 0;
            }
        }

        function decodeMcu(component, decode, mcu, row, col) {
            var mcuRow = (mcu / mcusPerLine) | 0;
            var mcuCol = mcu % mcusPerLine;
            var blockRow = mcuRow * component.v + row;
            var blockCol = mcuCol * component.h + col;
            var offset = getBlockBufferOffset(component, blockRow, blockCol);
            decode(component, offset);
        }

        function decodeBlock(component, decode, mcu) {
            var blockRow = (mcu / component.blocksPerLine) | 0;
            var blockCol = mcu % component.blocksPerLine;
            var offset = getBlockBufferOffset(component, blockRow, blockCol);
            decode(component, offset);
        }

        var componentsLength = components.length;
        var component, i, j, k, n;
        var decodeFn;
        if (progressive) {
            if (spectralStart === 0)
                decodeFn = successivePrev === 0 ? decodeDCFirst : decodeDCSuccessive;
            else
                decodeFn = successivePrev === 0 ? decodeACFirst : decodeACSuccessive;
        } else {
            decodeFn = decodeBaseline;
        }

        var mcu = 0, marker;
        var mcuExpected;
        if (componentsLength == 1) {
            mcuExpected = components[0].blocksPerLine * components[0].blocksPerColumn;
        } else {
            mcuExpected = mcusPerLine * frame.mcusPerColumn;
        }
        if (!resetInterval) {
            resetInterval = mcuExpected;
        }

        var h, v;
        while (mcu < mcuExpected) {
            // reset interval stuff
            for (i = 0; i < componentsLength; i++) {
                components[i].pred = 0;
            }
            eobrun = 0;

            if (componentsLength == 1) {
                component = components[0];
                for (n = 0; n < resetInterval; n++) {
                    decodeBlock(component, decodeFn, mcu);
                    mcu++;
                }
            } else {
                for (n = 0; n < resetInterval; n++) {
                    for (i = 0; i < componentsLength; i++) {
                        component = components[i];
                        h = component.h;
                        v = component.v;
                        for (j = 0; j < v; j++) {
                            for (k = 0; k < h; k++) {
                                decodeMcu(component, decodeFn, mcu, j, k);
                            }
                        }
                    }
                    mcu++;
                }
            }

            // find marker
            bitsCount = 0;
            marker = (data[offset] << 8) | data[offset + 1];
            if (marker <= 0xFF00) {
                throw "marker was not found";
            }

            if (marker >= 0xFFD0 && marker <= 0xFFD7) { // RSTx
                offset += 2;
            } else {
                break;
            }
        }

        return offset - startOffset;
    }

    // A port of poppler's IDCT method which in turn is taken from:
    //   Christoph Loeffler, Adriaan Ligtenberg, George S. Moschytz,
    //   "Practical Fast 1-D DCT Algorithms with 11 Multiplications",
    //   IEEE Intl. Conf. on Acoustics, Speech & Signal Processing, 1989,
    //   988-991.
    function quantizeAndInverse(component, blockBufferOffset, p) {
        var qt = component.quantizationTable;
        var v0, v1, v2, v3, v4, v5, v6, v7, t;
        var i;

        // dequant
        for (i = 0; i < 64; i++) {
            p[i] = component.blockData[blockBufferOffset + i] * qt[i];
        }

        // inverse DCT on rows
        for (i = 0; i < 8; ++i) {
            var row = 8 * i;

            // check for all-zero AC coefficients
            if (p[1 + row] == 0 && p[2 + row] == 0 && p[3 + row] == 0 &&
                p[4 + row] == 0 && p[5 + row] == 0 && p[6 + row] == 0 &&
                p[7 + row] == 0) {
                t = (dctSqrt2 * p[0 + row] + 512) >> 10;
                p[0 + row] = t;
                p[1 + row] = t;
                p[2 + row] = t;
                p[3 + row] = t;
                p[4 + row] = t;
                p[5 + row] = t;
                p[6 + row] = t;
                p[7 + row] = t;
                continue;
            }

            // stage 4
            v0 = (dctSqrt2 * p[0 + row] + 128) >> 8;
            v1 = (dctSqrt2 * p[4 + row] + 128) >> 8;
            v2 = p[2 + row];
            v3 = p[6 + row];
            v4 = (dctSqrt1d2 * (p[1 + row] - p[7 + row]) + 128) >> 8;
            v7 = (dctSqrt1d2 * (p[1 + row] + p[7 + row]) + 128) >> 8;
            v5 = p[3 + row] << 4;
            v6 = p[5 + row] << 4;

            // stage 3
            t = (v0 - v1+ 1) >> 1;
            v0 = (v0 + v1 + 1) >> 1;
            v1 = t;
            t = (v2 * dctSin6 + v3 * dctCos6 + 128) >> 8;
            v2 = (v2 * dctCos6 - v3 * dctSin6 + 128) >> 8;
            v3 = t;
            t = (v4 - v6 + 1) >> 1;
            v4 = (v4 + v6 + 1) >> 1;
            v6 = t;
            t = (v7 + v5 + 1) >> 1;
            v5 = (v7 - v5 + 1) >> 1;
            v7 = t;

            // stage 2
            t = (v0 - v3 + 1) >> 1;
            v0 = (v0 + v3 + 1) >> 1;
            v3 = t;
            t = (v1 - v2 + 1) >> 1;
            v1 = (v1 + v2 + 1) >> 1;
            v2 = t;
            t = (v4 * dctSin3 + v7 * dctCos3 + 2048) >> 12;
            v4 = (v4 * dctCos3 - v7 * dctSin3 + 2048) >> 12;
            v7 = t;
            t = (v5 * dctSin1 + v6 * dctCos1 + 2048) >> 12;
            v5 = (v5 * dctCos1 - v6 * dctSin1 + 2048) >> 12;
            v6 = t;

            // stage 1
            p[0 + row] = v0 + v7;
            p[7 + row] = v0 - v7;
            p[1 + row] = v1 + v6;
            p[6 + row] = v1 - v6;
            p[2 + row] = v2 + v5;
            p[5 + row] = v2 - v5;
            p[3 + row] = v3 + v4;
            p[4 + row] = v3 - v4;
        }

        // inverse DCT on columns
        for (i = 0; i < 8; ++i) {
            var col = i;

            // check for all-zero AC coefficients
            if (p[1*8 + col] == 0 && p[2*8 + col] == 0 && p[3*8 + col] == 0 &&
                p[4*8 + col] == 0 && p[5*8 + col] == 0 && p[6*8 + col] == 0 &&
                p[7*8 + col] == 0) {
                t = (dctSqrt2 * p[i+0] + 8192) >> 14;
                p[0*8 + col] = t;
                p[1*8 + col] = t;
                p[2*8 + col] = t;
                p[3*8 + col] = t;
                p[4*8 + col] = t;
                p[5*8 + col] = t;
                p[6*8 + col] = t;
                p[7*8 + col] = t;
                continue;
            }

            // stage 4
            v0 = (dctSqrt2 * p[0*8 + col] + 2048) >> 12;
            v1 = (dctSqrt2 * p[4*8 + col] + 2048) >> 12;
            v2 = p[2*8 + col];
            v3 = p[6*8 + col];
            v4 = (dctSqrt1d2 * (p[1*8 + col] - p[7*8 + col]) + 2048) >> 12;
            v7 = (dctSqrt1d2 * (p[1*8 + col] + p[7*8 + col]) + 2048) >> 12;
            v5 = p[3*8 + col];
            v6 = p[5*8 + col];

            // stage 3
            t = (v0 - v1 + 1) >> 1;
            v0 = (v0 + v1 + 1) >> 1;
            v1 = t;
            t = (v2 * dctSin6 + v3 * dctCos6 + 2048) >> 12;
            v2 = (v2 * dctCos6 - v3 * dctSin6 + 2048) >> 12;
            v3 = t;
            t = (v4 - v6 + 1) >> 1;
            v4 = (v4 + v6 + 1) >> 1;
            v6 = t;
            t = (v7 + v5 + 1) >> 1;
            v5 = (v7 - v5 + 1) >> 1;
            v7 = t;

            // stage 2
            t = (v0 - v3 + 1) >> 1;
            v0 = (v0 + v3 + 1) >> 1;
            v3 = t;
            t = (v1 - v2 + 1) >> 1;
            v1 = (v1 + v2 + 1) >> 1;
            v2 = t;
            t = (v4 * dctSin3 + v7 * dctCos3 + 2048) >> 12;
            v4 = (v4 * dctCos3 - v7 * dctSin3 + 2048) >> 12;
            v7 = t;
            t = (v5 * dctSin1 + v6 * dctCos1 + 2048) >> 12;
            v5 = (v5 * dctCos1 - v6 * dctSin1 + 2048) >> 12;
            v6 = t;

            // stage 1
            p[0*8 + col] = v0 + v7;
            p[7*8 + col] = v0 - v7;
            p[1*8 + col] = v1 + v6;
            p[6*8 + col] = v1 - v6;
            p[2*8 + col] = v2 + v5;
            p[5*8 + col] = v2 - v5;
            p[3*8 + col] = v3 + v4;
            p[4*8 + col] = v3 - v4;
        }

        // convert to 8-bit integers
        for (i = 0; i < 64; ++i) {
            var index = blockBufferOffset + i;
            var q = p[i];
            q = (q <= -2056) ? 0 : (q >= 2024) ? 255 : (q + 2056) >> 4;
            component.blockData[index] = q;
        }
    }

    function buildComponentData(frame, component) {
        var blocksPerLine = component.blocksPerLine;
        var blocksPerColumn = component.blocksPerColumn;
        var computationBuffer = new Int32Array(64);
        for (var blockRow = 0; blockRow < blocksPerColumn; blockRow++) {
            for (var blockCol = 0; blockCol < blocksPerLine; blockCol++) {
                var offset = getBlockBufferOffset(component, blockRow, blockCol);
                quantizeAndInverse(component, offset, computationBuffer);
            }
        }
        return component.blockData;
    }

    function clampToUint8(a) {
        return a <= 0 ? 0 : a >= 255 ? 255 : a | 0;
    }

    constructor.prototype = {
        load: function load(path) {
            var xhr = new XMLHttpRequest();
            xhr.open("GET", path, true);
            xhr.responseType = "arraybuffer";
            xhr.onload = (function() {
                // TODO catch parse error
                var data = new Uint8Array(xhr.response || xhr.mozResponseArrayBuffer);
                this.parse(data);
                if (this.onload)
                    this.onload();
            }).bind(this);
            xhr.send(null);
        },

        loadFromBuffer: function loadFromBuffer(arrayBuffer) {
            this.parse(arrayBuffer);
            if (this.onload)
                this.onload();
        },

        parse: function parse(data) {

            function readUint16() {
                var value = (data[offset] << 8) | data[offset + 1];
                offset += 2;
                return value;
            }

            function readDataBlock() {
                var length = readUint16();
                var array = data.subarray(offset, offset + length - 2);
                offset += array.length;
                return array;
            }

            function prepareComponents(frame) {
                var mcusPerLine = Math.ceil(frame.samplesPerLine / 8 / frame.maxH);
                var mcusPerColumn = Math.ceil(frame.scanLines / 8 / frame.maxV);
                for (var i = 0; i < frame.components.length; i++) {
                    component = frame.components[i];
                    var blocksPerLine = Math.ceil(Math.ceil(frame.samplesPerLine / 8) * component.h / frame.maxH);
                    var blocksPerColumn = Math.ceil(Math.ceil(frame.scanLines  / 8) * component.v / frame.maxV);
                    var blocksPerLineForMcu = mcusPerLine * component.h;
                    var blocksPerColumnForMcu = mcusPerColumn * component.v;

                    var blocksBufferSize = 64 * blocksPerColumnForMcu
                        * (blocksPerLineForMcu + 1);
                    component.blockData = new Int16Array(blocksBufferSize);
                    component.blocksPerLine = blocksPerLine;
                    component.blocksPerColumn = blocksPerColumn;
                }
                frame.mcusPerLine = mcusPerLine;
                frame.mcusPerColumn = mcusPerColumn;
            }

            var offset = 0; data.length;
            var jfif = null;
            var adobe = null;
            var frame, resetInterval;
            var quantizationTables = [];
            var huffmanTablesAC = [], huffmanTablesDC = [];
            var fileMarker = readUint16();
            if (fileMarker != 0xFFD8) { // SOI (Start of Image)
                throw "SOI not found";
            }

            fileMarker = readUint16();
            while (fileMarker != 0xFFD9) { // EOI (End of image)
                var i, j, l;
                switch(fileMarker) {
                    case 0xFFE0: // APP0 (Application Specific)
                    case 0xFFE1: // APP1
                    case 0xFFE2: // APP2
                    case 0xFFE3: // APP3
                    case 0xFFE4: // APP4
                    case 0xFFE5: // APP5
                    case 0xFFE6: // APP6
                    case 0xFFE7: // APP7
                    case 0xFFE8: // APP8
                    case 0xFFE9: // APP9
                    case 0xFFEA: // APP10
                    case 0xFFEB: // APP11
                    case 0xFFEC: // APP12
                    case 0xFFED: // APP13
                    case 0xFFEE: // APP14
                    case 0xFFEF: // APP15
                    case 0xFFFE: // COM (Comment)
                        var appData = readDataBlock();

                        if (fileMarker === 0xFFE0) {
                            if (appData[0] === 0x4A && appData[1] === 0x46 && appData[2] === 0x49 &&
                                appData[3] === 0x46 && appData[4] === 0) { // 'JFIF\x00'
                                jfif = {
                                    version: { major: appData[5], minor: appData[6] },
                                    densityUnits: appData[7],
                                    xDensity: (appData[8] << 8) | appData[9],
                                    yDensity: (appData[10] << 8) | appData[11],
                                    thumbWidth: appData[12],
                                    thumbHeight: appData[13],
                                    thumbData: appData.subarray(14, 14 + 3 * appData[12] * appData[13])
                                };
                            }
                        }
                        // TODO APP1 - Exif
                        if (fileMarker === 0xFFEE) {
                            if (appData[0] === 0x41 && appData[1] === 0x64 && appData[2] === 0x6F &&
                                appData[3] === 0x62 && appData[4] === 0x65 && appData[5] === 0) { // 'Adobe\x00'
                                adobe = {
                                    version: appData[6],
                                    flags0: (appData[7] << 8) | appData[8],
                                    flags1: (appData[9] << 8) | appData[10],
                                    transformCode: appData[11]
                                };
                            }
                        }
                        break;

                    case 0xFFDB: // DQT (Define Quantization Tables)
                        var quantizationTablesLength = readUint16();
                        var quantizationTablesEnd = quantizationTablesLength + offset - 2;
                        while (offset < quantizationTablesEnd) {
                            var quantizationTableSpec = data[offset++];
                            var tableData = new Int32Array(64);
                            if ((quantizationTableSpec >> 4) === 0) { // 8 bit values
                                for (j = 0; j < 64; j++) {
                                    var z = dctZigZag[j];
                                    tableData[z] = data[offset++];
                                }
                            } else if ((quantizationTableSpec >> 4) === 1) { //16 bit
                                for (j = 0; j < 64; j++) {
                                    var z = dctZigZag[j];
                                    tableData[z] = readUint16();
                                }
                            } else
                                throw "DQT: invalid table spec";
                            quantizationTables[quantizationTableSpec & 15] = tableData;
                        }
                        break;

                    case 0xFFC0: // SOF0 (Start of Frame, Baseline DCT)
                    case 0xFFC1: // SOF1 (Start of Frame, Extended DCT)
                    case 0xFFC2: // SOF2 (Start of Frame, Progressive DCT)
                        if (frame) {
                            throw "Only single frame JPEGs supported";
                        }
                        readUint16(); // skip data length
                        frame = {};
                        frame.extended = (fileMarker === 0xFFC1);
                        frame.progressive = (fileMarker === 0xFFC2);
                        frame.precision = data[offset++];
                        frame.scanLines = readUint16();
                        frame.samplesPerLine = readUint16();
                        frame.components = [];
                        frame.componentIds = {};
                        var componentsCount = data[offset++], componentId;
                        var maxH = 0, maxV = 0;
                        for (i = 0; i < componentsCount; i++) {
                            componentId = data[offset];
                            var h = data[offset + 1] >> 4;
                            var v = data[offset + 1] & 15;
                            if (maxH < h) maxH = h;
                            if (maxV < v) maxV = v;
                            var qId = data[offset + 2];
                            var l = frame.components.push({
                                h: h,
                                v: v,
                                quantizationTable: quantizationTables[qId]
                            });
                            frame.componentIds[componentId] = l - 1;
                            offset += 3;
                        }
                        frame.maxH = maxH;
                        frame.maxV = maxV;
                        prepareComponents(frame);
                        break;

                    case 0xFFC4: // DHT (Define Huffman Tables)
                        var huffmanLength = readUint16();
                        for (i = 2; i < huffmanLength;) {
                            var huffmanTableSpec = data[offset++];
                            var codeLengths = new Uint8Array(16);
                            var codeLengthSum = 0;
                            for (j = 0; j < 16; j++, offset++)
                                codeLengthSum += (codeLengths[j] = data[offset]);
                            var huffmanValues = new Uint8Array(codeLengthSum);
                            for (j = 0; j < codeLengthSum; j++, offset++)
                                huffmanValues[j] = data[offset];
                            i += 17 + codeLengthSum;

                            ((huffmanTableSpec >> 4) === 0 ?
                                huffmanTablesDC : huffmanTablesAC)[huffmanTableSpec & 15] =
                                buildHuffmanTable(codeLengths, huffmanValues);
                        }
                        break;

                    case 0xFFDD: // DRI (Define Restart Interval)
                        readUint16(); // skip data length
                        resetInterval = readUint16();
                        break;

                    case 0xFFDA: // SOS (Start of Scan)
                        readUint16();
                        var selectorsCount = data[offset++];
                        var components = [], component;
                        for (i = 0; i < selectorsCount; i++) {
                            var componentIndex = frame.componentIds[data[offset++]];
                            component = frame.components[componentIndex];
                            var tableSpec = data[offset++];
                            component.huffmanTableDC = huffmanTablesDC[tableSpec >> 4];
                            component.huffmanTableAC = huffmanTablesAC[tableSpec & 15];
                            components.push(component);
                        }
                        var spectralStart = data[offset++];
                        var spectralEnd = data[offset++];
                        var successiveApproximation = data[offset++];
                        var processed = decodeScan(data, offset,
                            frame, components, resetInterval,
                            spectralStart, spectralEnd,
                            successiveApproximation >> 4, successiveApproximation & 15);
                        offset += processed;
                        break;
                    default:
                        if (data[offset - 3] == 0xFF &&
                            data[offset - 2] >= 0xC0 && data[offset - 2] <= 0xFE) {
                            // could be incorrect encoding -- last 0xFF byte of the previous
                            // block was eaten by the encoder
                            offset -= 3;
                            break;
                        }
                        throw "unknown JPEG marker " + fileMarker.toString(16);
                }
                fileMarker = readUint16();
            }

            this.width = frame.samplesPerLine;
            this.height = frame.scanLines;
            this.jfif = jfif;
            this.adobe = adobe;
            this.components = [];
            for (var i = 0; i < frame.components.length; i++) {
                var component = frame.components[i];
                this.components.push({
                    output: buildComponentData(frame, component),
                    scaleX: component.h / frame.maxH,
                    scaleY: component.v / frame.maxV,
                    blocksPerLine: component.blocksPerLine,
                    blocksPerColumn: component.blocksPerColumn
                });
            }
        },

        getData: function getData(imageData, width, height) {
            var scaleX = this.width / width, scaleY = this.height / height;

            var component, componentScaleX, componentScaleY;
            var x, y, i;
            var offset = 0;
            var numComponents = this.components.length;
            //var data = new Uint8Array(dataLength);
            var data = imageData.data;

            // lineData is reused for all components. Assume first component is
            // the biggest
            var lineData = new Uint8Array((this.components[0].blocksPerLine << 3) *
                this.components[0].blocksPerColumn * 8);

            // First construct image data ...
            for (i = 0; i < numComponents; i++) {
                component = this.components[i < 3 ? 2 - i : i];
                var blocksPerLine = component.blocksPerLine;
                var blocksPerColumn = component.blocksPerColumn;
                var samplesPerLine = blocksPerLine << 3;

                var j, k;
                var lineOffset = 0;
                for (var blockRow = 0; blockRow < blocksPerColumn; blockRow++) {
                    var scanLine = blockRow << 3;
                    for (var blockCol = 0; blockCol < blocksPerLine; blockCol++) {
                        var bufferOffset = getBlockBufferOffset(component, blockRow, blockCol);
                        var offset = 0, sample = blockCol << 3;
                        for (j = 0; j < 8; j++) {
                            var lineOffset = (scanLine + j) * samplesPerLine;
                            for (k = 0; k < 8; k++) {
                                lineData[lineOffset + sample + k] =
                                    component.output[bufferOffset + offset++];
                            }
                        }
                    }
                }

                componentScaleX = component.scaleX * scaleX;
                componentScaleY = component.scaleY * scaleY;
                offset = i;

                var cx, cy;
                var index;
                for (y = 0; y < height; y++) {
                    for (x = 0; x < width; x++) {
                        cy = 0 | (y * componentScaleY);
                        cx = 0 | (x * componentScaleX);
                        index = cy * samplesPerLine + cx;
                        data[offset] = lineData[index];
                        offset += numComponents;
                    }
                }
            }

          /*
           // ... then transform colors, if necessary
           switch (numComponents) {
           case 1: case 2: break;
           // no color conversion for one or two compoenents

           case 3:
           // The default transform for three components is true
           colorTransform = true;
           // The adobe transform marker overrides any previous setting
           if (this.adobe && this.adobe.transformCode)
           colorTransform = true;
           else if (typeof this.colorTransform !== 'undefined')
           colorTransform = !!this.colorTransform;

           if (colorTransform) {
           for (i = 0; i < dataLength; i += numComponents) {
           Y  = data[i    ];
           Cb = data[i + 1];
           Cr = data[i + 2];

           R = clampToUint8(Y - 179.456 + 1.402 * Cr);
           G = clampToUint8(Y + 135.459 - 0.344 * Cb - 0.714 * Cr);
           B = clampToUint8(Y - 226.816 + 1.772 * Cb);

           data[i    ] = R;
           data[i + 1] = G;
           data[i + 2] = B;
           }
           }
           break;
           case 4:
           console.log(this.colorTransform);
           if (!this.adobe)
           throw 'Unsupported color mode (4 components)';
           // The default transform for four components is false
           colorTransform = false;
           // The adobe transform marker overrides any previous setting
           if (this.adobe && this.adobe.transformCode)
           colorTransform = true;
           else if (typeof this.colorTransform !== 'undefined')
           colorTransform = !!this.colorTransform;

           if (colorTransform) {
           for (i = 0; i < dataLength; i += numComponents) {
           Y  = data[i];
           Cb = data[i + 1];
           Cr = data[i + 2];

           C = clampToUint8(434.456 - Y - 1.402 * Cr);
           M = clampToUint8(119.541 - Y + 0.344 * Cb + 0.714 * Cr);
           Y = clampToUint8(481.816 - Y - 1.772 * Cb);

           data[i    ] = C;
           data[i + 1] = M;
           data[i + 2] = Y;
           // K is unchanged
           }
           }
           break;
           default:
           throw 'Unsupported color mode';
           }
           */
            return data;
        },
        copyToImageData: function copyToImageData(imageData) {
            var width = imageData.width, height = imageData.height;
            var imageDataBytes = width * height * 4;
            var imageDataArray = imageData.data;
            var data = this.getData(width, height);
            var i = 0, j = 0, k0, k1;
            var Y, K, C, M, R, G, B;
            switch (this.components.length) {
                case 1:
                    while (j < imageDataBytes) {
                        Y = data[i++];

                        imageDataArray[j++] = Y;
                        imageDataArray[j++] = Y;
                        imageDataArray[j++] = Y;
                        imageDataArray[j++] = 255;
                    }
                    break;
                case 3:
                    while (j < imageDataBytes) {
                        R = data[i++];
                        G = data[i++];
                        B = data[i++];

                        imageDataArray[j++] = R;
                        imageDataArray[j++] = G;
                        imageDataArray[j++] = B;
                        imageDataArray[j++] = 255;
                    }
                    break;
                case 4:
                    while (j < imageDataBytes) {
                        C = data[i++];
                        M = data[i++];
                        Y = data[i++];
                        K = data[i++];

                        k0 = 255 - K;
                        k1 = k0 / 255;


                        R = clampToUint8(k0 - C * k1);
                        G = clampToUint8(k0 - M * k1);
                        B = clampToUint8(k0 - Y * k1);

                        imageDataArray[j++] = R;
                        imageDataArray[j++] = G;
                        imageDataArray[j++] = B;
                        imageDataArray[j++] = 255;
                    }
                    break;
                default:
                    throw 'Unsupported color mode';
            }
        }
    };

    return constructor;
})();

var decoder = function decode (data) {
    const jpegImage = new JpegImage();

    jpegImage.loadFromBuffer(data);

    var imageData;
    if (typeof ImageData !== 'undefined') {
        imageData = new ImageData(jpegImage.width, jpegImage.height);
    } else {
        imageData = {
            width: jpegImage.width,
            height: jpegImage.height,
            data: new Uint8ClampedArray(jpegImage.width * jpegImage.height * 4)
        };
    }
    jpegImage.getData(imageData, jpegImage.width, jpegImage.height);

    return imageData;
};

function keyword(view, offset) {
    return String.fromCharCode(view.getUint8(offset), view.getUint8(offset + 1), view.getUint8(offset + 2), view.getUint8(offset + 3));
}
function uint32(view, offset) {
    return view.getUint32(offset * 4, true);
}
function bitVal(data, bitCount, index) {
    // only 1, 4 or 8 bits
    var byte = data[Math.floor(index * bitCount / 8)], valsPerByte = 8 / bitCount;
    return (byte >> (valsPerByte - index % valsPerByte - 1)) & ((1 << bitCount) - 1);
}
// node.js have no native ImageData
function createImageData(width, height) {
    if (typeof ImageData !== 'undefined') {
        return new ImageData(width, height);
    }
    else {
        return {
            width: width,
            height: height,
            data: new Uint8ClampedArray(width * height * 4),
            colorSpace: 'srgb'
        };
    }
}
function decode(arrayBuffer) {
    var view = new DataView(arrayBuffer);
    var image = {
        type: BLPType.BLP1,
        width: 0,
        height: 0,
        content: BLPContent.JPEG,
        alphaBits: 0,
        mipmaps: [],
        data: arrayBuffer,
    };
    var type = keyword(view, 0);
    if (type === 'BLP0' || type === 'BLP2') {
        throw new Error('BLP0/BLP2 not supported');
    }
    if (type !== 'BLP1') {
        throw new Error('Not a blp image');
    }
    image.content = uint32(view, 1);
    if (image.content !== BLPContent.JPEG && image.content !== BLPContent.Direct) {
        throw new Error('Unknown BLP content');
    }
    image.alphaBits = uint32(view, 2);
    image.width = uint32(view, 3);
    image.height = uint32(view, 4);
    for (var i = 0; i < 16; ++i) {
        var mipmap = {
            offset: uint32(view, 7 + i),
            size: uint32(view, 7 + 16 + i)
        };
        if (mipmap.size > 0) {
            image.mipmaps.push(mipmap);
        }
        else {
            break;
        }
    }
    return image;
}
function getImageData(blp, mipmapLevel) {
    var view = new DataView(blp.data), uint8Data = new Uint8Array(blp.data), mipmap = blp.mipmaps[mipmapLevel];
    if (blp.content === BLPContent.JPEG) {
        var headerSize = uint32(view, 39), data = new Uint8Array(headerSize + mipmap.size);
        data.set(uint8Data.subarray(40 * 4, 40 * 4 + headerSize));
        data.set(uint8Data.subarray(mipmap.offset, mipmap.offset + mipmap.size), headerSize);
        return decoder(data);
    }
    else {
        var palette = new Uint8Array(blp.data, 39 * 4, 256 * 4), width = blp.width / (1 << mipmapLevel), height = blp.height / (1 << mipmapLevel), size = width * height, alphaData = new Uint8Array(blp.data, mipmap.offset + size, Math.ceil(size * blp.alphaBits / 8)), imageData = createImageData(width, height), valPerAlphaBit = 255 / ((1 << blp.alphaBits) - 1);
        for (var i = 0; i < size; ++i) {
            var paletteIndex = view.getUint8(mipmap.offset + i) * 4;
            // BGRA order
            imageData.data[i * 4] = palette[paletteIndex + 2];
            imageData.data[i * 4 + 1] = palette[paletteIndex + 1];
            imageData.data[i * 4 + 2] = palette[paletteIndex];
            if (blp.alphaBits > 0) {
                imageData.data[i * 4 + 3] = bitVal(alphaData, blp.alphaBits, i) * valPerAlphaBit;
            }
            else {
                imageData.data[i * 4 + 3] = 255;
            }
        }
        return imageData;
    }
}

var findKeyframesRes = {
    frame: 0,
    left: null,
    right: null
};
function lerp(left, right, t) {
    return left * (1 - t) + right * t;
}
function bezier(left, outTan, inTan, right, t) {
    var inverseFactor = 1 - t, inverseFactorTimesTwo = inverseFactor * inverseFactor, factorTimes2 = t * t, factor1 = inverseFactorTimesTwo * inverseFactor, factor2 = 3 * t * inverseFactorTimesTwo, factor3 = 3 * factorTimes2 * inverseFactor, factor4 = factorTimes2 * t;
    return left * factor1 + outTan * factor2 + inTan * factor3 + right * factor4;
}
function hermite(left, outTan, inTan, right, t) {
    var factorTimes2 = t * t, factor1 = factorTimes2 * (2 * t - 3) + 1, factor2 = factorTimes2 * (t - 2) + t, factor3 = factorTimes2 * (t - 1), factor4 = factorTimes2 * (3 - 2 * t);
    return left * factor1 + outTan * factor2 + inTan * factor3 + right * factor4;
}
function findKeyframes(animVector, frame, from, to) {
    if (!animVector) {
        return null;
    }
    var array = animVector.Keys;
    var first = 0;
    var count = array.length;
    if (count === 0) {
        return null;
    }
    if (array[0].Frame > to) {
        return null;
    }
    else if (array[count - 1].Frame < from) {
        return null;
    }
    while (count > 0) {
        var step = count >> 1;
        if (array[first + step].Frame <= frame) {
            first = first + step + 1;
            count -= step + 1;
        }
        else {
            count = step;
        }
    }
    if (first === array.length || array[first].Frame > to) {
        if (first > 0 && array[first - 1].Frame >= from) {
            findKeyframesRes.frame = frame;
            findKeyframesRes.left = array[first - 1];
            findKeyframesRes.right = array[first - 1];
            return findKeyframesRes;
        }
        else {
            return null;
        }
    }
    if (first === 0 || array[first - 1].Frame < from) {
        if (array[first].Frame <= to) {
            findKeyframesRes.frame = frame;
            findKeyframesRes.left = array[first];
            findKeyframesRes.right = array[first];
            return findKeyframesRes;
        }
        else {
            return null;
        }
    }
    findKeyframesRes.frame = frame;
    findKeyframesRes.left = array[first - 1];
    findKeyframesRes.right = array[first];
    return findKeyframesRes;
}
function interpNum(frame, left, right, lineType) {
    if (left.Frame === right.Frame) {
        return left.Vector[0];
    }
    var t = (frame - left.Frame) / (right.Frame - left.Frame);
    if (lineType === LineType.DontInterp) {
        return left.Vector[0];
    }
    else if (lineType === LineType.Bezier) {
        return bezier(left.Vector[0], left.OutTan[0], right.InTan[0], right.Vector[0], t);
    }
    else if (lineType === LineType.Hermite) {
        return hermite(left.Vector[0], left.OutTan[0], right.InTan[0], right.Vector[0], t);
    }
    else {
        // Linear
        return lerp(left.Vector[0], right.Vector[0], t);
    }
}
function interpVec3(out, frame, left, right, lineType) {
    if (left.Frame === right.Frame) {
        return left.Vector;
    }
    var t = (frame - left.Frame) / (right.Frame - left.Frame);
    if (lineType === LineType.DontInterp) {
        return left.Vector;
    }
    else if (lineType === LineType.Bezier) {
        return vec3.bezier(out, left.Vector, left.OutTan, right.InTan, right.Vector, t);
    }
    else if (lineType === LineType.Hermite) {
        return vec3.hermite(out, left.Vector, left.OutTan, right.InTan, right.Vector, t);
    }
    else {
        return vec3.lerp(out, left.Vector, right.Vector, t);
    }
}
function interpQuat(out, frame, left, right, lineType) {
    if (left.Frame === right.Frame) {
        return left.Vector;
    }
    var t = (frame - left.Frame) / (right.Frame - left.Frame);
    if (lineType === LineType.DontInterp) {
        return left.Vector;
    }
    else if (lineType === LineType.Hermite || lineType === LineType.Bezier) {
        return quat.sqlerp(out, left.Vector, left.OutTan, right.InTan, right.Vector, t);
    }
    else {
        return quat.slerp(out, left.Vector, right.Vector, t);
    }
}

var findLocalFrameRes = {
    frame: 0,
    from: 0,
    to: 0
};
var ModelInterp = /** @class */ (function () {
    function ModelInterp(rendererData) {
        this.rendererData = rendererData;
    }
    ModelInterp.maxAnimVectorVal = function (vector) {
        if (typeof vector === 'number') {
            return vector;
        }
        var max = vector.Keys[0].Vector[0];
        for (var i = 1; i < vector.Keys.length; ++i) {
            if (vector.Keys[i].Vector[0] > max) {
                max = vector.Keys[i].Vector[0];
            }
        }
        return max;
    };
    ModelInterp.prototype.num = function (animVector) {
        var res = this.findKeyframes(animVector);
        if (!res) {
            return null;
        }
        return interpNum(res.frame, res.left, res.right, animVector.LineType);
    };
    ModelInterp.prototype.vec3 = function (out, animVector) {
        var res = this.findKeyframes(animVector);
        if (!res) {
            return null;
        }
        return interpVec3(out, res.frame, res.left, res.right, animVector.LineType);
    };
    ModelInterp.prototype.quat = function (out, animVector) {
        var res = this.findKeyframes(animVector);
        if (!res) {
            return null;
        }
        return interpQuat(out, res.frame, res.left, res.right, animVector.LineType);
    };
    ModelInterp.prototype.animVectorVal = function (vector, defaultVal) {
        var res;
        if (typeof vector === 'number') {
            res = vector;
        }
        else {
            res = this.num(vector);
            if (res === null) {
                res = defaultVal;
            }
        }
        return res;
    };
    ModelInterp.prototype.findKeyframes = function (animVector) {
        if (!animVector) {
            return null;
        }
        var _a = this.findLocalFrame(animVector), frame = _a.frame, from = _a.from, to = _a.to;
        return findKeyframes(animVector, frame, from, to);
    };
    ModelInterp.prototype.findLocalFrame = function (animVector) {
        if (typeof animVector.GlobalSeqId === 'number') {
            findLocalFrameRes.frame = this.rendererData.globalSequencesFrames[animVector.GlobalSeqId];
            findLocalFrameRes.from = 0;
            findLocalFrameRes.to = this.rendererData.model.GlobalSequences[animVector.GlobalSeqId];
        }
        else {
            findLocalFrameRes.frame = this.rendererData.frame;
            findLocalFrameRes.from = this.rendererData.animationInfo.Interval[0];
            findLocalFrameRes.to = this.rendererData.animationInfo.Interval[1];
        }
        return findLocalFrameRes;
    };
    return ModelInterp;
}());

var rotateCenter = vec3.fromValues(0, 0, 0);
var firstColor = vec4.create();
var secondColor = vec4.create();
var color = vec4.create();
var tailPos = vec3.create();
var tailCross = vec3.create();
var vertexShader$1 = "\n    attribute vec3 aVertexPosition;\n    attribute vec2 aTextureCoord;\n    attribute vec4 aColor;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    varying vec2 vTextureCoord;\n    varying vec4 vColor;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vTextureCoord = aTextureCoord;\n        vColor = aColor;\n    }\n";
var fragmentShader$2 = "\n    precision mediump float;\n\n    varying vec2 vTextureCoord;\n    varying vec4 vColor;\n\n    uniform sampler2D uSampler;\n    uniform vec3 uReplaceableColor;\n    uniform float uReplaceableType;\n    uniform float uDiscardAlphaLevel;\n\n    float hypot (vec2 z) {\n        float t;\n        float x = abs(z.x);\n        float y = abs(z.y);\n        t = min(x, y);\n        x = max(x, y);\n        t = t / x;\n        return (z.x == 0.0 && z.y == 0.0) ? 0.0 : x * sqrt(1.0 + t * t);\n    }\n\n    void main(void) {\n        vec2 coords = vec2(vTextureCoord.s, vTextureCoord.t);\n        if (uReplaceableType == 0.) {\n            gl_FragColor = texture2D(uSampler, coords);\n        } else if (uReplaceableType == 1.) {\n            gl_FragColor = vec4(uReplaceableColor, 1.0);\n        } else if (uReplaceableType == 2.) {\n            float dist = hypot(coords - vec2(0.5, 0.5)) * 2.;\n            float truncateDist = clamp(1. - dist * 1.4, 0., 1.);\n            float alpha = sin(truncateDist);\n            gl_FragColor = vec4(uReplaceableColor * alpha, 1.0);\n        }\n        gl_FragColor *= vColor;\n        \n        if (gl_FragColor[3] < uDiscardAlphaLevel) {\n            discard;\n        }\n    }\n";
var DISCARD_ALPHA_KEY_LEVEL = 0.83;
var DISCARD_MODULATE_LEVEL = 0.01;
var ParticlesController = /** @class */ (function () {
    function ParticlesController(interp, rendererData) {
        this.shaderProgramLocations = {
            vertexPositionAttribute: null,
            textureCoordAttribute: null,
            colorAttribute: null,
            pMatrixUniform: null,
            mvMatrixUniform: null,
            samplerUniform: null,
            replaceableColorUniform: null,
            replaceableTypeUniform: null,
            discardAlphaLevelUniform: null
        };
        this.particleStorage = [];
        this.interp = interp;
        this.rendererData = rendererData;
        this.emitters = [];
        if (rendererData.model.ParticleEmitters2.length) {
            this.particleBaseVectors = [
                vec3.create(),
                vec3.create(),
                vec3.create(),
                vec3.create()
            ];
            for (var _i = 0, _a = rendererData.model.ParticleEmitters2; _i < _a.length; _i++) {
                var particleEmitter = _a[_i];
                var emitter = {
                    emission: 0,
                    squirtFrame: 0,
                    particles: [],
                    props: particleEmitter,
                    capacity: 0,
                    baseCapacity: 0,
                    type: particleEmitter.FrameFlags,
                    tailVertices: null,
                    tailVertexBuffer: null,
                    headVertices: null,
                    headVertexBuffer: null,
                    tailTexCoords: null,
                    tailTexCoordBuffer: null,
                    headTexCoords: null,
                    headTexCoordBuffer: null,
                    colors: null,
                    colorBuffer: null,
                    indices: null,
                    indexBuffer: null
                };
                emitter.baseCapacity = Math.ceil(ModelInterp.maxAnimVectorVal(emitter.props.EmissionRate) * emitter.props.LifeSpan);
                this.emitters.push(emitter);
            }
        }
    }
    ParticlesController.prototype.destroy = function () {
        if (this.shaderProgram) {
            if (this.vertexShader) {
                this.gl.detachShader(this.shaderProgram, this.vertexShader);
                this.gl.deleteShader(this.vertexShader);
                this.vertexShader = null;
            }
            if (this.fragmentShader) {
                this.gl.detachShader(this.shaderProgram, this.fragmentShader);
                this.gl.deleteShader(this.fragmentShader);
                this.fragmentShader = null;
            }
            this.gl.deleteProgram(this.shaderProgram);
            this.shaderProgram = null;
        }
        this.particleStorage = [];
    };
    ParticlesController.prototype.initGL = function (glContext) {
        this.gl = glContext;
        this.initShaders();
    };
    ParticlesController.prototype.initShaders = function () {
        var vertex = this.vertexShader = getShader(this.gl, vertexShader$1, this.gl.VERTEX_SHADER);
        var fragment = this.fragmentShader = getShader(this.gl, fragmentShader$2, this.gl.FRAGMENT_SHADER);
        var shaderProgram = this.shaderProgram = this.gl.createProgram();
        this.gl.attachShader(shaderProgram, vertex);
        this.gl.attachShader(shaderProgram, fragment);
        this.gl.linkProgram(shaderProgram);
        if (!this.gl.getProgramParameter(shaderProgram, this.gl.LINK_STATUS)) {
            alert('Could not initialise shaders');
        }
        this.gl.useProgram(shaderProgram);
        this.shaderProgramLocations.vertexPositionAttribute =
            this.gl.getAttribLocation(shaderProgram, 'aVertexPosition');
        this.shaderProgramLocations.textureCoordAttribute =
            this.gl.getAttribLocation(shaderProgram, 'aTextureCoord');
        this.shaderProgramLocations.colorAttribute =
            this.gl.getAttribLocation(shaderProgram, 'aColor');
        this.shaderProgramLocations.pMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uPMatrix');
        this.shaderProgramLocations.mvMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uMVMatrix');
        this.shaderProgramLocations.samplerUniform = this.gl.getUniformLocation(shaderProgram, 'uSampler');
        this.shaderProgramLocations.replaceableColorUniform =
            this.gl.getUniformLocation(shaderProgram, 'uReplaceableColor');
        this.shaderProgramLocations.replaceableTypeUniform =
            this.gl.getUniformLocation(shaderProgram, 'uReplaceableType');
        this.shaderProgramLocations.discardAlphaLevelUniform =
            this.gl.getUniformLocation(shaderProgram, 'uDiscardAlphaLevel');
    };
    ParticlesController.prototype.updateParticle = function (particle, delta) {
        delta /= 1000;
        particle.lifeSpan -= delta;
        if (particle.lifeSpan <= 0) {
            return;
        }
        particle.speed[2] -= particle.gravity * delta;
        particle.pos[0] += particle.speed[0] * delta;
        particle.pos[1] += particle.speed[1] * delta;
        particle.pos[2] += particle.speed[2] * delta;
    };
    ParticlesController.prototype.resizeEmitterBuffers = function (emitter, size) {
        if (size <= emitter.capacity) {
            return;
        }
        size = Math.max(size, emitter.baseCapacity);
        var tailVertices;
        var headVertices;
        var tailTexCoords;
        var headTexCoords;
        if (emitter.type & ParticleEmitter2FramesFlags.Tail) {
            tailVertices = new Float32Array(size * 4 * 3); // 4 vertices * xyz
            tailTexCoords = new Float32Array(size * 4 * 2); // 4 vertices * xy
        }
        if (emitter.type & ParticleEmitter2FramesFlags.Head) {
            headVertices = new Float32Array(size * 4 * 3); // 4 vertices * xyz
            headTexCoords = new Float32Array(size * 4 * 2); // 4 vertices * xy
        }
        var colors = new Float32Array(size * 4 * 4); // 4 vertices * rgba
        var indices = new Uint16Array(size * 6); // 4 vertices * 2 triangles
        if (emitter.capacity) {
            indices.set(emitter.indices);
        }
        for (var i = emitter.capacity; i < size; ++i) {
            indices[i * 6] = i * 4;
            indices[i * 6 + 1] = i * 4 + 1;
            indices[i * 6 + 2] = i * 4 + 2;
            indices[i * 6 + 3] = i * 4 + 2;
            indices[i * 6 + 4] = i * 4 + 1;
            indices[i * 6 + 5] = i * 4 + 3;
        }
        if (tailVertices) {
            emitter.tailVertices = tailVertices;
            emitter.tailTexCoords = tailTexCoords;
        }
        if (headVertices) {
            emitter.headVertices = headVertices;
            emitter.headTexCoords = headTexCoords;
        }
        emitter.colors = colors;
        emitter.indices = indices;
        emitter.capacity = size;
        if (!emitter.indexBuffer) {
            if (emitter.type & ParticleEmitter2FramesFlags.Tail) {
                emitter.tailVertexBuffer = this.gl.createBuffer();
                emitter.tailTexCoordBuffer = this.gl.createBuffer();
            }
            if (emitter.type & ParticleEmitter2FramesFlags.Head) {
                emitter.headVertexBuffer = this.gl.createBuffer();
                emitter.headTexCoordBuffer = this.gl.createBuffer();
            }
            emitter.colorBuffer = this.gl.createBuffer();
            emitter.indexBuffer = this.gl.createBuffer();
        }
    };
    ParticlesController.prototype.update = function (delta) {
        for (var _i = 0, _a = this.emitters; _i < _a.length; _i++) {
            var emitter = _a[_i];
            this.updateEmitter(emitter, delta);
        }
    };
    ParticlesController.prototype.render = function (mvMatrix, pMatrix) {
        this.gl.enable(this.gl.CULL_FACE);
        this.gl.useProgram(this.shaderProgram);
        this.gl.uniformMatrix4fv(this.shaderProgramLocations.pMatrixUniform, false, pMatrix);
        this.gl.uniformMatrix4fv(this.shaderProgramLocations.mvMatrixUniform, false, mvMatrix);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.vertexPositionAttribute);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.textureCoordAttribute);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.colorAttribute);
        for (var _i = 0, _a = this.emitters; _i < _a.length; _i++) {
            var emitter = _a[_i];
            if (!emitter.particles.length) {
                continue;
            }
            this.setLayerProps(emitter);
            this.setGeneralBuffers(emitter);
            if (emitter.type & ParticleEmitter2FramesFlags.Tail) {
                this.renderEmitterType(emitter, ParticleEmitter2FramesFlags.Tail);
            }
            if (emitter.type & ParticleEmitter2FramesFlags.Head) {
                this.renderEmitterType(emitter, ParticleEmitter2FramesFlags.Head);
            }
        }
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.vertexPositionAttribute);
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.textureCoordAttribute);
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.colorAttribute);
    };
    ParticlesController.prototype.updateEmitter = function (emitter, delta) {
        var visibility = this.interp.animVectorVal(emitter.props.Visibility, 1);
        if (visibility > 0) {
            if (emitter.props.Squirt && typeof emitter.props.EmissionRate !== 'number') {
                var interp = this.interp.findKeyframes(emitter.props.EmissionRate);
                if (interp && interp.left && interp.left.Frame !== emitter.squirtFrame) {
                    emitter.squirtFrame = interp.left.Frame;
                    if (interp.left.Vector[0] > 0) {
                        emitter.emission += interp.left.Vector[0] * 1000;
                    }
                }
            }
            else {
                var emissionRate = this.interp.animVectorVal(emitter.props.EmissionRate, 0);
                emitter.emission += emissionRate * delta;
            }
            while (emitter.emission >= 1000) {
                emitter.emission -= 1000;
                emitter.particles.push(this.createParticle(emitter, this.rendererData.nodes[emitter.props.ObjectId].matrix));
            }
        }
        if (emitter.particles.length) {
            var updatedParticles = [];
            for (var _i = 0, _a = emitter.particles; _i < _a.length; _i++) {
                var particle = _a[_i];
                this.updateParticle(particle, delta);
                if (particle.lifeSpan > 0) {
                    updatedParticles.push(particle);
                }
                else {
                    this.particleStorage.push(particle);
                }
            }
            emitter.particles = updatedParticles;
            if (emitter.type & ParticleEmitter2FramesFlags.Head) {
                if (emitter.props.Flags & ParticleEmitter2Flags.XYQuad) {
                    vec3.set(this.particleBaseVectors[0], -1, 1, 0);
                    vec3.set(this.particleBaseVectors[1], -1, -1, 0);
                    vec3.set(this.particleBaseVectors[2], 1, 1, 0);
                    vec3.set(this.particleBaseVectors[3], 1, -1, 0);
                }
                else {
                    vec3.set(this.particleBaseVectors[0], 0, -1, 1);
                    vec3.set(this.particleBaseVectors[1], 0, -1, -1);
                    vec3.set(this.particleBaseVectors[2], 0, 1, 1);
                    vec3.set(this.particleBaseVectors[3], 0, 1, -1);
                    for (var i = 0; i < 4; ++i) {
                        vec3.transformQuat(this.particleBaseVectors[i], this.particleBaseVectors[i], this.rendererData.cameraQuat);
                    }
                }
            }
            this.resizeEmitterBuffers(emitter, emitter.particles.length);
            for (var i = 0; i < emitter.particles.length; ++i) {
                this.updateParticleBuffers(emitter.particles[i], i, emitter);
            }
        }
    };
    ParticlesController.prototype.createParticle = function (emitter, emitterMatrix) {
        var particle;
        if (this.particleStorage.length) {
            particle = this.particleStorage.pop();
        }
        else {
            particle = {
                emitter: null,
                pos: vec3.create(),
                angle: 0,
                speed: vec3.create(),
                gravity: null,
                lifeSpan: null
            };
        }
        var width = this.interp.animVectorVal(emitter.props.Width, 0);
        var length = this.interp.animVectorVal(emitter.props.Length, 0);
        var speedScale = this.interp.animVectorVal(emitter.props.Speed, 0);
        var variation = this.interp.animVectorVal(emitter.props.Variation, 0);
        var latitude = degToRad(this.interp.animVectorVal(emitter.props.Latitude, 0));
        particle.emitter = emitter;
        particle.pos[0] = emitter.props.PivotPoint[0] + rand(-width, width);
        particle.pos[1] = emitter.props.PivotPoint[1] + rand(-length, length);
        particle.pos[2] = emitter.props.PivotPoint[2];
        vec3.transformMat4(particle.pos, particle.pos, emitterMatrix);
        if (variation > 0) {
            speedScale *= 1 + rand(-variation, variation);
        }
        vec3.set(particle.speed, 0, 0, speedScale);
        particle.angle = rand(0, Math.PI * 2);
        vec3.rotateY(particle.speed, particle.speed, rotateCenter, rand(0, latitude));
        vec3.rotateZ(particle.speed, particle.speed, rotateCenter, particle.angle);
        if (emitter.props.Flags & ParticleEmitter2Flags.LineEmitter) {
            particle.speed[0] = 0;
        }
        vec3.transformMat4(particle.speed, particle.speed, emitterMatrix);
        // minus translation of emitterMatrix
        particle.speed[0] -= emitterMatrix[12];
        particle.speed[1] -= emitterMatrix[13];
        particle.speed[2] -= emitterMatrix[14];
        particle.gravity = this.interp.animVectorVal(emitter.props.Gravity, 0);
        particle.lifeSpan = emitter.props.LifeSpan;
        return particle;
    };
    ParticlesController.prototype.updateParticleBuffers = function (particle, index, emitter) {
        var globalT = 1 - particle.lifeSpan / emitter.props.LifeSpan;
        var firstHalf = globalT < emitter.props.Time;
        var t;
        if (firstHalf) {
            t = globalT / emitter.props.Time;
        }
        else {
            t = (globalT - emitter.props.Time) / (1 - emitter.props.Time);
        }
        this.updateParticleVertices(particle, index, emitter, firstHalf, t);
        this.updateParticleTexCoords(index, emitter, firstHalf, t);
        this.updateParticleColor(index, emitter, firstHalf, t);
    };
    ParticlesController.prototype.updateParticleVertices = function (particle, index, emitter, firstHalf, t) {
        var firstScale;
        var secondScale;
        var scale;
        if (firstHalf) {
            firstScale = emitter.props.ParticleScaling[0];
            secondScale = emitter.props.ParticleScaling[1];
        }
        else {
            firstScale = emitter.props.ParticleScaling[1];
            secondScale = emitter.props.ParticleScaling[2];
        }
        // eslint-disable-next-line prefer-const
        scale = lerp(firstScale, secondScale, t);
        if (emitter.type & ParticleEmitter2FramesFlags.Head) {
            for (var i = 0; i < 4; ++i) {
                emitter.headVertices[index * 12 + i * 3] = this.particleBaseVectors[i][0] * scale;
                emitter.headVertices[index * 12 + i * 3 + 1] = this.particleBaseVectors[i][1] * scale;
                emitter.headVertices[index * 12 + i * 3 + 2] = this.particleBaseVectors[i][2] * scale;
                if (emitter.props.Flags & ParticleEmitter2Flags.XYQuad) {
                    var x = emitter.headVertices[index * 12 + i * 3];
                    var y = emitter.headVertices[index * 12 + i * 3 + 1];
                    emitter.headVertices[index * 12 + i * 3] = x * Math.cos(particle.angle) -
                        y * Math.sin(particle.angle);
                    emitter.headVertices[index * 12 + i * 3 + 1] = x * Math.sin(particle.angle) +
                        y * Math.cos(particle.angle);
                }
            }
        }
        if (emitter.type & ParticleEmitter2FramesFlags.Tail) {
            tailPos[0] = -particle.speed[0] * emitter.props.TailLength;
            tailPos[1] = -particle.speed[1] * emitter.props.TailLength;
            tailPos[2] = -particle.speed[2] * emitter.props.TailLength;
            vec3.cross(tailCross, particle.speed, this.rendererData.cameraPos);
            vec3.normalize(tailCross, tailCross);
            vec3.scale(tailCross, tailCross, scale);
            emitter.tailVertices[index * 12] = tailCross[0];
            emitter.tailVertices[index * 12 + 1] = tailCross[1];
            emitter.tailVertices[index * 12 + 2] = tailCross[2];
            emitter.tailVertices[index * 12 + 3] = -tailCross[0];
            emitter.tailVertices[index * 12 + 3 + 1] = -tailCross[1];
            emitter.tailVertices[index * 12 + 3 + 2] = -tailCross[2];
            emitter.tailVertices[index * 12 + 2 * 3] = tailCross[0] + tailPos[0];
            emitter.tailVertices[index * 12 + 2 * 3 + 1] = tailCross[1] + tailPos[1];
            emitter.tailVertices[index * 12 + 2 * 3 + 2] = tailCross[2] + tailPos[2];
            emitter.tailVertices[index * 12 + 3 * 3] = -tailCross[0] + tailPos[0];
            emitter.tailVertices[index * 12 + 3 * 3 + 1] = -tailCross[1] + tailPos[1];
            emitter.tailVertices[index * 12 + 3 * 3 + 2] = -tailCross[2] + tailPos[2];
        }
        for (var i = 0; i < 4; ++i) {
            if (emitter.headVertices) {
                emitter.headVertices[index * 12 + i * 3] += particle.pos[0];
                emitter.headVertices[index * 12 + i * 3 + 1] += particle.pos[1];
                emitter.headVertices[index * 12 + i * 3 + 2] += particle.pos[2];
            }
            if (emitter.tailVertices) {
                emitter.tailVertices[index * 12 + i * 3] += particle.pos[0];
                emitter.tailVertices[index * 12 + i * 3 + 1] += particle.pos[1];
                emitter.tailVertices[index * 12 + i * 3 + 2] += particle.pos[2];
            }
        }
    };
    ParticlesController.prototype.updateParticleTexCoords = function (index, emitter, firstHalf, t) {
        if (emitter.type & ParticleEmitter2FramesFlags.Head) {
            this.updateParticleTexCoordsByType(index, emitter, firstHalf, t, ParticleEmitter2FramesFlags.Head);
        }
        if (emitter.type & ParticleEmitter2FramesFlags.Tail) {
            this.updateParticleTexCoordsByType(index, emitter, firstHalf, t, ParticleEmitter2FramesFlags.Tail);
        }
    };
    ParticlesController.prototype.updateParticleTexCoordsByType = function (index, emitter, firstHalf, t, type) {
        var uvAnim;
        var texCoords;
        if (type === ParticleEmitter2FramesFlags.Tail) {
            uvAnim = firstHalf ? emitter.props.TailUVAnim : emitter.props.TailDecayUVAnim;
            texCoords = emitter.tailTexCoords;
        }
        else {
            uvAnim = firstHalf ? emitter.props.LifeSpanUVAnim : emitter.props.DecayUVAnim;
            texCoords = emitter.headTexCoords;
        }
        var firstFrame = uvAnim[0];
        var secondFrame = uvAnim[1];
        var frame = Math.round(lerp(firstFrame, secondFrame, t));
        var texCoordX = frame % emitter.props.Columns;
        var texCoordY = Math.floor(frame / emitter.props.Rows);
        var cellWidth = 1 / emitter.props.Columns;
        var cellHeight = 1 / emitter.props.Rows;
        texCoords[index * 8] = texCoordX * cellWidth;
        texCoords[index * 8 + 1] = texCoordY * cellHeight;
        texCoords[index * 8 + 2] = texCoordX * cellWidth;
        texCoords[index * 8 + 3] = (1 + texCoordY) * cellHeight;
        texCoords[index * 8 + 4] = (1 + texCoordX) * cellWidth;
        texCoords[index * 8 + 5] = texCoordY * cellHeight;
        texCoords[index * 8 + 6] = (1 + texCoordX) * cellWidth;
        texCoords[index * 8 + 7] = (1 + texCoordY) * cellHeight;
    };
    ParticlesController.prototype.updateParticleColor = function (index, emitter, firstHalf, t) {
        if (firstHalf) {
            firstColor[0] = emitter.props.SegmentColor[0][0];
            firstColor[1] = emitter.props.SegmentColor[0][1];
            firstColor[2] = emitter.props.SegmentColor[0][2];
            firstColor[3] = emitter.props.Alpha[0] / 255;
            secondColor[0] = emitter.props.SegmentColor[1][0];
            secondColor[1] = emitter.props.SegmentColor[1][1];
            secondColor[2] = emitter.props.SegmentColor[1][2];
            secondColor[3] = emitter.props.Alpha[1] / 255;
        }
        else {
            firstColor[0] = emitter.props.SegmentColor[1][0];
            firstColor[1] = emitter.props.SegmentColor[1][1];
            firstColor[2] = emitter.props.SegmentColor[1][2];
            firstColor[3] = emitter.props.Alpha[1] / 255;
            secondColor[0] = emitter.props.SegmentColor[2][0];
            secondColor[1] = emitter.props.SegmentColor[2][1];
            secondColor[2] = emitter.props.SegmentColor[2][2];
            secondColor[3] = emitter.props.Alpha[2] / 255;
        }
        vec4.lerp(color, firstColor, secondColor, t);
        for (var i = 0; i < 4; ++i) {
            emitter.colors[index * 16 + i * 4] = color[0];
            emitter.colors[index * 16 + i * 4 + 1] = color[1];
            emitter.colors[index * 16 + i * 4 + 2] = color[2];
            emitter.colors[index * 16 + i * 4 + 3] = color[3];
        }
    };
    ParticlesController.prototype.setLayerProps = function (emitter) {
        if (emitter.props.FilterMode === ParticleEmitter2FilterMode.AlphaKey) {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, DISCARD_ALPHA_KEY_LEVEL);
        }
        else if (emitter.props.FilterMode === ParticleEmitter2FilterMode.Modulate ||
            emitter.props.FilterMode === ParticleEmitter2FilterMode.Modulate2x) {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, DISCARD_MODULATE_LEVEL);
        }
        else {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.);
        }
        if (emitter.props.FilterMode === ParticleEmitter2FilterMode.Blend) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(false);
        }
        else if (emitter.props.FilterMode === ParticleEmitter2FilterMode.Additive) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (emitter.props.FilterMode === ParticleEmitter2FilterMode.AlphaKey) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (emitter.props.FilterMode === ParticleEmitter2FilterMode.Modulate) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.ZERO, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (emitter.props.FilterMode === ParticleEmitter2FilterMode.Modulate2x) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.DST_COLOR, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        var texture = this.rendererData.model.Textures[emitter.props.TextureID];
        if (texture.Image) {
            this.gl.activeTexture(this.gl.TEXTURE0);
            this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[texture.Image]);
            this.gl.uniform1i(this.shaderProgramLocations.samplerUniform, 0);
            this.gl.uniform1f(this.shaderProgramLocations.replaceableTypeUniform, 0);
        }
        else if (texture.ReplaceableId === 1 || texture.ReplaceableId === 2) {
            this.gl.uniform3fv(this.shaderProgramLocations.replaceableColorUniform, this.rendererData.teamColor);
            this.gl.uniform1f(this.shaderProgramLocations.replaceableTypeUniform, texture.ReplaceableId);
        }
    };
    ParticlesController.prototype.setGeneralBuffers = function (emitter) {
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.colorBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.colors, this.gl.DYNAMIC_DRAW);
        this.gl.vertexAttribPointer(this.shaderProgramLocations.colorAttribute, 4, this.gl.FLOAT, false, 0, 0);
        this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER, emitter.indexBuffer);
        this.gl.bufferData(this.gl.ELEMENT_ARRAY_BUFFER, emitter.indices, this.gl.DYNAMIC_DRAW);
    };
    ParticlesController.prototype.renderEmitterType = function (emitter, type) {
        if (type === ParticleEmitter2FramesFlags.Tail) {
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.tailTexCoordBuffer);
            this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.tailTexCoords, this.gl.DYNAMIC_DRAW);
        }
        else {
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.headTexCoordBuffer);
            this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.headTexCoords, this.gl.DYNAMIC_DRAW);
        }
        this.gl.vertexAttribPointer(this.shaderProgramLocations.textureCoordAttribute, 2, this.gl.FLOAT, false, 0, 0);
        if (type === ParticleEmitter2FramesFlags.Tail) {
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.tailVertexBuffer);
            this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.tailVertices, this.gl.DYNAMIC_DRAW);
        }
        else {
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.headVertexBuffer);
            this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.headVertices, this.gl.DYNAMIC_DRAW);
        }
        this.gl.vertexAttribPointer(this.shaderProgramLocations.vertexPositionAttribute, 3, this.gl.FLOAT, false, 0, 0);
        this.gl.drawElements(this.gl.TRIANGLES, emitter.particles.length * 6, this.gl.UNSIGNED_SHORT, 0);
    };
    return ParticlesController;
}());

var vertexShader = "\n    attribute vec3 aVertexPosition;\n    attribute vec2 aTextureCoord;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    varying vec2 vTextureCoord;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vTextureCoord = aTextureCoord;\n    }\n";
var fragmentShader$1 = "\n    precision mediump float;\n\n    varying vec2 vTextureCoord;\n\n    uniform sampler2D uSampler;\n    uniform vec3 uReplaceableColor;\n    uniform float uReplaceableType;\n    uniform float uDiscardAlphaLevel;\n    uniform vec4 uColor;\n\n    float hypot (vec2 z) {\n        float t;\n        float x = abs(z.x);\n        float y = abs(z.y);\n        t = min(x, y);\n        x = max(x, y);\n        t = t / x;\n        return (z.x == 0.0 && z.y == 0.0) ? 0.0 : x * sqrt(1.0 + t * t);\n    }\n\n    void main(void) {\n        vec2 coords = vec2(vTextureCoord.s, vTextureCoord.t);\n        if (uReplaceableType == 0.) {\n            gl_FragColor = texture2D(uSampler, coords);\n        } else if (uReplaceableType == 1.) {\n            gl_FragColor = vec4(uReplaceableColor, 1.0);\n        } else if (uReplaceableType == 2.) {\n            float dist = hypot(coords - vec2(0.5, 0.5)) * 2.;\n            float truncateDist = clamp(1. - dist * 1.4, 0., 1.);\n            float alpha = sin(truncateDist);\n            gl_FragColor = vec4(uReplaceableColor * alpha, 1.0);\n        }\n        gl_FragColor *= uColor;\n        \n        if (gl_FragColor[3] < uDiscardAlphaLevel) {\n            discard;\n        }\n    }\n";
var RibbonsController = /** @class */ (function () {
    function RibbonsController(interp, rendererData) {
        this.shaderProgramLocations = {
            vertexPositionAttribute: null,
            textureCoordAttribute: null,
            pMatrixUniform: null,
            mvMatrixUniform: null,
            samplerUniform: null,
            replaceableColorUniform: null,
            replaceableTypeUniform: null,
            discardAlphaLevelUniform: null,
            colorUniform: null
        };
        this.interp = interp;
        this.rendererData = rendererData;
        this.emitters = [];
        if (rendererData.model.RibbonEmitters.length) {
            for (var _i = 0, _a = rendererData.model.RibbonEmitters; _i < _a.length; _i++) {
                var ribbonEmitter = _a[_i];
                var emitter = {
                    emission: 0,
                    props: ribbonEmitter,
                    capacity: 0,
                    baseCapacity: 0,
                    creationTimes: [],
                    vertices: null,
                    vertexBuffer: null,
                    texCoords: null,
                    texCoordBuffer: null
                };
                emitter.baseCapacity = Math.ceil(ModelInterp.maxAnimVectorVal(emitter.props.EmissionRate) * emitter.props.LifeSpan) + 1; // extra points
                this.emitters.push(emitter);
            }
        }
    }
    RibbonsController.prototype.destroy = function () {
        if (this.shaderProgram) {
            if (this.vertexShader) {
                this.gl.detachShader(this.shaderProgram, this.vertexShader);
                this.gl.deleteShader(this.vertexShader);
                this.vertexShader = null;
            }
            if (this.fragmentShader) {
                this.gl.detachShader(this.shaderProgram, this.fragmentShader);
                this.gl.deleteShader(this.fragmentShader);
                this.fragmentShader = null;
            }
            this.gl.deleteProgram(this.shaderProgram);
            this.shaderProgram = null;
        }
        this.emitters = [];
    };
    RibbonsController.prototype.initGL = function (glContext) {
        this.gl = glContext;
        this.initShaders();
    };
    RibbonsController.prototype.update = function (delta) {
        for (var _i = 0, _a = this.emitters; _i < _a.length; _i++) {
            var emitter = _a[_i];
            this.updateEmitter(emitter, delta);
        }
    };
    RibbonsController.prototype.render = function (mvMatrix, pMatrix) {
        this.gl.useProgram(this.shaderProgram);
        this.gl.uniformMatrix4fv(this.shaderProgramLocations.pMatrixUniform, false, pMatrix);
        this.gl.uniformMatrix4fv(this.shaderProgramLocations.mvMatrixUniform, false, mvMatrix);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.vertexPositionAttribute);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.textureCoordAttribute);
        for (var _i = 0, _a = this.emitters; _i < _a.length; _i++) {
            var emitter = _a[_i];
            if (emitter.creationTimes.length < 2) {
                continue;
            }
            this.gl.uniform4f(this.shaderProgramLocations.colorUniform, emitter.props.Color[0], emitter.props.Color[1], emitter.props.Color[2], this.interp.animVectorVal(emitter.props.Alpha, 1));
            this.setGeneralBuffers(emitter);
            var materialID = emitter.props.MaterialID;
            var material = this.rendererData.model.Materials[materialID];
            for (var j = 0; j < material.Layers.length; ++j) {
                this.setLayerProps(material.Layers[j], this.rendererData.materialLayerTextureID[materialID][j]);
                this.renderEmitter(emitter);
            }
        }
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.vertexPositionAttribute);
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.textureCoordAttribute);
    };
    RibbonsController.prototype.initShaders = function () {
        var vertex = this.vertexShader = getShader(this.gl, vertexShader, this.gl.VERTEX_SHADER);
        var fragment = this.fragmentShader = getShader(this.gl, fragmentShader$1, this.gl.FRAGMENT_SHADER);
        var shaderProgram = this.shaderProgram = this.gl.createProgram();
        this.gl.attachShader(shaderProgram, vertex);
        this.gl.attachShader(shaderProgram, fragment);
        this.gl.linkProgram(shaderProgram);
        if (!this.gl.getProgramParameter(shaderProgram, this.gl.LINK_STATUS)) {
            alert('Could not initialise shaders');
        }
        this.gl.useProgram(shaderProgram);
        this.shaderProgramLocations.vertexPositionAttribute =
            this.gl.getAttribLocation(shaderProgram, 'aVertexPosition');
        this.shaderProgramLocations.textureCoordAttribute =
            this.gl.getAttribLocation(shaderProgram, 'aTextureCoord');
        this.shaderProgramLocations.pMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uPMatrix');
        this.shaderProgramLocations.mvMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uMVMatrix');
        this.shaderProgramLocations.samplerUniform = this.gl.getUniformLocation(shaderProgram, 'uSampler');
        this.shaderProgramLocations.replaceableColorUniform =
            this.gl.getUniformLocation(shaderProgram, 'uReplaceableColor');
        this.shaderProgramLocations.replaceableTypeUniform =
            this.gl.getUniformLocation(shaderProgram, 'uReplaceableType');
        this.shaderProgramLocations.discardAlphaLevelUniform =
            this.gl.getUniformLocation(shaderProgram, 'uDiscardAlphaLevel');
        this.shaderProgramLocations.colorUniform =
            this.gl.getUniformLocation(shaderProgram, 'uColor');
    };
    RibbonsController.prototype.resizeEmitterBuffers = function (emitter, size) {
        if (size <= emitter.capacity) {
            return;
        }
        size = Math.min(size, emitter.baseCapacity);
        var vertices = new Float32Array(size * 2 * 3); // 2 vertices * xyz
        var texCoords = new Float32Array(size * 2 * 2); // 2 vertices * xy
        if (emitter.vertices) {
            vertices.set(emitter.vertices);
        }
        emitter.vertices = vertices;
        emitter.texCoords = texCoords;
        emitter.capacity = size;
        if (!emitter.vertexBuffer) {
            emitter.vertexBuffer = this.gl.createBuffer();
            emitter.texCoordBuffer = this.gl.createBuffer();
        }
    };
    RibbonsController.prototype.updateEmitter = function (emitter, delta) {
        var now = Date.now();
        var visibility = this.interp.animVectorVal(emitter.props.Visibility, 0);
        if (visibility > 0) {
            var emissionRate = emitter.props.EmissionRate;
            emitter.emission += emissionRate * delta;
            if (emitter.emission >= 1000) {
                // only once per tick
                emitter.emission = emitter.emission % 1000;
                if (emitter.creationTimes.length + 1 > emitter.capacity) {
                    this.resizeEmitterBuffers(emitter, emitter.creationTimes.length + 1);
                }
                this.appendVertices(emitter);
                emitter.creationTimes.push(now);
            }
        }
        if (emitter.creationTimes.length) {
            while (emitter.creationTimes[0] + emitter.props.LifeSpan * 1000 < now) {
                emitter.creationTimes.shift();
                for (var i = 0; i + 6 + 5 < emitter.vertices.length; i += 6) {
                    emitter.vertices[i] = emitter.vertices[i + 6];
                    emitter.vertices[i + 1] = emitter.vertices[i + 7];
                    emitter.vertices[i + 2] = emitter.vertices[i + 8];
                    emitter.vertices[i + 3] = emitter.vertices[i + 9];
                    emitter.vertices[i + 4] = emitter.vertices[i + 10];
                    emitter.vertices[i + 5] = emitter.vertices[i + 11];
                }
            }
        }
        // still exists
        if (emitter.creationTimes.length) {
            this.updateEmitterTexCoords(emitter, now);
        }
    };
    RibbonsController.prototype.appendVertices = function (emitter) {
        var first = vec3.clone(emitter.props.PivotPoint);
        var second = vec3.clone(emitter.props.PivotPoint);
        first[1] -= this.interp.animVectorVal(emitter.props.HeightBelow, 0);
        second[1] += this.interp.animVectorVal(emitter.props.HeightAbove, 0);
        var emitterMatrix = this.rendererData.nodes[emitter.props.ObjectId].matrix;
        vec3.transformMat4(first, first, emitterMatrix);
        vec3.transformMat4(second, second, emitterMatrix);
        var currentSize = emitter.creationTimes.length;
        emitter.vertices[currentSize * 6] = first[0];
        emitter.vertices[currentSize * 6 + 1] = first[1];
        emitter.vertices[currentSize * 6 + 2] = first[2];
        emitter.vertices[currentSize * 6 + 3] = second[0];
        emitter.vertices[currentSize * 6 + 4] = second[1];
        emitter.vertices[currentSize * 6 + 5] = second[2];
    };
    RibbonsController.prototype.updateEmitterTexCoords = function (emitter, now) {
        for (var i = 0; i < emitter.creationTimes.length; ++i) {
            var relativePos = (now - emitter.creationTimes[i]) / (emitter.props.LifeSpan * 1000);
            var textureSlot = this.interp.animVectorVal(emitter.props.TextureSlot, 0);
            var texCoordX = textureSlot % emitter.props.Columns;
            var texCoordY = Math.floor(textureSlot / emitter.props.Rows);
            var cellWidth = 1 / emitter.props.Columns;
            var cellHeight = 1 / emitter.props.Rows;
            relativePos = texCoordX * cellWidth + relativePos * cellWidth;
            emitter.texCoords[i * 2 * 2] = relativePos;
            emitter.texCoords[i * 2 * 2 + 1] = texCoordY * cellHeight;
            emitter.texCoords[i * 2 * 2 + 2] = relativePos;
            emitter.texCoords[i * 2 * 2 + 3] = (1 + texCoordY) * cellHeight;
        }
    };
    RibbonsController.prototype.setLayerProps = function (layer, textureID) {
        var texture = this.rendererData.model.Textures[textureID];
        if (layer.Shading & LayerShading.TwoSided) {
            this.gl.disable(this.gl.CULL_FACE);
        }
        else {
            this.gl.enable(this.gl.CULL_FACE);
        }
        if (layer.FilterMode === FilterMode.Transparent) {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.75);
        }
        else {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.);
        }
        if (layer.FilterMode === FilterMode.None) {
            this.gl.disable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            // this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(true);
        }
        else if (layer.FilterMode === FilterMode.Transparent) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(true);
        }
        else if (layer.FilterMode === FilterMode.Blend) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.Additive) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_COLOR, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.AddAlpha) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.Modulate) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.ZERO, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.Modulate2x) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.DST_COLOR, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        if (texture.Image) {
            this.gl.activeTexture(this.gl.TEXTURE0);
            this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[texture.Image]);
            this.gl.uniform1i(this.shaderProgramLocations.samplerUniform, 0);
            this.gl.uniform1f(this.shaderProgramLocations.replaceableTypeUniform, 0);
        }
        else if (texture.ReplaceableId === 1 || texture.ReplaceableId === 2) {
            this.gl.uniform3fv(this.shaderProgramLocations.replaceableColorUniform, this.rendererData.teamColor);
            this.gl.uniform1f(this.shaderProgramLocations.replaceableTypeUniform, texture.ReplaceableId);
        }
        if (layer.Shading & LayerShading.NoDepthTest) {
            this.gl.disable(this.gl.DEPTH_TEST);
        }
        if (layer.Shading & LayerShading.NoDepthSet) {
            this.gl.depthMask(false);
        }
        /*if (typeof layer.TVertexAnimId === 'number') {
            let anim: TVertexAnim = this.rendererData.model.TextureAnims[layer.TVertexAnimId];
            let translationRes = this.interp.vec3(translation, anim.Translation);
            let rotationRes = this.interp.quat(rotation, anim.Rotation);
            let scalingRes = this.interp.vec3(scaling, anim.Scaling);
            mat4.fromRotationTranslationScale(
                texCoordMat4,
                rotationRes || defaultRotation,
                translationRes || defaultTranslation,
                scalingRes || defaultScaling
            );
            mat3.set(
                texCoordMat3,
                texCoordMat4[0], texCoordMat4[1], 0,
                texCoordMat4[4], texCoordMat4[5], 0,
                texCoordMat4[12], texCoordMat4[13], 0
            );

            this.gl.uniformMatrix3fv(this.shaderProgramLocations.tVertexAnimUniform, false, texCoordMat3);
        } else {
            this.gl.uniformMatrix3fv(this.shaderProgramLocations.tVertexAnimUniform, false, identifyMat3);
        }*/
    };
    RibbonsController.prototype.setGeneralBuffers = function (emitter) {
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.texCoordBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.texCoords, this.gl.DYNAMIC_DRAW);
        this.gl.vertexAttribPointer(this.shaderProgramLocations.textureCoordAttribute, 2, this.gl.FLOAT, false, 0, 0);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, emitter.vertexBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, emitter.vertices, this.gl.DYNAMIC_DRAW);
        this.gl.vertexAttribPointer(this.shaderProgramLocations.vertexPositionAttribute, 3, this.gl.FLOAT, false, 0, 0);
    };
    RibbonsController.prototype.renderEmitter = function (emitter) {
        this.gl.drawArrays(this.gl.TRIANGLE_STRIP, 0, emitter.creationTimes.length * 2);
    };
    return RibbonsController;
}());

var MAX_NODES = 254;
var ENV_MAP_SIZE = 2048;
var ENV_CONVOLUTE_DIFFUSE_SIZE = 32;
var ENV_PREFILTER_SIZE = 128;
var MAX_ENV_MIP_LEVELS = 8;
var BRDF_LUT_SIZE = 512;
var vertexShaderHardwareSkinning = "\n    attribute vec3 aVertexPosition;\n    attribute vec3 aNormal;\n    attribute vec2 aTextureCoord;\n    attribute vec4 aGroup;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n    uniform mat4 uNodesMatrices[".concat(MAX_NODES, "];\n\n    varying vec3 vNormal;\n    varying vec2 vTextureCoord;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        int count = 1;\n        vec4 sum = uNodesMatrices[int(aGroup[0])] * position;\n\n        if (aGroup[1] < ").concat(MAX_NODES, ".) {\n            sum += uNodesMatrices[int(aGroup[1])] * position;\n            count += 1;\n        }\n        if (aGroup[2] < ").concat(MAX_NODES, ".) {\n            sum += uNodesMatrices[int(aGroup[2])] * position;\n            count += 1;\n        }\n        if (aGroup[3] < ").concat(MAX_NODES, ".) {\n            sum += uNodesMatrices[int(aGroup[3])] * position;\n            count += 1;\n        }\n        sum.xyz /= float(count);\n        sum.w = 1.;\n        position = sum;\n\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vTextureCoord = aTextureCoord;\n        vNormal = aNormal;\n    }\n");
var vertexShaderSoftwareSkinning = "\n    attribute vec3 aVertexPosition;\n    attribute vec3 aNormal;\n    attribute vec2 aTextureCoord;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    varying vec3 vNormal;\n    varying vec2 vTextureCoord;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vTextureCoord = aTextureCoord;\n        vNormal = aNormal;\n    }\n";
var fragmentShader = "\n    precision mediump float;\n\n    varying vec3 vNormal;\n    varying vec2 vTextureCoord;\n\n    uniform sampler2D uSampler;\n    uniform vec3 uReplaceableColor;\n    uniform float uReplaceableType;\n    uniform float uDiscardAlphaLevel;\n    uniform mat3 uTVextexAnim;\n\n    float hypot (vec2 z) {\n        float t;\n        float x = abs(z.x);\n        float y = abs(z.y);\n        t = min(x, y);\n        x = max(x, y);\n        t = t / x;\n        return (z.x == 0.0 && z.y == 0.0) ? 0.0 : x * sqrt(1.0 + t * t);\n    }\n\n    void main(void) {\n        vec2 texCoord = (uTVextexAnim * vec3(vTextureCoord.s, vTextureCoord.t, 1.)).st;\n\n        if (uReplaceableType == 0.) {\n            gl_FragColor = texture2D(uSampler, texCoord);\n        } else if (uReplaceableType == 1.) {\n            gl_FragColor = vec4(uReplaceableColor, 1.0);\n        } else if (uReplaceableType == 2.) {\n            float dist = hypot(texCoord - vec2(0.5, 0.5)) * 2.;\n            float truncateDist = clamp(1. - dist * 1.4, 0., 1.);\n            float alpha = sin(truncateDist);\n            gl_FragColor = vec4(uReplaceableColor * alpha, 1.0);\n        }\n\n        // hand-made alpha-test\n        if (gl_FragColor[3] < uDiscardAlphaLevel) {\n            discard;\n        }\n    }\n";
var vertexShaderHDHardwareSkinningOld = "\n    attribute vec3 aVertexPosition;\n    attribute vec3 aNormal;\n    attribute vec2 aTextureCoord;\n    attribute vec4 aSkin;\n    attribute vec4 aBoneWeight;\n    attribute vec4 aTangent;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n    uniform mat4 uNodesMatrices[".concat(MAX_NODES, "];\n\n    varying vec3 vNormal;\n    varying vec3 vTangent;\n    varying vec3 vBinormal;\n    varying vec2 vTextureCoord;\n    varying mat3 vTBN;\n    varying vec3 vFragPos;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        mat4 sum;\n\n        // sum += uNodesMatrices[int(aSkin[0])] * 1.;\n        sum += uNodesMatrices[int(aSkin[0])] * aBoneWeight[0];\n        sum += uNodesMatrices[int(aSkin[1])] * aBoneWeight[1];\n        sum += uNodesMatrices[int(aSkin[2])] * aBoneWeight[2];\n        sum += uNodesMatrices[int(aSkin[3])] * aBoneWeight[3];\n\n        mat3 rotation = mat3(sum);\n\n        position = sum * position;\n        position.w = 1.;\n\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vTextureCoord = aTextureCoord;\n\n        vec3 normal = aNormal;\n        vec3 tangent = aTangent.xyz;\n\n        // https://learnopengl.com/Advanced-Lighting/Normal-Mapping\n        tangent = normalize(tangent - dot(tangent, normal) * normal);\n\n        vec3 binormal = cross(normal, tangent) * aTangent.w;\n\n        normal = normalize(rotation * normal);\n        tangent = normalize(rotation * tangent);\n        binormal = normalize(rotation * binormal);\n\n        vNormal = normal;\n        vTangent = tangent;\n        vBinormal = binormal;\n\n        vTBN = mat3(tangent, binormal, normal);\n\n        vFragPos = position.xyz;\n    }\n");
var vertexShaderHDHardwareSkinningNew = "#version 300 es\n    in vec3 aVertexPosition;\n    in vec3 aNormal;\n    in vec2 aTextureCoord;\n    in vec4 aSkin;\n    in vec4 aBoneWeight;\n    in vec4 aTangent;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n    uniform mat4 uNodesMatrices[".concat(MAX_NODES, "];\n\n    out vec3 vNormal;\n    out vec3 vTangent;\n    out vec3 vBinormal;\n    out vec2 vTextureCoord;\n    out mat3 vTBN;\n    out vec3 vFragPos;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        mat4 sum;\n\n        // sum += uNodesMatrices[int(aSkin[0])] * 1.;\n        sum += uNodesMatrices[int(aSkin[0])] * aBoneWeight[0];\n        sum += uNodesMatrices[int(aSkin[1])] * aBoneWeight[1];\n        sum += uNodesMatrices[int(aSkin[2])] * aBoneWeight[2];\n        sum += uNodesMatrices[int(aSkin[3])] * aBoneWeight[3];\n\n        mat3 rotation = mat3(sum);\n\n        position = sum * position;\n        position.w = 1.;\n\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vTextureCoord = aTextureCoord;\n\n        vec3 normal = aNormal;\n        vec3 tangent = aTangent.xyz;\n\n        // https://learnopengl.com/Advanced-Lighting/Normal-Mapping\n        tangent = normalize(tangent - dot(tangent, normal) * normal);\n\n        vec3 binormal = cross(normal, tangent) * aTangent.w;\n\n        normal = normalize(rotation * normal);\n        tangent = normalize(rotation * tangent);\n        binormal = normalize(rotation * binormal);\n\n        vNormal = normal;\n        vTangent = tangent;\n        vBinormal = binormal;\n\n        vTBN = mat3(tangent, binormal, normal);\n\n        vFragPos = position.xyz;\n    }\n");
var fragmentShaderHDOld = "\n    precision mediump float;\n\n    varying vec2 vTextureCoord;\n    varying vec3 vNormal;\n    varying vec3 vTangent;\n    varying vec3 vBinormal;\n    varying mat3 vTBN;\n    varying vec3 vFragPos;\n\n    uniform sampler2D uSampler;\n    uniform sampler2D uNormalSampler;\n    uniform sampler2D uOrmSampler;\n    uniform vec3 uReplaceableColor;\n    uniform float uDiscardAlphaLevel;\n    uniform mat3 uTVextexAnim;\n    uniform vec3 uLightPos;\n    uniform vec3 uLightColor;\n    uniform vec3 uCameraPos;\n    uniform vec3 uShadowParams;\n    uniform sampler2D uShadowMapSampler;\n    uniform mat4 uShadowMapLightMatrix;\n\n    const float PI = 3.14159265359;\n    const float gamma = 2.2;\n\n    float distributionGGX(vec3 normal, vec3 halfWay, float roughness) {\n        float a = roughness * roughness;\n        float a2 = a * a;\n        float nDotH = max(dot(normal, halfWay), 0.0);\n        float nDotH2 = nDotH * nDotH;\n\n        float num = a2;\n        float denom = (nDotH2 * (a2 - 1.0) + 1.0);\n        denom = PI * denom * denom;\n\n        return num / denom;\n    }\n\n    float geometrySchlickGGX(float nDotV, float roughness) {\n        float r = roughness + 1.;\n        float k = r * r / 8.;\n        // float k = roughness * roughness / 2.;\n\n        float num = nDotV;\n        float denom = nDotV * (1. - k) + k;\n\n        return num / denom;\n    }\n\n    float geometrySmith(vec3 normal, vec3 viewDir, vec3 lightDir, float roughness) {\n        float nDotV = max(dot(normal, viewDir), .0);\n        float nDotL = max(dot(normal, lightDir), .0);\n        float ggx2  = geometrySchlickGGX(nDotV, roughness);\n        float ggx1  = geometrySchlickGGX(nDotL, roughness);\n\n        return ggx1 * ggx2;\n    }\n\n    vec3 fresnelSchlick(float lightFactor, vec3 f0) {\n        return f0 + (1. - f0) * pow(clamp(1. - lightFactor, 0., 1.), 5.);\n    }\n\n    void main(void) {\n        vec2 texCoord = (uTVextexAnim * vec3(vTextureCoord.s, vTextureCoord.t, 1.)).st;\n\n        vec4 orm = texture2D(uOrmSampler, texCoord);\n\n        float occlusion = orm.r;\n        float roughness = orm.g;\n        float metallic = orm.b;\n        float teamColorFactor = orm.a;\n\n        vec4 baseColor = texture2D(uSampler, texCoord);\n        vec3 teamColor = baseColor.rgb * uReplaceableColor;\n        baseColor.rgb = mix(baseColor.rgb, teamColor, teamColorFactor);\n        baseColor.rgb = pow(baseColor.rgb, vec3(gamma));\n\n        vec3 normal = texture2D(uNormalSampler, texCoord).rgb;\n        normal = normal * 2.0 - 1.0;\n        normal.x = -normal.x;\n        normal.y = -normal.y;\n        normal = normalize(vTBN * -normal);\n\n        vec3 viewDir = normalize(uCameraPos - vFragPos);\n        vec3 reflected = reflect(-viewDir, normal);\n\n        vec3 lightDir = normalize(uLightPos - vFragPos);\n        float lightFactor = max(dot(normal, lightDir), .0);\n        vec3 radiance = uLightColor;\n\n        vec3 f0 = vec3(.04);\n        f0 = mix(f0, baseColor.rgb, metallic);\n\n        vec3 totalLight = vec3(0.);\n        vec3 halfWay = normalize(viewDir + lightDir);\n        float ndf = distributionGGX(normal, halfWay, roughness);\n        float g = geometrySmith(normal, viewDir, lightDir, roughness);\n        vec3 f = fresnelSchlick(max(dot(halfWay, viewDir), 0.), f0);\n\n        vec3 kS = f;\n        // vec3 kD = vec3(1.) - kS;\n        vec3 kD = vec3(1.);\n        // kD *= 1.0 - metallic;\n        vec3 num = ndf * g * f;\n        float denom = 4. * max(dot(normal, viewDir), 0.) * max(dot(normal, lightDir), 0.) + .0001;\n        vec3 specular = num / denom;\n\n        totalLight = (kD * baseColor.rgb / PI + specular) * radiance * lightFactor;\n\n        if (uShadowParams[0] > .5) {\n            float shadowBias = uShadowParams[1];\n            float shadowStep = uShadowParams[2];\n            vec4 fragInLightPos = uShadowMapLightMatrix * vec4(vFragPos, 1.);\n            vec3 shadowMapCoord = fragInLightPos.xyz / fragInLightPos.w;\n\n            int passes = 5;\n            float step = 1. / float(passes);\n\n            float lightDepth = texture2D(uShadowMapSampler, shadowMapCoord.xy).r;\n            float lightDepth0 = texture2D(uShadowMapSampler, vec2(shadowMapCoord.x + shadowStep, shadowMapCoord.y)).r;\n            float lightDepth1 = texture2D(uShadowMapSampler, vec2(shadowMapCoord.x, shadowMapCoord.y + shadowStep)).r;\n            float lightDepth2 = texture2D(uShadowMapSampler, vec2(shadowMapCoord.x, shadowMapCoord.y - shadowStep)).r;\n            float lightDepth3 = texture2D(uShadowMapSampler, vec2(shadowMapCoord.x - shadowStep, shadowMapCoord.y)).r;\n            float currentDepth = shadowMapCoord.z;\n\n            float visibility = 0.;\n            if (lightDepth > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth0 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth1 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth2 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth3 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n\n            totalLight *= visibility;\n        }\n\n        vec3 color;\n\n        vec3 ambient = vec3(.03);\n        ambient *= baseColor.rgb * occlusion;\n        color = ambient + totalLight;\n\n        color = color / (vec3(1.) + color);\n        color = pow(color, vec3(1. / gamma));\n\n        gl_FragColor = vec4(color, 1.);\n\n        // hand-made alpha-test\n        if (gl_FragColor[3] < uDiscardAlphaLevel) {\n            discard;\n        }\n    }\n";
var fragmentShaderHDNew = "#version 300 es\n    precision mediump float;\n\n    in vec2 vTextureCoord;\n    in vec3 vNormal;\n    in vec3 vTangent;\n    in vec3 vBinormal;\n    in mat3 vTBN;\n    in vec3 vFragPos;\n\n    out vec4 FragColor;\n\n    uniform sampler2D uSampler;\n    uniform sampler2D uNormalSampler;\n    uniform sampler2D uOrmSampler;\n    uniform vec3 uReplaceableColor;\n    uniform float uDiscardAlphaLevel;\n    uniform mat3 uTVextexAnim;\n    uniform vec3 uLightPos;\n    uniform vec3 uLightColor;\n    uniform vec3 uCameraPos;\n    uniform vec3 uShadowParams;\n    uniform sampler2D uShadowMapSampler;\n    uniform mat4 uShadowMapLightMatrix;\n    uniform bool uHasEnv;\n    uniform samplerCube uIrradianceMap;\n    uniform samplerCube uPrefilteredEnv;\n    uniform sampler2D uBRDFLUT;\n\n    const float PI = 3.14159265359;\n    const float gamma = 2.2;\n    const float MAX_REFLECTION_LOD = ".concat(MAX_ENV_MIP_LEVELS.toFixed(1), ";\n\n    float distributionGGX(vec3 normal, vec3 halfWay, float roughness) {\n        float a = roughness * roughness;\n        float a2 = a * a;\n        float nDotH = max(dot(normal, halfWay), 0.0);\n        float nDotH2 = nDotH * nDotH;\n\n        float num = a2;\n        float denom = (nDotH2 * (a2 - 1.0) + 1.0);\n        denom = PI * denom * denom;\n\n        return num / denom;\n    }\n\n    float geometrySchlickGGX(float nDotV, float roughness) {\n        float r = roughness + 1.;\n        float k = r * r / 8.;\n        // float k = roughness * roughness / 2.;\n\n        float num = nDotV;\n        float denom = nDotV * (1. - k) + k;\n\n        return num / denom;\n    }\n\n    float geometrySmith(vec3 normal, vec3 viewDir, vec3 lightDir, float roughness) {\n        float nDotV = max(dot(normal, viewDir), .0);\n        float nDotL = max(dot(normal, lightDir), .0);\n        float ggx2  = geometrySchlickGGX(nDotV, roughness);\n        float ggx1  = geometrySchlickGGX(nDotL, roughness);\n\n        return ggx1 * ggx2;\n    }\n\n    vec3 fresnelSchlick(float lightFactor, vec3 f0) {\n        return f0 + (1. - f0) * pow(clamp(1. - lightFactor, 0., 1.), 5.);\n    }\n\n    vec3 fresnelSchlickRoughness(float lightFactor, vec3 f0, float roughness) {\n        return f0 + (max(vec3(1.0 - roughness), f0) - f0) * pow(clamp(1.0 - lightFactor, 0.0, 1.0), 5.0);\n    }\n\n    void main(void) {\n        vec2 texCoord = (uTVextexAnim * vec3(vTextureCoord.s, vTextureCoord.t, 1.)).st;\n\n        vec4 orm = texture(uOrmSampler, texCoord);\n\n        float occlusion = orm.r;\n        float roughness = orm.g;\n        float metallic = orm.b;\n        float teamColorFactor = orm.a;\n\n        vec4 baseColor = texture(uSampler, texCoord);\n        vec3 teamColor = baseColor.rgb * uReplaceableColor;\n        baseColor.rgb = mix(baseColor.rgb, teamColor, teamColorFactor);\n        baseColor.rgb = pow(baseColor.rgb, vec3(gamma));\n\n        vec3 normal = texture(uNormalSampler, texCoord).rgb;\n        normal = normal * 2.0 - 1.0;\n        normal.x = -normal.x;\n        normal.y = -normal.y;\n        normal = normalize(vTBN * -normal);\n\n        vec3 viewDir = normalize(uCameraPos - vFragPos);\n        vec3 reflected = reflect(-viewDir, normal);\n\n        vec3 lightDir = normalize(uLightPos - vFragPos);\n        float lightFactor = max(dot(normal, lightDir), .0);\n        vec3 radiance = uLightColor;\n\n        vec3 f0 = vec3(.04);\n        f0 = mix(f0, baseColor.rgb, metallic);\n\n        vec3 totalLight = vec3(0.);\n        vec3 halfWay = normalize(viewDir + lightDir);\n        float ndf = distributionGGX(normal, halfWay, roughness);\n        float g = geometrySmith(normal, viewDir, lightDir, roughness);\n        vec3 f = fresnelSchlick(max(dot(halfWay, viewDir), 0.), f0);\n\n        vec3 kS = f;\n        vec3 kD = vec3(1.) - kS;\n        if (uHasEnv) {\n            kD *= 1.0 - metallic;\n        }\n        vec3 num = ndf * g * f;\n        float denom = 4. * max(dot(normal, viewDir), 0.) * max(dot(normal, lightDir), 0.) + .0001;\n        vec3 specular = num / denom;\n\n        totalLight = (kD * baseColor.rgb / PI + specular) * radiance * lightFactor;\n\n        if (uShadowParams[0] > .5) {\n            float shadowBias = uShadowParams[1];\n            float shadowStep = uShadowParams[2];\n            vec4 fragInLightPos = uShadowMapLightMatrix * vec4(vFragPos, 1.);\n            vec3 shadowMapCoord = fragInLightPos.xyz / fragInLightPos.w;\n\n            int passes = 5;\n            float step = 1. / float(passes);\n\n            float lightDepth = texture(uShadowMapSampler, shadowMapCoord.xy).r;\n            float lightDepth0 = texture(uShadowMapSampler, vec2(shadowMapCoord.x + shadowStep, shadowMapCoord.y)).r;\n            float lightDepth1 = texture(uShadowMapSampler, vec2(shadowMapCoord.x, shadowMapCoord.y + shadowStep)).r;\n            float lightDepth2 = texture(uShadowMapSampler, vec2(shadowMapCoord.x, shadowMapCoord.y - shadowStep)).r;\n            float lightDepth3 = texture(uShadowMapSampler, vec2(shadowMapCoord.x - shadowStep, shadowMapCoord.y)).r;\n            float currentDepth = shadowMapCoord.z;\n\n            float visibility = 0.;\n            if (lightDepth > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth0 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth1 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth2 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n            if (lightDepth3 > currentDepth - shadowBias) {\n                visibility += step;\n            }\n\n            totalLight *= visibility;\n        }\n\n        vec3 color;\n\n        if (uHasEnv) {\n            vec3 f = fresnelSchlickRoughness(max(dot(normal, viewDir), 0.0), f0, roughness);\n            vec3 kS = f;\n            vec3 kD = vec3(1.0) - kS;\n            kD *= 1.0 - metallic;\n\n            vec3 diffuse = texture(uIrradianceMap, normal).rgb * baseColor.rgb;\n            vec3 prefilteredColor = textureLod(uPrefilteredEnv, reflected, roughness * MAX_REFLECTION_LOD).rgb;\n            vec2 envBRDF = texture(uBRDFLUT, vec2(max(dot(normal, viewDir), 0.0), roughness)).rg;\n            specular = prefilteredColor * (f * envBRDF.x + envBRDF.y);\n\n            vec3 ambient = (kD * diffuse + specular) * occlusion;\n            color = ambient + totalLight;\n        } else {\n            vec3 ambient = vec3(.03);\n            ambient *= baseColor.rgb * occlusion;\n            color = ambient + totalLight;\n        }\n\n        color = color / (vec3(1.) + color);\n        color = pow(color, vec3(1. / gamma));\n\n        FragColor = vec4(color, 1.);\n\n        // hand-made alpha-test\n        if (FragColor[3] < uDiscardAlphaLevel) {\n            discard;\n        }\n    }\n");
var skeletonVertexShader = "\n    attribute vec3 aVertexPosition;\n    attribute vec3 aColor;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    varying vec3 vColor;\n\n    void main(void) {\n        vec4 position = vec4(aVertexPosition, 1.0);\n        gl_Position = uPMatrix * uMVMatrix * position;\n        vColor = aColor;\n    }\n";
var skeletonFragmentShader = "\n    precision mediump float;\n\n    varying vec3 vColor;\n\n    void main(void) {\n        gl_FragColor = vec4(vColor, 1.0);\n    }\n";
var envToCubemapVertexShader = "\n    attribute vec3 aPos;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    varying vec3 vLocalPos;\n\n    void main(void) {\n        vLocalPos = aPos;\n        gl_Position = uPMatrix * uMVMatrix * vec4(aPos, 1.0);\n    }\n";
var envToCubemapFragmentShader = "\n    precision mediump float;\n\n    varying vec3 vLocalPos;\n\n    uniform sampler2D uEquirectangularMap;\n\n    const vec2 invAtan = vec2(0.1591, 0.3183);\n\n    vec2 SampleSphericalMap(vec3 v) {\n        // vec2 uv = vec2(atan(v.z, v.x), asin(v.y));\n        vec2 uv = vec2(atan(v.x, v.y), asin(-v.z));\n        uv *= invAtan;\n        uv += 0.5;\n        return uv;\n    }\n\n    void main(void) {\n        vec2 uv = SampleSphericalMap(normalize(vLocalPos)); // make sure to normalize localPos\n        vec3 color = texture2D(uEquirectangularMap, uv).rgb;\n\n        gl_FragColor = vec4(color, 1.0);\n        // gl_FragColor = vec4(vLocalPos, 1.0);\n    }\n";
var envVertexShader = "#version 300 es\n    in vec3 aPos;\n    out vec3 vLocalPos;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    void main(void) {\n        vLocalPos = aPos;\n        mat4 rotView = mat4(mat3(uMVMatrix)); // remove translation from the view matrix\n        vec4 clipPos = uPMatrix * rotView * 1000. * vec4(aPos, 1.0);\n\n        gl_Position = clipPos.xyww;\n        // gl_Position = uPMatrix * uMVMatrix * vec4(aPos, 1.0);\n    }\n";
var envFragmentShader = "#version 300 es\n    precision mediump float;\n\n    in vec3 vLocalPos;\n\n    out vec4 FragColor;\n\n    uniform samplerCube uEnvironmentMap;\n\n    void main(void) {\n        // vec3 envColor = textureLod(uEnvironmentMap, vLocalPos, 0.0).rgb;\n        vec3 envColor = texture(uEnvironmentMap, vLocalPos).rgb;\n\n        FragColor = vec4(envColor, 1.0);\n    }\n";
var convoluteEnvDiffuseVertexShader = "\n    attribute vec3 aPos;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    varying vec3 vLocalPos;\n\n    void main(void) {\n        vLocalPos = aPos;\n        gl_Position = uPMatrix * uMVMatrix * vec4(aPos, 1.0);\n    }\n";
var convoluteEnvDiffuseFragmentShader = "\n    precision mediump float;\n\n    varying vec3 vLocalPos;\n\n    uniform samplerCube uEnvironmentMap;\n\n    const float PI = 3.14159265359;\n    const float gamma = 2.2;\n\n    void main(void) {\n        vec3 irradiance = vec3(0.0);\n\n        // the sample direction equals the hemisphere's orientation\n        vec3 normal = normalize(vLocalPos);\n\n        vec3 up    = vec3(0.0, 1.0, 0.0);\n        vec3 right = normalize(cross(up, normal));\n        up         = normalize(cross(normal, right));\n\n        const float sampleDelta = 0.025;\n        float nrSamples = 0.0;\n        for(float phi = 0.0; phi < 2.0 * PI; phi += sampleDelta)\n        {\n            for(float theta = 0.0; theta < 0.5 * PI; theta += sampleDelta)\n            {\n                // spherical to cartesian (in tangent space)\n                vec3 tangentSample = vec3(sin(theta) * cos(phi),  sin(theta) * sin(phi), cos(theta));\n                // tangent space to world\n                vec3 sampleVec = tangentSample.x * right + tangentSample.y * up + tangentSample.z * normal;\n\n                irradiance += pow(textureCube(uEnvironmentMap, sampleVec).rgb, vec3(gamma)) * cos(theta) * sin(theta);\n                nrSamples++;\n            }\n        }\n        irradiance = PI * irradiance * (1.0 / float(nrSamples));\n\n        gl_FragColor = vec4(irradiance, 1.0);\n        // gl_FragColor = vec4(textureCube(uEnvironmentMap, vLocalPos).rgb, 1.0);\n        // gl_FragColor = vec4(1.0);\n    }\n";
var prefilterEnvVertexShader = "#version 300 es\n    in vec3 aPos;\n\n    out vec3 vLocalPos;\n\n    uniform mat4 uMVMatrix;\n    uniform mat4 uPMatrix;\n\n    void main(void) {\n        vLocalPos = aPos;\n        gl_Position = uPMatrix * uMVMatrix * vec4(aPos, 1.0);\n    }\n";
var prefilterEnvFragmentShader = "#version 300 es\n    precision mediump float;\n\n    out vec4 FragColor;\n\n    in vec3 vLocalPos;\n\n    uniform samplerCube uEnvironmentMap;\n    uniform float uRoughness;\n\n    const float PI = 3.14159265359;\n    const float gamma = 2.2;\n\n    float RadicalInverse_VdC(uint bits) {\n        bits = (bits << 16u) | (bits >> 16u);\n        bits = ((bits & 0x55555555u) << 1u) | ((bits & 0xAAAAAAAAu) >> 1u);\n        bits = ((bits & 0x33333333u) << 2u) | ((bits & 0xCCCCCCCCu) >> 2u);\n        bits = ((bits & 0x0F0F0F0Fu) << 4u) | ((bits & 0xF0F0F0F0u) >> 4u);\n        bits = ((bits & 0x00FF00FFu) << 8u) | ((bits & 0xFF00FF00u) >> 8u);\n        return float(bits) * 2.3283064365386963e-10; // / 0x100000000\n    }\n\n    vec2 Hammersley(uint i, uint N) {\n        return vec2(float(i)/float(N), RadicalInverse_VdC(i));\n    }\n\n    vec3 ImportanceSampleGGX(vec2 Xi, vec3 N, float roughness) {\n        float a = roughness * roughness;\n\n        float phi = 2.0 * PI * Xi.x;\n        float cosTheta = sqrt((1.0 - Xi.y) / (1.0 + (a*a - 1.0) * Xi.y));\n        float sinTheta = sqrt(1.0 - cosTheta*cosTheta);\n\n        // from spherical coordinates to cartesian coordinates\n        vec3 H;\n        H.x = cos(phi) * sinTheta;\n        H.y = sin(phi) * sinTheta;\n        H.z = cosTheta;\n\n        // from tangent-space vector to world-space sample vector\n        vec3 up        = abs(N.z) < 0.999 ? vec3(0.0, 0.0, 1.0) : vec3(1.0, 0.0, 0.0);\n        vec3 tangent   = normalize(cross(up, N));\n        vec3 bitangent = cross(N, tangent);\n\n        vec3 sampleVec = tangent * H.x + bitangent * H.y + N * H.z;\n\n        return normalize(sampleVec);\n    }\n\n    void main() {\n        vec3 N = normalize(vLocalPos);\n        vec3 R = N;\n        vec3 V = R;\n\n        const uint SAMPLE_COUNT = 1024u;\n        float totalWeight = 0.0;\n        vec3 prefilteredColor = vec3(0.0);\n        for(uint i = 0u; i < SAMPLE_COUNT; ++i)\n        {\n            vec2 Xi = Hammersley(i, SAMPLE_COUNT);\n            vec3 H  = ImportanceSampleGGX(Xi, N, uRoughness);\n            vec3 L  = normalize(2.0 * dot(V, H) * H - V);\n\n            float NdotL = max(dot(N, L), 0.0);\n            if(NdotL > 0.0) {\n                prefilteredColor += pow(texture(uEnvironmentMap, L).rgb, vec3(gamma)) * NdotL;\n                totalWeight      += NdotL;\n            }\n        }\n        prefilteredColor = prefilteredColor / totalWeight;\n\n        FragColor = vec4(prefilteredColor, 1.0);\n    }\n";
var integrateBRDFVertexShader = "#version 300 es\n    in vec3 aPos;\n\n    out vec2 vLocalPos;\n\n    void main(void) {\n        vLocalPos = aPos.xy;\n        gl_Position = vec4(aPos, 1.0);\n    }\n";
var integrateBRDFFragmentShader = "#version 300 es\n    precision mediump float;\n\n    in vec2 vLocalPos;\n\n    out vec4 FragColor;\n\n    const float PI = 3.14159265359;\n\n    float RadicalInverse_VdC(uint bits) {\n        bits = (bits << 16u) | (bits >> 16u);\n        bits = ((bits & 0x55555555u) << 1u) | ((bits & 0xAAAAAAAAu) >> 1u);\n        bits = ((bits & 0x33333333u) << 2u) | ((bits & 0xCCCCCCCCu) >> 2u);\n        bits = ((bits & 0x0F0F0F0Fu) << 4u) | ((bits & 0xF0F0F0F0u) >> 4u);\n        bits = ((bits & 0x00FF00FFu) << 8u) | ((bits & 0xFF00FF00u) >> 8u);\n        return float(bits) * 2.3283064365386963e-10; // / 0x100000000\n    }\n\n    vec2 Hammersley(uint i, uint N) {\n        return vec2(float(i)/float(N), RadicalInverse_VdC(i));\n    }\n\n    vec3 ImportanceSampleGGX(vec2 Xi, vec3 N, float roughness) {\n        float a = roughness * roughness;\n\n        float phi = 2.0 * PI * Xi.x;\n        float cosTheta = sqrt((1.0 - Xi.y) / (1.0 + (a*a - 1.0) * Xi.y));\n        float sinTheta = sqrt(1.0 - cosTheta*cosTheta);\n\n        // from spherical coordinates to cartesian coordinates\n        vec3 H;\n        H.x = cos(phi) * sinTheta;\n        H.y = sin(phi) * sinTheta;\n        H.z = cosTheta;\n\n        // from tangent-space vector to world-space sample vector\n        vec3 up        = abs(N.z) < 0.999 ? vec3(0.0, 0.0, 1.0) : vec3(1.0, 0.0, 0.0);\n        vec3 tangent   = normalize(cross(up, N));\n        vec3 bitangent = cross(N, tangent);\n\n        vec3 sampleVec = tangent * H.x + bitangent * H.y + N * H.z;\n\n        return normalize(sampleVec);\n    }\n\n    float geometrySchlickGGX(float nDotV, float roughness) {\n        float r = roughness;\n        float k = r * r / 2.;\n\n        float num = nDotV;\n        float denom = nDotV * (1. - k) + k;\n\n        return num / denom;\n    }\n\n    float geometrySmith(vec3 normal, vec3 viewDir, vec3 lightDir, float roughness) {\n        float nDotV = max(dot(normal, viewDir), .0);\n        float nDotL = max(dot(normal, lightDir), .0);\n        float ggx2  = geometrySchlickGGX(nDotV, roughness);\n        float ggx1  = geometrySchlickGGX(nDotL, roughness);\n\n        return ggx1 * ggx2;\n    }\n\n    vec2 IntegrateBRDF(float NdotV, float roughness) {\n        vec3 V;\n        V.x = sqrt(1.0 - NdotV*NdotV);\n        V.y = 0.0;\n        V.z = NdotV;\n\n        float A = 0.0;\n        float B = 0.0;\n\n        vec3 N = vec3(0.0, 0.0, 1.0);\n\n        const uint SAMPLE_COUNT = 1024u;\n        for(uint i = 0u; i < SAMPLE_COUNT; ++i)\n        {\n            vec2 Xi = Hammersley(i, SAMPLE_COUNT);\n            vec3 H  = ImportanceSampleGGX(Xi, N, roughness);\n            vec3 L  = normalize(2.0 * dot(V, H) * H - V);\n\n            float NdotL = max(L.z, 0.0);\n            float NdotH = max(H.z, 0.0);\n            float VdotH = max(dot(V, H), 0.0);\n\n            if(NdotL > 0.0)\n            {\n                float G = geometrySmith(N, V, L, roughness);\n                float G_Vis = (G * VdotH) / (NdotH * NdotV);\n                float Fc = pow(1.0 - VdotH, 5.0);\n\n                A += (1.0 - Fc) * G_Vis;\n                B += Fc * G_Vis;\n            }\n        }\n        A /= float(SAMPLE_COUNT);\n        B /= float(SAMPLE_COUNT);\n        return vec2(A, B);\n    }\n\n    void main() {\n        FragColor = vec4(IntegrateBRDF((vLocalPos.x + 1.0) * .5, (vLocalPos.y + 1.0) * .5), 0., 1.);\n    }\n";
var translation = vec3.create();
var rotation = quat.create();
var scaling = vec3.create();
var defaultTranslation = vec3.fromValues(0, 0, 0);
var defaultRotation = quat.fromValues(0, 0, 0, 1);
var defaultScaling = vec3.fromValues(1, 1, 1);
var tempParentRotationQuat = quat.create();
var tempParentRotationMat = mat4.create();
var tempCameraMat = mat4.create();
var tempTransformedPivotPoint = vec3.create();
var tempAxis = vec3.create();
var tempLockQuat = quat.create();
var tempLockMat = mat4.create();
var tempXAxis = vec3.create();
var tempCameraVec = vec3.create();
var tempCross0 = vec3.create();
var tempCross1 = vec3.create();
var tempPos = vec3.create();
var tempSum = vec3.create();
var tempVec3 = vec3.create();
var identifyMat3 = mat3.create();
var texCoordMat4 = mat4.create();
var texCoordMat3 = mat3.create();
var ModelRenderer = /** @class */ (function () {
    function ModelRenderer(model) {
        var _a;
        this.vertexBuffer = [];
        this.normalBuffer = [];
        this.vertices = []; // Array per geoset for software skinning
        this.texCoordBuffer = [];
        this.indexBuffer = [];
        this.wireframeIndexBuffer = [];
        this.groupBuffer = [];
        this.skinWeightBuffer = [];
        this.tangentBuffer = [];
        this.isHD = (_a = model.Geosets) === null || _a === void 0 ? void 0 : _a.some(function (it) { var _a; return ((_a = it.SkinWeights) === null || _a === void 0 ? void 0 : _a.length) > 0; });
        this.shaderProgramLocations = {
            vertexPositionAttribute: null,
            normalsAttribute: null,
            textureCoordAttribute: null,
            groupAttribute: null,
            skinAttribute: null,
            weightAttribute: null,
            tangentAttribute: null,
            pMatrixUniform: null,
            mvMatrixUniform: null,
            samplerUniform: null,
            normalSamplerUniform: null,
            ormSamplerUniform: null,
            replaceableColorUniform: null,
            replaceableTypeUniform: null,
            discardAlphaLevelUniform: null,
            tVertexAnimUniform: null,
            nodesMatricesAttributes: null,
            lightPosUniform: null,
            lightColorUniform: null,
            cameraPosUniform: null,
            shadowParamsUniform: null,
            shadowMapSamplerUniform: null,
            shadowMapLightMatrixUniform: null,
            hasEnvUniform: null,
            irradianceMapUniform: null,
            prefilteredEnvUniform: null,
            brdfLUTUniform: null
        };
        this.skeletonShaderProgramLocations = {
            vertexPositionAttribute: null,
            colorAttribute: null,
            mvMatrixUniform: null,
            pMatrixUniform: null
        };
        this.model = model;
        this.rendererData = {
            model: model,
            frame: 0,
            animation: null,
            animationInfo: null,
            globalSequencesFrames: [],
            rootNode: null,
            nodes: [],
            geosetAnims: [],
            geosetAlpha: [],
            materialLayerTextureID: [],
            materialLayerNormalTextureID: [],
            materialLayerOrmTextureID: [],
            teamColor: null,
            cameraPos: null,
            cameraQuat: null,
            lightPos: null,
            lightColor: null,
            shadowBias: 0,
            shadowSmoothingStep: 0,
            textures: {},
            envTextures: {},
            requiredEnvMaps: {},
            irradianceMap: {},
            prefilteredEnvMap: {}
        };
        this.rendererData.teamColor = vec3.fromValues(1., 0., 0.);
        this.rendererData.cameraPos = vec3.create();
        this.rendererData.cameraQuat = quat.create();
        this.rendererData.lightPos = vec3.fromValues(1000, 1000, 1000);
        this.rendererData.lightColor = vec3.fromValues(1, 1, 1);
        this.setSequence(0);
        this.rendererData.rootNode = {
            // todo
            node: {},
            matrix: mat4.create(),
            childs: []
        };
        for (var _i = 0, _b = model.Nodes; _i < _b.length; _i++) {
            var node = _b[_i];
            if (node) {
                this.rendererData.nodes[node.ObjectId] = {
                    node: node,
                    matrix: mat4.create(),
                    childs: []
                };
            }
        }
        for (var _c = 0, _d = model.Nodes; _c < _d.length; _c++) {
            var node = _d[_c];
            if (node) {
                if (!node.Parent && node.Parent !== 0) {
                    this.rendererData.rootNode.childs.push(this.rendererData.nodes[node.ObjectId]);
                }
                else {
                    this.rendererData.nodes[node.Parent].childs.push(this.rendererData.nodes[node.ObjectId]);
                }
            }
        }
        if (model.GlobalSequences) {
            for (var i = 0; i < model.GlobalSequences.length; ++i) {
                this.rendererData.globalSequencesFrames[i] = 0;
            }
        }
        for (var i = 0; i < model.GeosetAnims.length; ++i) {
            this.rendererData.geosetAnims[model.GeosetAnims[i].GeosetId] = model.GeosetAnims[i];
        }
        for (var i = 0; i < model.Materials.length; ++i) {
            this.rendererData.materialLayerTextureID[i] = new Array(model.Materials[i].Layers.length);
            this.rendererData.materialLayerNormalTextureID[i] = new Array(model.Materials[i].Layers.length);
            this.rendererData.materialLayerOrmTextureID[i] = new Array(model.Materials[i].Layers.length);
        }
        this.interp = new ModelInterp(this.rendererData);
        this.particlesController = new ParticlesController(this.interp, this.rendererData);
        this.ribbonsController = new RibbonsController(this.interp, this.rendererData);
    }
    ModelRenderer.prototype.destroy = function () {
        if (this.particlesController) {
            this.particlesController.destroy();
            this.particlesController = null;
        }
        if (this.ribbonsController) {
            this.ribbonsController.destroy();
            this.ribbonsController = null;
        }
        if (this.skeletonShaderProgram) {
            if (this.skeletonVertexShader) {
                this.gl.detachShader(this.skeletonShaderProgram, this.skeletonVertexShader);
                this.gl.deleteShader(this.skeletonVertexShader);
                this.skeletonVertexShader = null;
            }
            if (this.skeletonFragmentShader) {
                this.gl.detachShader(this.skeletonShaderProgram, this.skeletonFragmentShader);
                this.gl.deleteShader(this.skeletonFragmentShader);
                this.skeletonFragmentShader = null;
            }
            this.gl.deleteProgram(this.skeletonShaderProgram);
            this.skeletonShaderProgram = null;
        }
        if (this.shaderProgram) {
            if (this.vertexShader) {
                this.gl.detachShader(this.shaderProgram, this.vertexShader);
                this.gl.deleteShader(this.vertexShader);
                this.vertexShader = null;
            }
            if (this.fragmentShader) {
                this.gl.detachShader(this.shaderProgram, this.fragmentShader);
                this.gl.deleteShader(this.fragmentShader);
                this.fragmentShader = null;
            }
            this.gl.deleteProgram(this.shaderProgram);
            this.shaderProgram = null;
        }
        this.destroyShaderProgramObject(this.envToCubemap);
        this.destroyShaderProgramObject(this.envSphere);
        this.destroyShaderProgramObject(this.convoluteDiffuseEnv);
        this.destroyShaderProgramObject(this.prefilterEnv);
        this.destroyShaderProgramObject(this.integrateBRDF);
        this.gl.deleteBuffer(this.cubeVertexBuffer);
        this.gl.deleteBuffer(this.squareVertexBuffer);
    };
    ModelRenderer.prototype.initGL = function (glContext) {
        var _this = this;
        this.gl = glContext;
        // Max bones + MV + P
        this.softwareSkinning = this.gl.getParameter(this.gl.MAX_VERTEX_UNIFORM_VECTORS) < 4 * (MAX_NODES + 2);
        this.anisotropicExt = (this.gl.getExtension('EXT_texture_filter_anisotropic') ||
            this.gl.getExtension('MOZ_EXT_texture_filter_anisotropic') ||
            this.gl.getExtension('WEBKIT_EXT_texture_filter_anisotropic'));
        this.colorBufferFloatExt = this.gl.getExtension('EXT_color_buffer_float');
        if (this.model.Version >= 1000 && isWebGL2(this.gl)) {
            this.model.Materials.forEach(function (material) {
                var layer;
                if (material.Shader === 'Shader_HD_DefaultUnit' && material.Layers.length === 6 && typeof material.Layers[5].TextureID === 'number' ||
                    _this.model.Version >= 1100 && (layer = material.Layers.find(function (it) { return it.ShaderTypeId === 1 && it.ReflectionsTextureID; })) && typeof layer.ReflectionsTextureID === 'number') {
                    var id = _this.model.Version >= 1100 && layer ? layer.ReflectionsTextureID : material.Layers[5].TextureID;
                    _this.rendererData.requiredEnvMaps[_this.model.Textures[id].Image] = true;
                }
            });
        }
        this.initShaders();
        this.initBuffers();
        this.initCube();
        this.initSquare();
        this.initBRDFLUT();
        this.particlesController.initGL(glContext);
        this.ribbonsController.initGL(glContext);
    };
    ModelRenderer.prototype.setTextureImage = function (path, img, flags) {
        this.rendererData.textures[path] = this.gl.createTexture();
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[path]);
        // this.gl.pixelStorei(this.gl.UNPACK_FLIP_Y_WEBGL, true);
        this.gl.texImage2D(this.gl.TEXTURE_2D, 0, this.gl.RGBA, this.gl.RGBA, this.gl.UNSIGNED_BYTE, img);
        this.setTextureParameters(flags, true);
        this.gl.generateMipmap(this.gl.TEXTURE_2D);
        this.processEnvMaps(path);
        this.gl.bindTexture(this.gl.TEXTURE_2D, null);
    };
    ModelRenderer.prototype.setTextureImageData = function (path, imageData, flags) {
        this.rendererData.textures[path] = this.gl.createTexture();
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[path]);
        // this.gl.pixelStorei(this.gl.UNPACK_FLIP_Y_WEBGL, true);
        for (var i = 0; i < imageData.length; ++i) {
            this.gl.texImage2D(this.gl.TEXTURE_2D, i, this.gl.RGBA, this.gl.RGBA, this.gl.UNSIGNED_BYTE, imageData[i]);
        }
        this.setTextureParameters(flags, false);
        this.processEnvMaps(path);
        this.gl.bindTexture(this.gl.TEXTURE_2D, null);
    };
    ModelRenderer.prototype.setTextureCompressedImage = function (path, format, imageData, ddsInfo, flags) {
        this.rendererData.textures[path] = this.gl.createTexture();
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[path]);
        var view = new Uint8Array(imageData);
        var count = 1;
        for (var i = 1; i < ddsInfo.images.length; ++i) {
            var image = ddsInfo.images[i];
            if (image.shape.width >= 2 && image.shape.height >= 2) {
                count = i + 1;
            }
        }
        if (isWebGL2(this.gl)) {
            this.gl.texStorage2D(this.gl.TEXTURE_2D, count, format, ddsInfo.images[0].shape.width, ddsInfo.images[0].shape.height);
            for (var i = 0; i < count; ++i) {
                var image = ddsInfo.images[i];
                this.gl.compressedTexSubImage2D(this.gl.TEXTURE_2D, i, 0, 0, image.shape.width, image.shape.height, format, view.subarray(image.offset, image.offset + image.length));
            }
        }
        else {
            for (var i = 0; i < count; ++i) {
                var image = ddsInfo.images[i];
                this.gl.compressedTexImage2D(this.gl.TEXTURE_2D, i, format, image.shape.width, image.shape.height, 0, view.subarray(image.offset, image.offset + image.length));
            }
        }
        this.setTextureParameters(flags, isWebGL2(this.gl));
        this.processEnvMaps(path);
        this.gl.bindTexture(this.gl.TEXTURE_2D, null);
    };
    ModelRenderer.prototype.setCamera = function (cameraPos, cameraQuat) {
        vec3.copy(this.rendererData.cameraPos, cameraPos);
        quat.copy(this.rendererData.cameraQuat, cameraQuat);
    };
    ModelRenderer.prototype.setLightPosition = function (lightPos) {
        vec3.copy(this.rendererData.lightPos, lightPos);
    };
    ModelRenderer.prototype.setLightColor = function (lightColor) {
        vec3.copy(this.rendererData.lightColor, lightColor);
    };
    ModelRenderer.prototype.setSequence = function (index) {
        this.rendererData.animation = index;
        this.rendererData.animationInfo = this.model.Sequences[this.rendererData.animation];
        this.rendererData.frame = this.rendererData.animationInfo.Interval[0];
    };
    ModelRenderer.prototype.getSequence = function () {
        return this.rendererData.animation;
    };
    ModelRenderer.prototype.setFrame = function (frame) {
        var index = this.model.Sequences.findIndex(function (it) { return it.Interval[0] <= frame && it.Interval[1] >= frame; });
        if (index < 0) {
            return;
        }
        this.rendererData.animation = index;
        this.rendererData.animationInfo = this.model.Sequences[this.rendererData.animation];
        this.rendererData.frame = frame;
    };
    ModelRenderer.prototype.getFrame = function () {
        return this.rendererData.frame;
    };
    ModelRenderer.prototype.setTeamColor = function (color) {
        vec3.copy(this.rendererData.teamColor, color);
    };
    ModelRenderer.prototype.update = function (delta) {
        this.rendererData.frame += delta;
        if (this.rendererData.frame > this.rendererData.animationInfo.Interval[1]) {
            this.rendererData.frame = this.rendererData.animationInfo.Interval[0];
        }
        this.updateGlobalSequences(delta);
        this.updateNode(this.rendererData.rootNode);
        this.particlesController.update(delta);
        this.ribbonsController.update(delta);
        for (var i = 0; i < this.model.Geosets.length; ++i) {
            this.rendererData.geosetAlpha[i] = this.findAlpha(i);
        }
        for (var materialId = 0; materialId < this.rendererData.materialLayerTextureID.length; ++materialId) {
            for (var layerId = 0; layerId < this.rendererData.materialLayerTextureID[materialId].length; ++layerId) {
                var layer = this.model.Materials[materialId].Layers[layerId];
                var TextureID = layer.TextureID;
                var NormalTextureID = layer.NormalTextureID;
                var ORMTextureID = layer.ORMTextureID;
                if (typeof TextureID === 'number') {
                    this.rendererData.materialLayerTextureID[materialId][layerId] = TextureID;
                }
                else {
                    this.rendererData.materialLayerTextureID[materialId][layerId] = this.interp.num(TextureID);
                }
                if (typeof NormalTextureID !== 'undefined') {
                    this.rendererData.materialLayerNormalTextureID[materialId][layerId] = typeof NormalTextureID === 'number' ? NormalTextureID : this.interp.num(NormalTextureID);
                }
                if (typeof ORMTextureID !== 'undefined') {
                    this.rendererData.materialLayerOrmTextureID[materialId][layerId] = typeof ORMTextureID === 'number' ? ORMTextureID : this.interp.num(ORMTextureID);
                }
            }
        }
    };
    ModelRenderer.prototype.render = function (mvMatrix, pMatrix, _a) {
        var _b, _c, _d;
        var wireframe = _a.wireframe, _e = _a.levelOfDetail, levelOfDetail = _e === void 0 ? 0 : _e, _f = _a.useEnvironmentMap, useEnvironmentMap = _f === void 0 ? false : _f, shadowMapTexture = _a.shadowMapTexture, shadowMapMatrix = _a.shadowMapMatrix, shadowBias = _a.shadowBias, shadowSmoothingStep = _a.shadowSmoothingStep;
        this.gl.useProgram(this.shaderProgram);
        this.gl.uniformMatrix4fv(this.shaderProgramLocations.pMatrixUniform, false, pMatrix);
        this.gl.uniformMatrix4fv(this.shaderProgramLocations.mvMatrixUniform, false, mvMatrix);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.vertexPositionAttribute);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.normalsAttribute);
        this.gl.enableVertexAttribArray(this.shaderProgramLocations.textureCoordAttribute);
        if (this.isHD) {
            this.gl.enableVertexAttribArray(this.shaderProgramLocations.skinAttribute);
            this.gl.enableVertexAttribArray(this.shaderProgramLocations.weightAttribute);
            this.gl.enableVertexAttribArray(this.shaderProgramLocations.tangentAttribute);
        }
        else {
            if (!this.softwareSkinning) {
                this.gl.enableVertexAttribArray(this.shaderProgramLocations.groupAttribute);
            }
        }
        if (!this.softwareSkinning) {
            for (var j = 0; j < MAX_NODES; ++j) {
                if (this.rendererData.nodes[j]) {
                    this.gl.uniformMatrix4fv(this.shaderProgramLocations.nodesMatricesAttributes[j], false, this.rendererData.nodes[j].matrix);
                }
            }
        }
        for (var i = 0; i < this.model.Geosets.length; ++i) {
            var geoset = this.model.Geosets[i];
            if (this.rendererData.geosetAlpha[i] < 1e-6) {
                continue;
            }
            if (geoset.LevelOfDetail !== undefined && geoset.LevelOfDetail !== levelOfDetail) {
                continue;
            }
            if (this.softwareSkinning) {
                this.generateGeosetVertices(i);
            }
            var materialID = geoset.MaterialID;
            var material = this.model.Materials[materialID];
            // Shader_HD_DefaultUnit
            if (this.isHD) {
                this.gl.uniform3fv(this.shaderProgramLocations.lightPosUniform, this.rendererData.lightPos);
                this.gl.uniform3fv(this.shaderProgramLocations.lightColorUniform, this.rendererData.lightColor);
                // this.gl.uniform3fv(this.shaderProgramLocations.lightPosUniform, this.rendererData.cameraPos);
                this.gl.uniform3fv(this.shaderProgramLocations.cameraPosUniform, this.rendererData.cameraPos);
                if (shadowMapTexture && shadowMapMatrix) {
                    this.gl.uniform3f(this.shaderProgramLocations.shadowParamsUniform, 1, shadowBias !== null && shadowBias !== void 0 ? shadowBias : 1e-6, shadowSmoothingStep !== null && shadowSmoothingStep !== void 0 ? shadowSmoothingStep : 1 / 1024);
                    this.gl.activeTexture(this.gl.TEXTURE3);
                    this.gl.bindTexture(this.gl.TEXTURE_2D, shadowMapTexture);
                    this.gl.uniform1i(this.shaderProgramLocations.shadowMapSamplerUniform, 3);
                    this.gl.uniformMatrix4fv(this.shaderProgramLocations.shadowMapLightMatrixUniform, false, shadowMapMatrix);
                }
                else {
                    this.gl.uniform3f(this.shaderProgramLocations.shadowParamsUniform, 0, 0, 0);
                }
                var envTextureId = this.model.Version >= 1100 && ((_b = material.Layers.find(function (it) { return it.ShaderTypeId === 1 && typeof it.ReflectionsTextureID === 'number'; })) === null || _b === void 0 ? void 0 : _b.ReflectionsTextureID) || ((_c = material.Layers[5]) === null || _c === void 0 ? void 0 : _c.TextureID);
                var envTexture = (_d = this.model.Textures[envTextureId]) === null || _d === void 0 ? void 0 : _d.Image;
                var irradianceMap = this.rendererData.irradianceMap[envTexture];
                var prefilteredEnv = this.rendererData.prefilteredEnvMap[envTexture];
                if (useEnvironmentMap && irradianceMap) {
                    this.gl.uniform1i(this.shaderProgramLocations.hasEnvUniform, 1);
                    this.gl.activeTexture(this.gl.TEXTURE4);
                    this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, irradianceMap);
                    this.gl.uniform1i(this.shaderProgramLocations.irradianceMapUniform, 4);
                    this.gl.activeTexture(this.gl.TEXTURE5);
                    this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, prefilteredEnv);
                    this.gl.uniform1i(this.shaderProgramLocations.prefilteredEnvUniform, 5);
                    this.gl.activeTexture(this.gl.TEXTURE6);
                    this.gl.bindTexture(this.gl.TEXTURE_2D, this.brdfLUT);
                    this.gl.uniform1i(this.shaderProgramLocations.brdfLUTUniform, 6);
                }
                else {
                    this.gl.uniform1i(this.shaderProgramLocations.hasEnvUniform, 0);
                    this.gl.uniform1i(this.shaderProgramLocations.irradianceMapUniform, 4);
                    this.gl.uniform1i(this.shaderProgramLocations.prefilteredEnvUniform, 5);
                    this.gl.uniform1i(this.shaderProgramLocations.brdfLUTUniform, 6);
                }
                this.setLayerPropsHD(materialID, material.Layers);
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.vertexBuffer[i]);
                this.gl.vertexAttribPointer(this.shaderProgramLocations.vertexPositionAttribute, 3, this.gl.FLOAT, false, 0, 0);
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.normalBuffer[i]);
                this.gl.vertexAttribPointer(this.shaderProgramLocations.normalsAttribute, 3, this.gl.FLOAT, false, 0, 0);
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.texCoordBuffer[i]);
                this.gl.vertexAttribPointer(this.shaderProgramLocations.textureCoordAttribute, 2, this.gl.FLOAT, false, 0, 0);
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.skinWeightBuffer[i]);
                this.gl.vertexAttribPointer(this.shaderProgramLocations.skinAttribute, 4, this.gl.UNSIGNED_BYTE, false, 8, 0);
                this.gl.vertexAttribPointer(this.shaderProgramLocations.weightAttribute, 4, this.gl.UNSIGNED_BYTE, true, 8, 4);
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.tangentBuffer[i]);
                this.gl.vertexAttribPointer(this.shaderProgramLocations.tangentAttribute, 4, this.gl.FLOAT, false, 0, 0);
                if (wireframe && !this.wireframeIndexBuffer[i]) {
                    this.createWireframeBuffer(i);
                }
                this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER, wireframe ? this.wireframeIndexBuffer[i] : this.indexBuffer[i]);
                this.gl.drawElements(wireframe ? this.gl.LINES : this.gl.TRIANGLES, wireframe ? geoset.Faces.length * 2 : geoset.Faces.length, this.gl.UNSIGNED_SHORT, 0);
                if (shadowMapTexture && shadowMapMatrix) {
                    this.gl.activeTexture(this.gl.TEXTURE3);
                    this.gl.bindTexture(this.gl.TEXTURE_2D, null);
                }
            }
            else {
                for (var j = 0; j < material.Layers.length; ++j) {
                    this.setLayerProps(material.Layers[j], this.rendererData.materialLayerTextureID[materialID][j]);
                    this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.vertexBuffer[i]);
                    this.gl.vertexAttribPointer(this.shaderProgramLocations.vertexPositionAttribute, 3, this.gl.FLOAT, false, 0, 0);
                    this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.normalBuffer[i]);
                    this.gl.vertexAttribPointer(this.shaderProgramLocations.normalsAttribute, 3, this.gl.FLOAT, false, 0, 0);
                    this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.texCoordBuffer[i]);
                    this.gl.vertexAttribPointer(this.shaderProgramLocations.textureCoordAttribute, 2, this.gl.FLOAT, false, 0, 0);
                    if (!this.softwareSkinning) {
                        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.groupBuffer[i]);
                        this.gl.vertexAttribPointer(this.shaderProgramLocations.groupAttribute, 4, this.gl.UNSIGNED_SHORT, false, 0, 0);
                    }
                    if (wireframe && !this.wireframeIndexBuffer[i]) {
                        this.createWireframeBuffer(i);
                    }
                    this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER, wireframe ? this.wireframeIndexBuffer[i] : this.indexBuffer[i]);
                    this.gl.drawElements(wireframe ? this.gl.LINES : this.gl.TRIANGLES, wireframe ? geoset.Faces.length * 2 : geoset.Faces.length, this.gl.UNSIGNED_SHORT, 0);
                }
            }
        }
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.vertexPositionAttribute);
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.normalsAttribute);
        this.gl.disableVertexAttribArray(this.shaderProgramLocations.textureCoordAttribute);
        if (this.isHD) {
            this.gl.disableVertexAttribArray(this.shaderProgramLocations.skinAttribute);
            this.gl.disableVertexAttribArray(this.shaderProgramLocations.weightAttribute);
            this.gl.disableVertexAttribArray(this.shaderProgramLocations.tangentAttribute);
        }
        else {
            if (!this.softwareSkinning) {
                this.gl.disableVertexAttribArray(this.shaderProgramLocations.groupAttribute);
            }
        }
        this.particlesController.render(mvMatrix, pMatrix);
        this.ribbonsController.render(mvMatrix, pMatrix);
    };
    ModelRenderer.prototype.renderEnvironment = function (mvMatrix, pMatrix) {
        if (!isWebGL2(this.gl)) {
            return;
        }
        this.gl.disable(this.gl.BLEND);
        this.gl.disable(this.gl.DEPTH_TEST);
        this.gl.disable(this.gl.CULL_FACE);
        for (var path in this.rendererData.envTextures) {
            this.gl.useProgram(this.envSphere.program);
            this.gl.uniformMatrix4fv(this.envSphere.uniforms.uPMatrix, false, pMatrix);
            this.gl.uniformMatrix4fv(this.envSphere.uniforms.uMVMatrix, false, mvMatrix);
            this.gl.activeTexture(this.gl.TEXTURE0);
            this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, this.rendererData.envTextures[path]);
            this.gl.uniform1i(this.envSphere.uniforms.uEnvironmentMap, 0);
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.cubeVertexBuffer);
            this.gl.enableVertexAttribArray(this.envSphere.attributes.aPos);
            this.gl.vertexAttribPointer(this.envSphere.attributes.aPos, 3, this.gl.FLOAT, false, 0, 0);
            this.gl.drawArrays(this.gl.TRIANGLES, 0, 6 * 6);
            this.gl.disableVertexAttribArray(this.envSphere.attributes.aPos);
            this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, null);
        }
    };
    /**
     * @param mvMatrix
     * @param pMatrix
     * @param nodes Nodes to highlight. null means draw all
     */
    ModelRenderer.prototype.renderSkeleton = function (mvMatrix, pMatrix, nodes) {
        var _this = this;
        if (!this.skeletonShaderProgram) {
            this.skeletonShaderProgram = this.initSkeletonShaderProgram();
        }
        this.gl.disable(this.gl.BLEND);
        this.gl.disable(this.gl.DEPTH_TEST);
        this.gl.useProgram(this.skeletonShaderProgram);
        this.gl.uniformMatrix4fv(this.skeletonShaderProgramLocations.pMatrixUniform, false, pMatrix);
        this.gl.uniformMatrix4fv(this.skeletonShaderProgramLocations.mvMatrixUniform, false, mvMatrix);
        this.gl.enableVertexAttribArray(this.skeletonShaderProgramLocations.vertexPositionAttribute);
        this.gl.enableVertexAttribArray(this.skeletonShaderProgramLocations.colorAttribute);
        if (!this.skeletonVertexBuffer) {
            this.skeletonVertexBuffer = this.gl.createBuffer();
        }
        if (!this.skeletonColorBuffer) {
            this.skeletonColorBuffer = this.gl.createBuffer();
        }
        var coords = [];
        var colors = [];
        var line = function (node0, node1) {
            vec3.transformMat4(tempPos, node0.node.PivotPoint, node0.matrix);
            coords.push(tempPos[0], tempPos[1], tempPos[2]);
            vec3.transformMat4(tempPos, node1.node.PivotPoint, node1.matrix);
            coords.push(tempPos[0], tempPos[1], tempPos[2]);
            colors.push(0, 1, 0, 0, 0, 1);
        };
        var updateNode = function (node) {
            if ((node.node.Parent || node.node.Parent === 0) && (!nodes || nodes.includes(node.node.Name))) {
                line(node, _this.rendererData.nodes[node.node.Parent]);
            }
            for (var _i = 0, _a = node.childs; _i < _a.length; _i++) {
                var child = _a[_i];
                updateNode(child);
            }
        };
        updateNode(this.rendererData.rootNode);
        var vertexBuffer = new Float32Array(coords);
        var colorBuffer = new Float32Array(colors);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.skeletonVertexBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, vertexBuffer, this.gl.DYNAMIC_DRAW);
        this.gl.vertexAttribPointer(this.skeletonShaderProgramLocations.vertexPositionAttribute, 3, this.gl.FLOAT, false, 0, 0);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.skeletonColorBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, colorBuffer, this.gl.DYNAMIC_DRAW);
        this.gl.vertexAttribPointer(this.skeletonShaderProgramLocations.colorAttribute, 3, this.gl.FLOAT, false, 0, 0);
        this.gl.drawArrays(this.gl.LINES, 0, vertexBuffer.length / 3);
        this.gl.disableVertexAttribArray(this.skeletonShaderProgramLocations.vertexPositionAttribute);
        this.gl.disableVertexAttribArray(this.skeletonShaderProgramLocations.colorAttribute);
    };
    ModelRenderer.prototype.initSkeletonShaderProgram = function () {
        var vertex = this.skeletonVertexShader = getShader(this.gl, skeletonVertexShader, this.gl.VERTEX_SHADER);
        var fragment = this.skeletonFragmentShader = getShader(this.gl, skeletonFragmentShader, this.gl.FRAGMENT_SHADER);
        var shaderProgram = this.gl.createProgram();
        this.gl.attachShader(shaderProgram, vertex);
        this.gl.attachShader(shaderProgram, fragment);
        this.gl.linkProgram(shaderProgram);
        if (!this.gl.getProgramParameter(shaderProgram, this.gl.LINK_STATUS)) {
            alert('Could not initialise shaders');
        }
        this.gl.useProgram(shaderProgram);
        this.skeletonShaderProgramLocations.vertexPositionAttribute = this.gl.getAttribLocation(shaderProgram, 'aVertexPosition');
        this.skeletonShaderProgramLocations.colorAttribute = this.gl.getAttribLocation(shaderProgram, 'aColor');
        this.skeletonShaderProgramLocations.pMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uPMatrix');
        this.skeletonShaderProgramLocations.mvMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uMVMatrix');
        return shaderProgram;
    };
    ModelRenderer.prototype.generateGeosetVertices = function (geosetIndex) {
        var geoset = this.model.Geosets[geosetIndex];
        var buffer = this.vertices[geosetIndex];
        for (var i = 0; i < buffer.length; i += 3) {
            var index = i / 3;
            var group = geoset.Groups[geoset.VertexGroup[index]];
            vec3.set(tempPos, geoset.Vertices[i], geoset.Vertices[i + 1], geoset.Vertices[i + 2]);
            vec3.set(tempSum, 0, 0, 0);
            for (var j = 0; j < group.length; ++j) {
                vec3.add(tempSum, tempSum, vec3.transformMat4(tempVec3, tempPos, this.rendererData.nodes[group[j]].matrix));
            }
            vec3.scale(tempPos, tempSum, 1 / group.length);
            buffer[i] = tempPos[0];
            buffer[i + 1] = tempPos[1];
            buffer[i + 2] = tempPos[2];
        }
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.vertexBuffer[geosetIndex]);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, buffer, this.gl.DYNAMIC_DRAW);
    };
    ModelRenderer.prototype.setTextureParameters = function (flags, hasMipmaps) {
        if (flags & TextureFlags.WrapWidth) {
            this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_S, this.gl.REPEAT);
        }
        else {
            this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_S, this.gl.CLAMP_TO_EDGE);
        }
        if (flags & TextureFlags.WrapHeight) {
            this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_T, this.gl.REPEAT);
        }
        else {
            this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_T, this.gl.CLAMP_TO_EDGE);
        }
        this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_MAG_FILTER, this.gl.LINEAR);
        this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_MIN_FILTER, hasMipmaps ? this.gl.LINEAR_MIPMAP_NEAREST : this.gl.LINEAR);
        if (this.anisotropicExt) {
            var max = this.gl.getParameter(this.anisotropicExt.MAX_TEXTURE_MAX_ANISOTROPY_EXT);
            this.gl.texParameterf(this.gl.TEXTURE_2D, this.anisotropicExt.TEXTURE_MAX_ANISOTROPY_EXT, max);
        }
    };
    ModelRenderer.prototype.processEnvMaps = function (path) {
        if (!this.rendererData.requiredEnvMaps[path] || !this.rendererData.textures[path] || !isWebGL2(this.gl) || !this.colorBufferFloatExt) {
            return;
        }
        this.gl.disable(this.gl.BLEND);
        this.gl.disable(this.gl.DEPTH_TEST);
        this.gl.disable(this.gl.CULL_FACE);
        var pMatrix = mat4.create();
        var mvMatrix = mat4.create();
        var eye = vec3.fromValues(0, 0, 0);
        var center = [
            vec3.fromValues(1, 0, 0),
            vec3.fromValues(-1, 0, 0),
            vec3.fromValues(0, 1, 0),
            vec3.fromValues(0, -1, 0),
            vec3.fromValues(0, 0, 1),
            vec3.fromValues(0, 0, -1)
        ];
        var up = [
            vec3.fromValues(0, -1, 0),
            vec3.fromValues(0, -1, 0),
            vec3.fromValues(0, 0, 1),
            vec3.fromValues(0, 0, -1),
            vec3.fromValues(0, -1, 0),
            vec3.fromValues(0, -1, 0)
        ];
        var framebuffer = this.gl.createFramebuffer();
        this.gl.useProgram(this.envToCubemap.program);
        var cubemap = this.rendererData.envTextures[path] = this.gl.createTexture();
        this.gl.activeTexture(this.gl.TEXTURE1);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, cubemap);
        for (var i = 0; i < 6; ++i) {
            this.gl.texImage2D(this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, 0, this.gl.RGBA16F, ENV_MAP_SIZE, ENV_MAP_SIZE, 0, this.gl.RGBA, this.gl.FLOAT, null);
        }
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_S, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_T, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_R, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_MIN_FILTER, this.gl.LINEAR);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_MAG_FILTER, this.gl.LINEAR);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.cubeVertexBuffer);
        this.gl.enableVertexAttribArray(this.envToCubemap.attributes.aPos);
        this.gl.vertexAttribPointer(this.envToCubemap.attributes.aPos, 3, this.gl.FLOAT, false, 0, 0);
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, framebuffer);
        mat4.perspective(pMatrix, Math.PI / 2, 1, .1, 10);
        this.gl.uniformMatrix4fv(this.envToCubemap.uniforms.uPMatrix, false, pMatrix);
        this.gl.activeTexture(this.gl.TEXTURE0);
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[path]);
        this.gl.uniform1i(this.envToCubemap.uniforms.uEquirectangularMap, 0);
        this.gl.viewport(0, 0, ENV_MAP_SIZE, ENV_MAP_SIZE);
        for (var i = 0; i < 6; ++i) {
            this.gl.framebufferTexture2D(this.gl.FRAMEBUFFER, this.gl.COLOR_ATTACHMENT0, this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, cubemap, 0);
            this.gl.clear(this.gl.COLOR_BUFFER_BIT | this.gl.DEPTH_BUFFER_BIT);
            mat4.lookAt(mvMatrix, eye, center[i], up[i]);
            this.gl.uniformMatrix4fv(this.envToCubemap.uniforms.uMVMatrix, false, mvMatrix);
            this.gl.drawArrays(this.gl.TRIANGLES, 0, 6 * 6);
        }
        this.gl.disableVertexAttribArray(this.envToCubemap.attributes.aPos);
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, null);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, cubemap);
        this.gl.generateMipmap(this.gl.TEXTURE_CUBE_MAP);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, null);
        // Diffuse env convolution
        this.gl.useProgram(this.convoluteDiffuseEnv.program);
        var diffuseCubemap = this.rendererData.irradianceMap[path] = this.gl.createTexture();
        this.gl.activeTexture(this.gl.TEXTURE1);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, diffuseCubemap);
        for (var i = 0; i < 6; ++i) {
            this.gl.texImage2D(this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, 0, this.gl.RGBA16F, ENV_CONVOLUTE_DIFFUSE_SIZE, ENV_CONVOLUTE_DIFFUSE_SIZE, 0, this.gl.RGBA, this.gl.FLOAT, null);
        }
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_S, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_T, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_R, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_MIN_FILTER, this.gl.LINEAR);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_MAG_FILTER, this.gl.LINEAR);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.cubeVertexBuffer);
        this.gl.enableVertexAttribArray(this.convoluteDiffuseEnv.attributes.aPos);
        this.gl.vertexAttribPointer(this.convoluteDiffuseEnv.attributes.aPos, 3, this.gl.FLOAT, false, 0, 0);
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, framebuffer);
        mat4.perspective(pMatrix, Math.PI / 2, 1, .1, 10);
        this.gl.uniformMatrix4fv(this.convoluteDiffuseEnv.uniforms.uPMatrix, false, pMatrix);
        this.gl.activeTexture(this.gl.TEXTURE0);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, this.rendererData.envTextures[path]);
        this.gl.uniform1i(this.convoluteDiffuseEnv.uniforms.uEnvironmentMap, 0);
        this.gl.viewport(0, 0, ENV_CONVOLUTE_DIFFUSE_SIZE, ENV_CONVOLUTE_DIFFUSE_SIZE);
        for (var i = 0; i < 6; ++i) {
            this.gl.framebufferTexture2D(this.gl.FRAMEBUFFER, this.gl.COLOR_ATTACHMENT0, this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, diffuseCubemap, 0);
            this.gl.clear(this.gl.COLOR_BUFFER_BIT | this.gl.DEPTH_BUFFER_BIT);
            mat4.lookAt(mvMatrix, eye, center[i], up[i]);
            this.gl.uniformMatrix4fv(this.convoluteDiffuseEnv.uniforms.uMVMatrix, false, mvMatrix);
            this.gl.drawArrays(this.gl.TRIANGLES, 0, 6 * 6);
        }
        this.gl.disableVertexAttribArray(this.convoluteDiffuseEnv.attributes.aPos);
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, null);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, diffuseCubemap);
        this.gl.generateMipmap(this.gl.TEXTURE_CUBE_MAP);
        // Prefilter env map with different roughness
        this.gl.useProgram(this.prefilterEnv.program);
        var prefilterCubemap = this.rendererData.prefilteredEnvMap[path] = this.gl.createTexture();
        this.gl.activeTexture(this.gl.TEXTURE1);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, prefilterCubemap);
        this.gl.texStorage2D(this.gl.TEXTURE_CUBE_MAP, MAX_ENV_MIP_LEVELS, this.gl.RGBA16F, ENV_PREFILTER_SIZE, ENV_PREFILTER_SIZE);
        // for (let i = 0; i < 6; ++i) {
        // this.gl.texImage2D(this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, 0, this.gl.RGB, ENV_PREFILTER_SIZE, ENV_PREFILTER_SIZE, 0, this.gl.RGB, this.gl.UNSIGNED_BYTE, null);
        // }
        for (var mip = 0; mip < MAX_ENV_MIP_LEVELS; ++mip) {
            for (var i = 0; i < 6; ++i) {
                var size = ENV_PREFILTER_SIZE * Math.pow(.5, mip);
                var data = new Float32Array(size * size * 4);
                this.gl.texSubImage2D(this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, mip, 0, 0, size, size, this.gl.RGBA, this.gl.FLOAT, data);
            }
        }
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_S, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_T, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_WRAP_R, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_MIN_FILTER, this.gl.LINEAR_MIPMAP_LINEAR);
        this.gl.texParameteri(this.gl.TEXTURE_CUBE_MAP, this.gl.TEXTURE_MAG_FILTER, this.gl.LINEAR);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.cubeVertexBuffer);
        this.gl.enableVertexAttribArray(this.prefilterEnv.attributes.aPos);
        this.gl.vertexAttribPointer(this.prefilterEnv.attributes.aPos, 3, this.gl.FLOAT, false, 0, 0);
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, framebuffer);
        mat4.perspective(pMatrix, Math.PI / 2, 1, .1, 10);
        this.gl.uniformMatrix4fv(this.prefilterEnv.uniforms.uPMatrix, false, pMatrix);
        this.gl.activeTexture(this.gl.TEXTURE0);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, this.rendererData.envTextures[path]);
        this.gl.uniform1i(this.prefilterEnv.uniforms.uEnvironmentMap, 0);
        for (var mip = 0; mip < MAX_ENV_MIP_LEVELS; ++mip) {
            var mipWidth = ENV_PREFILTER_SIZE * Math.pow(.5, mip);
            var mipHeight = ENV_PREFILTER_SIZE * Math.pow(.5, mip);
            this.gl.viewport(0, 0, mipWidth, mipHeight);
            var roughness = mip / (MAX_ENV_MIP_LEVELS - 1);
            this.gl.uniform1f(this.prefilterEnv.uniforms.uRoughness, roughness);
            for (var i = 0; i < 6; ++i) {
                this.gl.framebufferTexture2D(this.gl.FRAMEBUFFER, this.gl.COLOR_ATTACHMENT0, this.gl.TEXTURE_CUBE_MAP_POSITIVE_X + i, prefilterCubemap, mip);
                this.gl.clear(this.gl.COLOR_BUFFER_BIT | this.gl.DEPTH_BUFFER_BIT);
                mat4.lookAt(mvMatrix, eye, center[i], up[i]);
                this.gl.uniformMatrix4fv(this.prefilterEnv.uniforms.uMVMatrix, false, mvMatrix);
                this.gl.drawArrays(this.gl.TRIANGLES, 0, 6 * 6);
            }
        }
        // cleanup
        this.gl.activeTexture(this.gl.TEXTURE1);
        this.gl.bindTexture(this.gl.TEXTURE_CUBE_MAP, null);
        this.gl.deleteFramebuffer(framebuffer);
    };
    ModelRenderer.prototype.initShaderProgram = function (vertex, fragment, attributesDesc, uniformsDesc) {
        var vertexShader = getShader(this.gl, vertex, this.gl.VERTEX_SHADER);
        var fragmentShader = getShader(this.gl, fragment, this.gl.FRAGMENT_SHADER);
        var program = this.gl.createProgram();
        this.gl.attachShader(program, vertexShader);
        this.gl.attachShader(program, fragmentShader);
        this.gl.linkProgram(program);
        if (!this.gl.getProgramParameter(program, this.gl.LINK_STATUS)) {
            throw new Error('Could not initialise shaders');
        }
        var attributes = {};
        for (var name_1 in attributesDesc) {
            attributes[name_1] = this.gl.getAttribLocation(program, name_1);
            if (attributes[name_1] < 0) {
                throw new Error('Missing shader attribute location: ' + name_1);
            }
        }
        var uniforms = {};
        for (var name_2 in uniformsDesc) {
            uniforms[name_2] = this.gl.getUniformLocation(program, name_2);
            if (!uniforms[name_2]) {
                throw new Error('Missing shader uniform location: ' + name_2);
            }
        }
        return {
            program: program,
            vertexShader: vertexShader,
            fragmentShader: fragmentShader,
            attributes: attributes,
            uniforms: uniforms
        };
    };
    ModelRenderer.prototype.destroyShaderProgramObject = function (object) {
        if (object.program) {
            if (object.vertexShader) {
                this.gl.detachShader(object.program, object.vertexShader);
                this.gl.deleteShader(object.vertexShader);
                object.vertexShader = null;
            }
            if (object.fragmentShader) {
                this.gl.detachShader(object.program, object.fragmentShader);
                this.gl.deleteShader(object.fragmentShader);
                object.fragmentShader = null;
            }
            this.gl.deleteProgram(object.program);
            object.program = null;
        }
    };
    ModelRenderer.prototype.initShaders = function () {
        if (this.shaderProgram) {
            return;
        }
        var vertexShaderSource;
        if (this.isHD) {
            vertexShaderSource = isWebGL2(this.gl) ? vertexShaderHDHardwareSkinningNew : vertexShaderHDHardwareSkinningOld;
        }
        else if (this.softwareSkinning) {
            vertexShaderSource = vertexShaderSoftwareSkinning;
        }
        else {
            vertexShaderSource = vertexShaderHardwareSkinning;
        }
        var fragmentShaderSource;
        if (this.isHD) {
            fragmentShaderSource = isWebGL2(this.gl) ? fragmentShaderHDNew : fragmentShaderHDOld;
        }
        else {
            fragmentShaderSource = fragmentShader;
        }
        var vertex = this.vertexShader = getShader(this.gl, vertexShaderSource, this.gl.VERTEX_SHADER);
        var fragment = this.fragmentShader = getShader(this.gl, fragmentShaderSource, this.gl.FRAGMENT_SHADER);
        var shaderProgram = this.shaderProgram = this.gl.createProgram();
        this.gl.attachShader(shaderProgram, vertex);
        this.gl.attachShader(shaderProgram, fragment);
        this.gl.linkProgram(shaderProgram);
        if (!this.gl.getProgramParameter(shaderProgram, this.gl.LINK_STATUS)) {
            alert('Could not initialise shaders');
        }
        this.gl.useProgram(shaderProgram);
        this.shaderProgramLocations.vertexPositionAttribute = this.gl.getAttribLocation(shaderProgram, 'aVertexPosition');
        this.shaderProgramLocations.normalsAttribute = this.gl.getAttribLocation(shaderProgram, 'aNormal');
        this.shaderProgramLocations.textureCoordAttribute = this.gl.getAttribLocation(shaderProgram, 'aTextureCoord');
        if (this.isHD) {
            this.shaderProgramLocations.skinAttribute = this.gl.getAttribLocation(shaderProgram, 'aSkin');
            this.shaderProgramLocations.weightAttribute = this.gl.getAttribLocation(shaderProgram, 'aBoneWeight');
            this.shaderProgramLocations.tangentAttribute = this.gl.getAttribLocation(shaderProgram, 'aTangent');
        }
        else {
            if (!this.softwareSkinning) {
                this.shaderProgramLocations.groupAttribute = this.gl.getAttribLocation(shaderProgram, 'aGroup');
            }
        }
        this.shaderProgramLocations.pMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uPMatrix');
        this.shaderProgramLocations.mvMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uMVMatrix');
        this.shaderProgramLocations.samplerUniform = this.gl.getUniformLocation(shaderProgram, 'uSampler');
        this.shaderProgramLocations.replaceableColorUniform = this.gl.getUniformLocation(shaderProgram, 'uReplaceableColor');
        if (this.isHD) {
            this.shaderProgramLocations.normalSamplerUniform = this.gl.getUniformLocation(shaderProgram, 'uNormalSampler');
            this.shaderProgramLocations.ormSamplerUniform = this.gl.getUniformLocation(shaderProgram, 'uOrmSampler');
            this.shaderProgramLocations.lightPosUniform = this.gl.getUniformLocation(shaderProgram, 'uLightPos');
            this.shaderProgramLocations.lightColorUniform = this.gl.getUniformLocation(shaderProgram, 'uLightColor');
            this.shaderProgramLocations.cameraPosUniform = this.gl.getUniformLocation(shaderProgram, 'uCameraPos');
            this.shaderProgramLocations.shadowParamsUniform = this.gl.getUniformLocation(shaderProgram, 'uShadowParams');
            this.shaderProgramLocations.shadowMapSamplerUniform = this.gl.getUniformLocation(shaderProgram, 'uShadowMapSampler');
            this.shaderProgramLocations.shadowMapLightMatrixUniform = this.gl.getUniformLocation(shaderProgram, 'uShadowMapLightMatrix');
            this.shaderProgramLocations.hasEnvUniform = this.gl.getUniformLocation(shaderProgram, 'uHasEnv');
            this.shaderProgramLocations.irradianceMapUniform = this.gl.getUniformLocation(shaderProgram, 'uIrradianceMap');
            this.shaderProgramLocations.prefilteredEnvUniform = this.gl.getUniformLocation(shaderProgram, 'uPrefilteredEnv');
            this.shaderProgramLocations.brdfLUTUniform = this.gl.getUniformLocation(shaderProgram, 'uBRDFLUT');
        }
        else {
            this.shaderProgramLocations.replaceableTypeUniform = this.gl.getUniformLocation(shaderProgram, 'uReplaceableType');
        }
        this.shaderProgramLocations.discardAlphaLevelUniform = this.gl.getUniformLocation(shaderProgram, 'uDiscardAlphaLevel');
        this.shaderProgramLocations.tVertexAnimUniform = this.gl.getUniformLocation(shaderProgram, 'uTVextexAnim');
        if (!this.softwareSkinning) {
            this.shaderProgramLocations.nodesMatricesAttributes = [];
            for (var i = 0; i < MAX_NODES; ++i) {
                this.shaderProgramLocations.nodesMatricesAttributes[i] =
                    this.gl.getUniformLocation(shaderProgram, "uNodesMatrices[".concat(i, "]"));
            }
        }
        if (this.isHD && isWebGL2(this.gl)) {
            this.envToCubemap = this.initShaderProgram(envToCubemapVertexShader, envToCubemapFragmentShader, {
                aPos: 'aPos'
            }, {
                uPMatrix: 'uPMatrix',
                uMVMatrix: 'uMVMatrix',
                uEquirectangularMap: 'uEquirectangularMap'
            });
            this.envSphere = this.initShaderProgram(envVertexShader, envFragmentShader, {
                aPos: 'aPos'
            }, {
                uPMatrix: 'uPMatrix',
                uMVMatrix: 'uMVMatrix',
                uEnvironmentMap: 'uEnvironmentMap'
            });
            this.convoluteDiffuseEnv = this.initShaderProgram(convoluteEnvDiffuseVertexShader, convoluteEnvDiffuseFragmentShader, {
                aPos: 'aPos'
            }, {
                uPMatrix: 'uPMatrix',
                uMVMatrix: 'uMVMatrix',
                uEnvironmentMap: 'uEnvironmentMap'
            });
            this.prefilterEnv = this.initShaderProgram(prefilterEnvVertexShader, prefilterEnvFragmentShader, {
                aPos: 'aPos'
            }, {
                uPMatrix: 'uPMatrix',
                uMVMatrix: 'uMVMatrix',
                uEnvironmentMap: 'uEnvironmentMap',
                uRoughness: 'uRoughness'
            });
            this.integrateBRDF = this.initShaderProgram(integrateBRDFVertexShader, integrateBRDFFragmentShader, {
                aPos: 'aPos'
            }, {});
        }
    };
    ModelRenderer.prototype.createWireframeBuffer = function (index) {
        var faces = this.model.Geosets[index].Faces;
        var lines = new Uint16Array(faces.length * 2);
        for (var i = 0; i < faces.length; i += 3) {
            lines[i * 2] = faces[i];
            lines[i * 2 + 1] = faces[i + 1];
            lines[i * 2 + 2] = faces[i + 1];
            lines[i * 2 + 3] = faces[i + 2];
            lines[i * 2 + 4] = faces[i + 2];
            lines[i * 2 + 5] = faces[i];
        }
        this.wireframeIndexBuffer[index] = this.gl.createBuffer();
        this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER, this.wireframeIndexBuffer[index]);
        this.gl.bufferData(this.gl.ELEMENT_ARRAY_BUFFER, lines, this.gl.STATIC_DRAW);
    };
    ModelRenderer.prototype.initBuffers = function () {
        for (var i = 0; i < this.model.Geosets.length; ++i) {
            var geoset = this.model.Geosets[i];
            this.vertexBuffer[i] = this.gl.createBuffer();
            if (this.softwareSkinning) {
                this.vertices[i] = new Float32Array(geoset.Vertices.length);
            }
            else {
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.vertexBuffer[i]);
                this.gl.bufferData(this.gl.ARRAY_BUFFER, geoset.Vertices, this.gl.STATIC_DRAW);
            }
            this.normalBuffer[i] = this.gl.createBuffer();
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.normalBuffer[i]);
            this.gl.bufferData(this.gl.ARRAY_BUFFER, geoset.Normals, this.gl.STATIC_DRAW);
            this.texCoordBuffer[i] = this.gl.createBuffer();
            this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.texCoordBuffer[i]);
            this.gl.bufferData(this.gl.ARRAY_BUFFER, geoset.TVertices[0], this.gl.STATIC_DRAW);
            if (this.isHD) {
                this.skinWeightBuffer[i] = this.gl.createBuffer();
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.skinWeightBuffer[i]);
                this.gl.bufferData(this.gl.ARRAY_BUFFER, geoset.SkinWeights, this.gl.STATIC_DRAW);
                this.tangentBuffer[i] = this.gl.createBuffer();
                this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.tangentBuffer[i]);
                this.gl.bufferData(this.gl.ARRAY_BUFFER, geoset.Tangents, this.gl.STATIC_DRAW);
            }
            else {
                if (!this.softwareSkinning) {
                    this.groupBuffer[i] = this.gl.createBuffer();
                    this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.groupBuffer[i]);
                    var buffer = new Uint16Array(geoset.VertexGroup.length * 4);
                    for (var j = 0; j < buffer.length; j += 4) {
                        var index = j / 4;
                        var group = geoset.Groups[geoset.VertexGroup[index]];
                        buffer[j] = group[0];
                        buffer[j + 1] = group.length > 1 ? group[1] : MAX_NODES;
                        buffer[j + 2] = group.length > 2 ? group[2] : MAX_NODES;
                        buffer[j + 3] = group.length > 3 ? group[3] : MAX_NODES;
                    }
                    this.gl.bufferData(this.gl.ARRAY_BUFFER, buffer, this.gl.STATIC_DRAW);
                }
            }
            this.indexBuffer[i] = this.gl.createBuffer();
            this.gl.bindBuffer(this.gl.ELEMENT_ARRAY_BUFFER, this.indexBuffer[i]);
            this.gl.bufferData(this.gl.ELEMENT_ARRAY_BUFFER, geoset.Faces, this.gl.STATIC_DRAW);
        }
    };
    ModelRenderer.prototype.initCube = function () {
        this.cubeVertexBuffer = this.gl.createBuffer();
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.cubeVertexBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, new Float32Array([
            -0.5, -0.5, -0.5,
            -0.5, 0.5, -0.5,
            0.5, -0.5, -0.5,
            -0.5, 0.5, -0.5,
            0.5, 0.5, -0.5,
            0.5, -0.5, -0.5,
            -0.5, -0.5, 0.5,
            0.5, -0.5, 0.5,
            -0.5, 0.5, 0.5,
            -0.5, 0.5, 0.5,
            0.5, -0.5, 0.5,
            0.5, 0.5, 0.5,
            -0.5, 0.5, -0.5,
            -0.5, 0.5, 0.5,
            0.5, 0.5, -0.5,
            -0.5, 0.5, 0.5,
            0.5, 0.5, 0.5,
            0.5, 0.5, -0.5,
            -0.5, -0.5, -0.5,
            0.5, -0.5, -0.5,
            -0.5, -0.5, 0.5,
            -0.5, -0.5, 0.5,
            0.5, -0.5, -0.5,
            0.5, -0.5, 0.5,
            -0.5, -0.5, -0.5,
            -0.5, -0.5, 0.5,
            -0.5, 0.5, -0.5,
            -0.5, -0.5, 0.5,
            -0.5, 0.5, 0.5,
            -0.5, 0.5, -0.5,
            0.5, -0.5, -0.5,
            0.5, 0.5, -0.5,
            0.5, -0.5, 0.5,
            0.5, -0.5, 0.5,
            0.5, 0.5, -0.5,
            0.5, 0.5, 0.5,
        ]), this.gl.STATIC_DRAW);
    };
    ModelRenderer.prototype.initSquare = function () {
        this.squareVertexBuffer = this.gl.createBuffer();
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.squareVertexBuffer);
        this.gl.bufferData(this.gl.ARRAY_BUFFER, new Float32Array([
            -1.0, -1.0,
            1.0, -1.0,
            -1.0, 1.0,
            1.0, -1.0,
            1.0, 1.0,
            -1.0, 1.0,
        ]), this.gl.STATIC_DRAW);
    };
    ModelRenderer.prototype.initBRDFLUT = function () {
        if (!isWebGL2(this.gl) || !this.isHD || !this.colorBufferFloatExt) {
            return;
        }
        this.brdfLUT = this.gl.createTexture();
        this.gl.activeTexture(this.gl.TEXTURE0);
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.brdfLUT);
        this.gl.texImage2D(this.gl.TEXTURE_2D, 0, this.gl.RG16F, BRDF_LUT_SIZE, BRDF_LUT_SIZE, 0, this.gl.RG, this.gl.FLOAT, null);
        this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_S, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_WRAP_T, this.gl.CLAMP_TO_EDGE);
        this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_MIN_FILTER, this.gl.LINEAR);
        this.gl.texParameteri(this.gl.TEXTURE_2D, this.gl.TEXTURE_MAG_FILTER, this.gl.LINEAR);
        var framebuffer = this.gl.createFramebuffer();
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, framebuffer);
        this.gl.framebufferTexture2D(this.gl.FRAMEBUFFER, this.gl.COLOR_ATTACHMENT0, this.gl.TEXTURE_2D, this.brdfLUT, 0);
        this.gl.useProgram(this.integrateBRDF.program);
        this.gl.viewport(0, 0, BRDF_LUT_SIZE, BRDF_LUT_SIZE);
        this.gl.clear(this.gl.COLOR_BUFFER_BIT | this.gl.DEPTH_BUFFER_BIT);
        this.gl.bindBuffer(this.gl.ARRAY_BUFFER, this.squareVertexBuffer);
        this.gl.enableVertexAttribArray(this.integrateBRDF.attributes.aPos);
        this.gl.vertexAttribPointer(this.integrateBRDF.attributes.aPos, 2, this.gl.FLOAT, false, 0, 0);
        this.gl.drawArrays(this.gl.TRIANGLES, 0, 6);
        this.gl.bindFramebuffer(this.gl.FRAMEBUFFER, null);
        this.gl.deleteFramebuffer(framebuffer);
    };
    /*private resetGlobalSequences (): void {
        for (let i = 0; i < this.rendererData.globalSequencesFrames.length; ++i) {
            this.rendererData.globalSequencesFrames[i] = 0;
        }
    }*/
    ModelRenderer.prototype.updateGlobalSequences = function (delta) {
        for (var i = 0; i < this.rendererData.globalSequencesFrames.length; ++i) {
            this.rendererData.globalSequencesFrames[i] += delta;
            if (this.rendererData.globalSequencesFrames[i] > this.model.GlobalSequences[i]) {
                this.rendererData.globalSequencesFrames[i] = 0;
            }
        }
    };
    ModelRenderer.prototype.updateNode = function (node) {
        var translationRes = this.interp.vec3(translation, node.node.Translation);
        var rotationRes = this.interp.quat(rotation, node.node.Rotation);
        var scalingRes = this.interp.vec3(scaling, node.node.Scaling);
        if (!translationRes && !rotationRes && !scalingRes) {
            mat4.identity(node.matrix);
        }
        else if (translationRes && !rotationRes && !scalingRes) {
            mat4.fromTranslation(node.matrix, translationRes);
        }
        else if (!translationRes && rotationRes && !scalingRes) {
            mat4fromRotationOrigin(node.matrix, rotationRes, node.node.PivotPoint);
        }
        else {
            mat4.fromRotationTranslationScaleOrigin(node.matrix, rotationRes || defaultRotation, translationRes || defaultTranslation, scalingRes || defaultScaling, node.node.PivotPoint);
        }
        if (node.node.Parent || node.node.Parent === 0) {
            mat4.mul(node.matrix, this.rendererData.nodes[node.node.Parent].matrix, node.matrix);
        }
        var billboardedLock = node.node.Flags & NodeFlags.BillboardedLockX ||
            node.node.Flags & NodeFlags.BillboardedLockY ||
            node.node.Flags & NodeFlags.BillboardedLockZ;
        if (node.node.Flags & NodeFlags.Billboarded) {
            vec3.transformMat4(tempTransformedPivotPoint, node.node.PivotPoint, node.matrix);
            if (node.node.Parent || node.node.Parent === 0) {
                // cancel parent rotation from PivotPoint
                mat4.getRotation(tempParentRotationQuat, this.rendererData.nodes[node.node.Parent].matrix);
                quat.invert(tempParentRotationQuat, tempParentRotationQuat);
                mat4fromRotationOrigin(tempParentRotationMat, tempParentRotationQuat, tempTransformedPivotPoint);
                mat4.mul(node.matrix, tempParentRotationMat, node.matrix);
            }
            // rotate to camera
            mat4fromRotationOrigin(tempCameraMat, this.rendererData.cameraQuat, tempTransformedPivotPoint);
            mat4.mul(node.matrix, tempCameraMat, node.matrix);
        }
        else if (billboardedLock) {
            vec3.transformMat4(tempTransformedPivotPoint, node.node.PivotPoint, node.matrix);
            vec3.copy(tempAxis, node.node.PivotPoint);
            // todo BillboardedLockX ?
            if (node.node.Flags & NodeFlags.BillboardedLockX) {
                tempAxis[0] += 1;
            }
            else if (node.node.Flags & NodeFlags.BillboardedLockY) {
                tempAxis[1] += 1;
            }
            else if (node.node.Flags & NodeFlags.BillboardedLockZ) {
                tempAxis[2] += 1;
            }
            vec3.transformMat4(tempAxis, tempAxis, node.matrix);
            vec3.sub(tempAxis, tempAxis, tempTransformedPivotPoint);
            vec3.set(tempXAxis, 1, 0, 0);
            vec3.add(tempXAxis, tempXAxis, node.node.PivotPoint);
            vec3.transformMat4(tempXAxis, tempXAxis, node.matrix);
            vec3.sub(tempXAxis, tempXAxis, tempTransformedPivotPoint);
            vec3.set(tempCameraVec, -1, 0, 0);
            vec3.transformQuat(tempCameraVec, tempCameraVec, this.rendererData.cameraQuat);
            vec3.cross(tempCross0, tempAxis, tempCameraVec);
            vec3.cross(tempCross1, tempAxis, tempCross0);
            vec3.normalize(tempCross1, tempCross1);
            quat.rotationTo(tempLockQuat, tempXAxis, tempCross1);
            mat4fromRotationOrigin(tempLockMat, tempLockQuat, tempTransformedPivotPoint);
            mat4.mul(node.matrix, tempLockMat, node.matrix);
        }
        for (var _i = 0, _a = node.childs; _i < _a.length; _i++) {
            var child = _a[_i];
            this.updateNode(child);
        }
    };
    ModelRenderer.prototype.findAlpha = function (geosetId) {
        var geosetAnim = this.rendererData.geosetAnims[geosetId];
        if (!geosetAnim || geosetAnim.Alpha === undefined) {
            return 1;
        }
        if (typeof geosetAnim.Alpha === 'number') {
            return geosetAnim.Alpha;
        }
        var interpRes = this.interp.num(geosetAnim.Alpha);
        if (interpRes === null) {
            return 1;
        }
        return interpRes;
    };
    ModelRenderer.prototype.setLayerProps = function (layer, textureID) {
        var texture = this.model.Textures[textureID];
        if (layer.Shading & LayerShading.TwoSided) {
            this.gl.disable(this.gl.CULL_FACE);
        }
        else {
            this.gl.enable(this.gl.CULL_FACE);
        }
        if (layer.FilterMode === FilterMode.Transparent) {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.75);
        }
        else {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.);
        }
        if (layer.FilterMode === FilterMode.None) {
            this.gl.disable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            // this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(true);
        }
        else if (layer.FilterMode === FilterMode.Transparent) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(true);
        }
        else if (layer.FilterMode === FilterMode.Blend) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.Additive) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_COLOR, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.AddAlpha) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.Modulate) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.ZERO, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (layer.FilterMode === FilterMode.Modulate2x) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.DST_COLOR, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        if (texture.Image) {
            this.gl.activeTexture(this.gl.TEXTURE0);
            this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[texture.Image]);
            this.gl.uniform1i(this.shaderProgramLocations.samplerUniform, 0);
            this.gl.uniform1f(this.shaderProgramLocations.replaceableTypeUniform, 0);
        }
        else if (texture.ReplaceableId === 1 || texture.ReplaceableId === 2) {
            this.gl.uniform3fv(this.shaderProgramLocations.replaceableColorUniform, this.rendererData.teamColor);
            this.gl.uniform1f(this.shaderProgramLocations.replaceableTypeUniform, texture.ReplaceableId);
        }
        if (layer.Shading & LayerShading.NoDepthTest) {
            this.gl.disable(this.gl.DEPTH_TEST);
        }
        if (layer.Shading & LayerShading.NoDepthSet) {
            this.gl.depthMask(false);
        }
        if (typeof layer.TVertexAnimId === 'number') {
            var anim = this.rendererData.model.TextureAnims[layer.TVertexAnimId];
            var translationRes = this.interp.vec3(translation, anim.Translation);
            var rotationRes = this.interp.quat(rotation, anim.Rotation);
            var scalingRes = this.interp.vec3(scaling, anim.Scaling);
            mat4.fromRotationTranslationScale(texCoordMat4, rotationRes || defaultRotation, translationRes || defaultTranslation, scalingRes || defaultScaling);
            mat3.set(texCoordMat3, texCoordMat4[0], texCoordMat4[1], 0, texCoordMat4[4], texCoordMat4[5], 0, texCoordMat4[12], texCoordMat4[13], 0);
            this.gl.uniformMatrix3fv(this.shaderProgramLocations.tVertexAnimUniform, false, texCoordMat3);
        }
        else {
            this.gl.uniformMatrix3fv(this.shaderProgramLocations.tVertexAnimUniform, false, identifyMat3);
        }
    };
    ModelRenderer.prototype.setLayerPropsHD = function (materialID, layers) {
        var baseLayer = layers[0];
        var textures = this.rendererData.materialLayerTextureID[materialID];
        var normalTextres = this.rendererData.materialLayerNormalTextureID[materialID];
        var ormTextres = this.rendererData.materialLayerOrmTextureID[materialID];
        var diffuseTextureID = textures[0];
        var diffuseTexture = this.model.Textures[diffuseTextureID];
        var normalTextureID = (baseLayer === null || baseLayer === void 0 ? void 0 : baseLayer.ShaderTypeId) === 1 ? normalTextres[0] : textures[1];
        var normalTexture = this.model.Textures[normalTextureID];
        var ormTextureID = (baseLayer === null || baseLayer === void 0 ? void 0 : baseLayer.ShaderTypeId) === 1 ? ormTextres[0] : textures[2];
        var ormTexture = this.model.Textures[ormTextureID];
        // const emissiveTextureID = textures[3];
        // const emissiveTexture = this.model.Textures[emissiveTextureID];
        // const teamColorTextureID = textures[4];
        // const teamColorTexture = this.model.Textures[teamColorTextureID];
        // const envTextureID = textures[5];
        // const envTexture = this.model.Textures[envTextureID];
        if (baseLayer.Shading & LayerShading.TwoSided) {
            this.gl.disable(this.gl.CULL_FACE);
        }
        else {
            this.gl.enable(this.gl.CULL_FACE);
        }
        if (baseLayer.FilterMode === FilterMode.Transparent) {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.75);
        }
        else {
            this.gl.uniform1f(this.shaderProgramLocations.discardAlphaLevelUniform, 0.);
        }
        if (baseLayer.FilterMode === FilterMode.None) {
            this.gl.disable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            // this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(true);
        }
        else if (baseLayer.FilterMode === FilterMode.Transparent) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(true);
        }
        else if (baseLayer.FilterMode === FilterMode.Blend) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA, this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
            this.gl.depthMask(false);
        }
        else if (baseLayer.FilterMode === FilterMode.Additive) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_COLOR, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (baseLayer.FilterMode === FilterMode.AddAlpha) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFunc(this.gl.SRC_ALPHA, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (baseLayer.FilterMode === FilterMode.Modulate) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.ZERO, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        else if (baseLayer.FilterMode === FilterMode.Modulate2x) {
            this.gl.enable(this.gl.BLEND);
            this.gl.enable(this.gl.DEPTH_TEST);
            this.gl.blendFuncSeparate(this.gl.DST_COLOR, this.gl.SRC_COLOR, this.gl.ZERO, this.gl.ONE);
            this.gl.depthMask(false);
        }
        this.gl.activeTexture(this.gl.TEXTURE0);
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[diffuseTexture.Image]);
        this.gl.uniform1i(this.shaderProgramLocations.samplerUniform, 0);
        if (baseLayer.Shading & LayerShading.NoDepthTest) {
            this.gl.disable(this.gl.DEPTH_TEST);
        }
        if (baseLayer.Shading & LayerShading.NoDepthSet) {
            this.gl.depthMask(false);
        }
        if (typeof baseLayer.TVertexAnimId === 'number') {
            var anim = this.rendererData.model.TextureAnims[baseLayer.TVertexAnimId];
            var translationRes = this.interp.vec3(translation, anim.Translation);
            var rotationRes = this.interp.quat(rotation, anim.Rotation);
            var scalingRes = this.interp.vec3(scaling, anim.Scaling);
            mat4.fromRotationTranslationScale(texCoordMat4, rotationRes || defaultRotation, translationRes || defaultTranslation, scalingRes || defaultScaling);
            mat3.set(texCoordMat3, texCoordMat4[0], texCoordMat4[1], 0, texCoordMat4[4], texCoordMat4[5], 0, texCoordMat4[12], texCoordMat4[13], 0);
            this.gl.uniformMatrix3fv(this.shaderProgramLocations.tVertexAnimUniform, false, texCoordMat3);
        }
        else {
            this.gl.uniformMatrix3fv(this.shaderProgramLocations.tVertexAnimUniform, false, identifyMat3);
        }
        this.gl.activeTexture(this.gl.TEXTURE1);
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[normalTexture.Image]);
        this.gl.uniform1i(this.shaderProgramLocations.normalSamplerUniform, 1);
        this.gl.activeTexture(this.gl.TEXTURE2);
        this.gl.bindTexture(this.gl.TEXTURE_2D, this.rendererData.textures[ormTexture.Image]);
        this.gl.uniform1i(this.shaderProgramLocations.ormSamplerUniform, 2);
        this.gl.uniform3fv(this.shaderProgramLocations.replaceableColorUniform, this.rendererData.teamColor);
    };
    return ModelRenderer;
}());

export { ModelRenderer, blpimage as blp, decode as decodeBLP, generate$1 as generateMDL, generate as generateMDX, getImageData as getBLPImageData, model, parse$1 as parseMDL, parse as parseMDX };
//# sourceMappingURL=war3-model.js.map
